import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { AcceptAddressTransferCommandInput, AcceptAddressTransferCommandOutput } from "../commands/AcceptAddressTransferCommand";
import { AcceptReservedInstancesExchangeQuoteCommandInput, AcceptReservedInstancesExchangeQuoteCommandOutput } from "../commands/AcceptReservedInstancesExchangeQuoteCommand";
import { AcceptTransitGatewayMulticastDomainAssociationsCommandInput, AcceptTransitGatewayMulticastDomainAssociationsCommandOutput } from "../commands/AcceptTransitGatewayMulticastDomainAssociationsCommand";
import { AcceptTransitGatewayPeeringAttachmentCommandInput, AcceptTransitGatewayPeeringAttachmentCommandOutput } from "../commands/AcceptTransitGatewayPeeringAttachmentCommand";
import { AcceptTransitGatewayVpcAttachmentCommandInput, AcceptTransitGatewayVpcAttachmentCommandOutput } from "../commands/AcceptTransitGatewayVpcAttachmentCommand";
import { AcceptVpcEndpointConnectionsCommandInput, AcceptVpcEndpointConnectionsCommandOutput } from "../commands/AcceptVpcEndpointConnectionsCommand";
import { AcceptVpcPeeringConnectionCommandInput, AcceptVpcPeeringConnectionCommandOutput } from "../commands/AcceptVpcPeeringConnectionCommand";
import { AdvertiseByoipCidrCommandInput, AdvertiseByoipCidrCommandOutput } from "../commands/AdvertiseByoipCidrCommand";
import { AllocateAddressCommandInput, AllocateAddressCommandOutput } from "../commands/AllocateAddressCommand";
import { AllocateHostsCommandInput, AllocateHostsCommandOutput } from "../commands/AllocateHostsCommand";
import { AllocateIpamPoolCidrCommandInput, AllocateIpamPoolCidrCommandOutput } from "../commands/AllocateIpamPoolCidrCommand";
import { ApplySecurityGroupsToClientVpnTargetNetworkCommandInput, ApplySecurityGroupsToClientVpnTargetNetworkCommandOutput } from "../commands/ApplySecurityGroupsToClientVpnTargetNetworkCommand";
import { AssignIpv6AddressesCommandInput, AssignIpv6AddressesCommandOutput } from "../commands/AssignIpv6AddressesCommand";
import { AssignPrivateIpAddressesCommandInput, AssignPrivateIpAddressesCommandOutput } from "../commands/AssignPrivateIpAddressesCommand";
import { AssignPrivateNatGatewayAddressCommandInput, AssignPrivateNatGatewayAddressCommandOutput } from "../commands/AssignPrivateNatGatewayAddressCommand";
import { AssociateAddressCommandInput, AssociateAddressCommandOutput } from "../commands/AssociateAddressCommand";
import { AssociateClientVpnTargetNetworkCommandInput, AssociateClientVpnTargetNetworkCommandOutput } from "../commands/AssociateClientVpnTargetNetworkCommand";
import { AssociateDhcpOptionsCommandInput, AssociateDhcpOptionsCommandOutput } from "../commands/AssociateDhcpOptionsCommand";
import { AssociateEnclaveCertificateIamRoleCommandInput, AssociateEnclaveCertificateIamRoleCommandOutput } from "../commands/AssociateEnclaveCertificateIamRoleCommand";
import { AssociateIamInstanceProfileCommandInput, AssociateIamInstanceProfileCommandOutput } from "../commands/AssociateIamInstanceProfileCommand";
import { AssociateInstanceEventWindowCommandInput, AssociateInstanceEventWindowCommandOutput } from "../commands/AssociateInstanceEventWindowCommand";
import { AssociateIpamByoasnCommandInput, AssociateIpamByoasnCommandOutput } from "../commands/AssociateIpamByoasnCommand";
import { AssociateIpamResourceDiscoveryCommandInput, AssociateIpamResourceDiscoveryCommandOutput } from "../commands/AssociateIpamResourceDiscoveryCommand";
import { AssociateNatGatewayAddressCommandInput, AssociateNatGatewayAddressCommandOutput } from "../commands/AssociateNatGatewayAddressCommand";
import { AssociateRouteTableCommandInput, AssociateRouteTableCommandOutput } from "../commands/AssociateRouteTableCommand";
import { AssociateSubnetCidrBlockCommandInput, AssociateSubnetCidrBlockCommandOutput } from "../commands/AssociateSubnetCidrBlockCommand";
import { AssociateTransitGatewayMulticastDomainCommandInput, AssociateTransitGatewayMulticastDomainCommandOutput } from "../commands/AssociateTransitGatewayMulticastDomainCommand";
import { AssociateTransitGatewayPolicyTableCommandInput, AssociateTransitGatewayPolicyTableCommandOutput } from "../commands/AssociateTransitGatewayPolicyTableCommand";
import { AssociateTransitGatewayRouteTableCommandInput, AssociateTransitGatewayRouteTableCommandOutput } from "../commands/AssociateTransitGatewayRouteTableCommand";
import { AssociateTrunkInterfaceCommandInput, AssociateTrunkInterfaceCommandOutput } from "../commands/AssociateTrunkInterfaceCommand";
import { AssociateVpcCidrBlockCommandInput, AssociateVpcCidrBlockCommandOutput } from "../commands/AssociateVpcCidrBlockCommand";
import { AttachClassicLinkVpcCommandInput, AttachClassicLinkVpcCommandOutput } from "../commands/AttachClassicLinkVpcCommand";
import { AttachInternetGatewayCommandInput, AttachInternetGatewayCommandOutput } from "../commands/AttachInternetGatewayCommand";
import { AttachNetworkInterfaceCommandInput, AttachNetworkInterfaceCommandOutput } from "../commands/AttachNetworkInterfaceCommand";
import { AttachVerifiedAccessTrustProviderCommandInput, AttachVerifiedAccessTrustProviderCommandOutput } from "../commands/AttachVerifiedAccessTrustProviderCommand";
import { AttachVolumeCommandInput, AttachVolumeCommandOutput } from "../commands/AttachVolumeCommand";
import { AttachVpnGatewayCommandInput, AttachVpnGatewayCommandOutput } from "../commands/AttachVpnGatewayCommand";
import { AuthorizeClientVpnIngressCommandInput, AuthorizeClientVpnIngressCommandOutput } from "../commands/AuthorizeClientVpnIngressCommand";
import { AuthorizeSecurityGroupEgressCommandInput, AuthorizeSecurityGroupEgressCommandOutput } from "../commands/AuthorizeSecurityGroupEgressCommand";
import { AuthorizeSecurityGroupIngressCommandInput, AuthorizeSecurityGroupIngressCommandOutput } from "../commands/AuthorizeSecurityGroupIngressCommand";
import { BundleInstanceCommandInput, BundleInstanceCommandOutput } from "../commands/BundleInstanceCommand";
import { CancelBundleTaskCommandInput, CancelBundleTaskCommandOutput } from "../commands/CancelBundleTaskCommand";
import { CancelCapacityReservationCommandInput, CancelCapacityReservationCommandOutput } from "../commands/CancelCapacityReservationCommand";
import { CancelCapacityReservationFleetsCommandInput, CancelCapacityReservationFleetsCommandOutput } from "../commands/CancelCapacityReservationFleetsCommand";
import { CancelConversionTaskCommandInput, CancelConversionTaskCommandOutput } from "../commands/CancelConversionTaskCommand";
import { CancelExportTaskCommandInput, CancelExportTaskCommandOutput } from "../commands/CancelExportTaskCommand";
import { CancelImageLaunchPermissionCommandInput, CancelImageLaunchPermissionCommandOutput } from "../commands/CancelImageLaunchPermissionCommand";
import { CancelImportTaskCommandInput, CancelImportTaskCommandOutput } from "../commands/CancelImportTaskCommand";
import { CancelReservedInstancesListingCommandInput, CancelReservedInstancesListingCommandOutput } from "../commands/CancelReservedInstancesListingCommand";
import { CancelSpotFleetRequestsCommandInput, CancelSpotFleetRequestsCommandOutput } from "../commands/CancelSpotFleetRequestsCommand";
import { CancelSpotInstanceRequestsCommandInput, CancelSpotInstanceRequestsCommandOutput } from "../commands/CancelSpotInstanceRequestsCommand";
import { ConfirmProductInstanceCommandInput, ConfirmProductInstanceCommandOutput } from "../commands/ConfirmProductInstanceCommand";
import { CopyFpgaImageCommandInput, CopyFpgaImageCommandOutput } from "../commands/CopyFpgaImageCommand";
import { CopyImageCommandInput, CopyImageCommandOutput } from "../commands/CopyImageCommand";
import { CopySnapshotCommandInput, CopySnapshotCommandOutput } from "../commands/CopySnapshotCommand";
import { CreateCapacityReservationCommandInput, CreateCapacityReservationCommandOutput } from "../commands/CreateCapacityReservationCommand";
import { CreateCapacityReservationFleetCommandInput, CreateCapacityReservationFleetCommandOutput } from "../commands/CreateCapacityReservationFleetCommand";
import { CreateCarrierGatewayCommandInput, CreateCarrierGatewayCommandOutput } from "../commands/CreateCarrierGatewayCommand";
import { CreateClientVpnEndpointCommandInput, CreateClientVpnEndpointCommandOutput } from "../commands/CreateClientVpnEndpointCommand";
import { CreateClientVpnRouteCommandInput, CreateClientVpnRouteCommandOutput } from "../commands/CreateClientVpnRouteCommand";
import { CreateCoipCidrCommandInput, CreateCoipCidrCommandOutput } from "../commands/CreateCoipCidrCommand";
import { CreateCoipPoolCommandInput, CreateCoipPoolCommandOutput } from "../commands/CreateCoipPoolCommand";
import { CreateCustomerGatewayCommandInput, CreateCustomerGatewayCommandOutput } from "../commands/CreateCustomerGatewayCommand";
import { CreateDefaultSubnetCommandInput, CreateDefaultSubnetCommandOutput } from "../commands/CreateDefaultSubnetCommand";
import { CreateDefaultVpcCommandInput, CreateDefaultVpcCommandOutput } from "../commands/CreateDefaultVpcCommand";
import { CreateDhcpOptionsCommandInput, CreateDhcpOptionsCommandOutput } from "../commands/CreateDhcpOptionsCommand";
import { CreateEgressOnlyInternetGatewayCommandInput, CreateEgressOnlyInternetGatewayCommandOutput } from "../commands/CreateEgressOnlyInternetGatewayCommand";
import { CreateFleetCommandInput, CreateFleetCommandOutput } from "../commands/CreateFleetCommand";
import { CreateFlowLogsCommandInput, CreateFlowLogsCommandOutput } from "../commands/CreateFlowLogsCommand";
import { CreateFpgaImageCommandInput, CreateFpgaImageCommandOutput } from "../commands/CreateFpgaImageCommand";
import { CreateImageCommandInput, CreateImageCommandOutput } from "../commands/CreateImageCommand";
import { CreateInstanceConnectEndpointCommandInput, CreateInstanceConnectEndpointCommandOutput } from "../commands/CreateInstanceConnectEndpointCommand";
import { CreateInstanceEventWindowCommandInput, CreateInstanceEventWindowCommandOutput } from "../commands/CreateInstanceEventWindowCommand";
import { CreateInstanceExportTaskCommandInput, CreateInstanceExportTaskCommandOutput } from "../commands/CreateInstanceExportTaskCommand";
import { CreateInternetGatewayCommandInput, CreateInternetGatewayCommandOutput } from "../commands/CreateInternetGatewayCommand";
import { CreateIpamCommandInput, CreateIpamCommandOutput } from "../commands/CreateIpamCommand";
import { CreateIpamPoolCommandInput, CreateIpamPoolCommandOutput } from "../commands/CreateIpamPoolCommand";
import { CreateIpamResourceDiscoveryCommandInput, CreateIpamResourceDiscoveryCommandOutput } from "../commands/CreateIpamResourceDiscoveryCommand";
import { CreateIpamScopeCommandInput, CreateIpamScopeCommandOutput } from "../commands/CreateIpamScopeCommand";
import { CreateKeyPairCommandInput, CreateKeyPairCommandOutput } from "../commands/CreateKeyPairCommand";
import { CreateLaunchTemplateCommandInput, CreateLaunchTemplateCommandOutput } from "../commands/CreateLaunchTemplateCommand";
import { CreateLaunchTemplateVersionCommandInput, CreateLaunchTemplateVersionCommandOutput } from "../commands/CreateLaunchTemplateVersionCommand";
import { CreateLocalGatewayRouteCommandInput, CreateLocalGatewayRouteCommandOutput } from "../commands/CreateLocalGatewayRouteCommand";
import { CreateLocalGatewayRouteTableCommandInput, CreateLocalGatewayRouteTableCommandOutput } from "../commands/CreateLocalGatewayRouteTableCommand";
import { CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommandInput, CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommandOutput } from "../commands/CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommand";
import { CreateLocalGatewayRouteTableVpcAssociationCommandInput, CreateLocalGatewayRouteTableVpcAssociationCommandOutput } from "../commands/CreateLocalGatewayRouteTableVpcAssociationCommand";
import { CreateManagedPrefixListCommandInput, CreateManagedPrefixListCommandOutput } from "../commands/CreateManagedPrefixListCommand";
import { CreateNatGatewayCommandInput, CreateNatGatewayCommandOutput } from "../commands/CreateNatGatewayCommand";
import { CreateNetworkAclCommandInput, CreateNetworkAclCommandOutput } from "../commands/CreateNetworkAclCommand";
import { CreateNetworkAclEntryCommandInput, CreateNetworkAclEntryCommandOutput } from "../commands/CreateNetworkAclEntryCommand";
import { CreateNetworkInsightsAccessScopeCommandInput, CreateNetworkInsightsAccessScopeCommandOutput } from "../commands/CreateNetworkInsightsAccessScopeCommand";
import { CreateNetworkInsightsPathCommandInput, CreateNetworkInsightsPathCommandOutput } from "../commands/CreateNetworkInsightsPathCommand";
import { CreateNetworkInterfaceCommandInput, CreateNetworkInterfaceCommandOutput } from "../commands/CreateNetworkInterfaceCommand";
import { CreateNetworkInterfacePermissionCommandInput, CreateNetworkInterfacePermissionCommandOutput } from "../commands/CreateNetworkInterfacePermissionCommand";
import { CreatePlacementGroupCommandInput, CreatePlacementGroupCommandOutput } from "../commands/CreatePlacementGroupCommand";
import { CreatePublicIpv4PoolCommandInput, CreatePublicIpv4PoolCommandOutput } from "../commands/CreatePublicIpv4PoolCommand";
import { CreateReplaceRootVolumeTaskCommandInput, CreateReplaceRootVolumeTaskCommandOutput } from "../commands/CreateReplaceRootVolumeTaskCommand";
import { CreateReservedInstancesListingCommandInput, CreateReservedInstancesListingCommandOutput } from "../commands/CreateReservedInstancesListingCommand";
import { CreateRestoreImageTaskCommandInput, CreateRestoreImageTaskCommandOutput } from "../commands/CreateRestoreImageTaskCommand";
import { CreateRouteCommandInput, CreateRouteCommandOutput } from "../commands/CreateRouteCommand";
import { CreateRouteTableCommandInput, CreateRouteTableCommandOutput } from "../commands/CreateRouteTableCommand";
import { CreateSecurityGroupCommandInput, CreateSecurityGroupCommandOutput } from "../commands/CreateSecurityGroupCommand";
import { CreateSnapshotCommandInput, CreateSnapshotCommandOutput } from "../commands/CreateSnapshotCommand";
import { CreateSnapshotsCommandInput, CreateSnapshotsCommandOutput } from "../commands/CreateSnapshotsCommand";
import { CreateSpotDatafeedSubscriptionCommandInput, CreateSpotDatafeedSubscriptionCommandOutput } from "../commands/CreateSpotDatafeedSubscriptionCommand";
import { CreateStoreImageTaskCommandInput, CreateStoreImageTaskCommandOutput } from "../commands/CreateStoreImageTaskCommand";
import { CreateSubnetCidrReservationCommandInput, CreateSubnetCidrReservationCommandOutput } from "../commands/CreateSubnetCidrReservationCommand";
import { CreateSubnetCommandInput, CreateSubnetCommandOutput } from "../commands/CreateSubnetCommand";
import { CreateTagsCommandInput, CreateTagsCommandOutput } from "../commands/CreateTagsCommand";
import { CreateTrafficMirrorFilterCommandInput, CreateTrafficMirrorFilterCommandOutput } from "../commands/CreateTrafficMirrorFilterCommand";
import { CreateTrafficMirrorFilterRuleCommandInput, CreateTrafficMirrorFilterRuleCommandOutput } from "../commands/CreateTrafficMirrorFilterRuleCommand";
import { CreateTrafficMirrorSessionCommandInput, CreateTrafficMirrorSessionCommandOutput } from "../commands/CreateTrafficMirrorSessionCommand";
import { CreateTrafficMirrorTargetCommandInput, CreateTrafficMirrorTargetCommandOutput } from "../commands/CreateTrafficMirrorTargetCommand";
import { CreateTransitGatewayCommandInput, CreateTransitGatewayCommandOutput } from "../commands/CreateTransitGatewayCommand";
import { CreateTransitGatewayConnectCommandInput, CreateTransitGatewayConnectCommandOutput } from "../commands/CreateTransitGatewayConnectCommand";
import { CreateTransitGatewayConnectPeerCommandInput, CreateTransitGatewayConnectPeerCommandOutput } from "../commands/CreateTransitGatewayConnectPeerCommand";
import { CreateTransitGatewayMulticastDomainCommandInput, CreateTransitGatewayMulticastDomainCommandOutput } from "../commands/CreateTransitGatewayMulticastDomainCommand";
import { CreateTransitGatewayPeeringAttachmentCommandInput, CreateTransitGatewayPeeringAttachmentCommandOutput } from "../commands/CreateTransitGatewayPeeringAttachmentCommand";
import { CreateTransitGatewayPolicyTableCommandInput, CreateTransitGatewayPolicyTableCommandOutput } from "../commands/CreateTransitGatewayPolicyTableCommand";
import { CreateTransitGatewayPrefixListReferenceCommandInput, CreateTransitGatewayPrefixListReferenceCommandOutput } from "../commands/CreateTransitGatewayPrefixListReferenceCommand";
import { CreateTransitGatewayRouteCommandInput, CreateTransitGatewayRouteCommandOutput } from "../commands/CreateTransitGatewayRouteCommand";
import { CreateTransitGatewayRouteTableAnnouncementCommandInput, CreateTransitGatewayRouteTableAnnouncementCommandOutput } from "../commands/CreateTransitGatewayRouteTableAnnouncementCommand";
import { CreateTransitGatewayRouteTableCommandInput, CreateTransitGatewayRouteTableCommandOutput } from "../commands/CreateTransitGatewayRouteTableCommand";
import { CreateTransitGatewayVpcAttachmentCommandInput, CreateTransitGatewayVpcAttachmentCommandOutput } from "../commands/CreateTransitGatewayVpcAttachmentCommand";
import { CreateVerifiedAccessEndpointCommandInput, CreateVerifiedAccessEndpointCommandOutput } from "../commands/CreateVerifiedAccessEndpointCommand";
import { CreateVerifiedAccessGroupCommandInput, CreateVerifiedAccessGroupCommandOutput } from "../commands/CreateVerifiedAccessGroupCommand";
import { CreateVerifiedAccessInstanceCommandInput, CreateVerifiedAccessInstanceCommandOutput } from "../commands/CreateVerifiedAccessInstanceCommand";
import { CreateVerifiedAccessTrustProviderCommandInput, CreateVerifiedAccessTrustProviderCommandOutput } from "../commands/CreateVerifiedAccessTrustProviderCommand";
import { CreateVolumeCommandInput, CreateVolumeCommandOutput } from "../commands/CreateVolumeCommand";
import { CreateVpcCommandInput, CreateVpcCommandOutput } from "../commands/CreateVpcCommand";
import { CreateVpcEndpointCommandInput, CreateVpcEndpointCommandOutput } from "../commands/CreateVpcEndpointCommand";
import { CreateVpcEndpointConnectionNotificationCommandInput, CreateVpcEndpointConnectionNotificationCommandOutput } from "../commands/CreateVpcEndpointConnectionNotificationCommand";
import { CreateVpcEndpointServiceConfigurationCommandInput, CreateVpcEndpointServiceConfigurationCommandOutput } from "../commands/CreateVpcEndpointServiceConfigurationCommand";
import { CreateVpcPeeringConnectionCommandInput, CreateVpcPeeringConnectionCommandOutput } from "../commands/CreateVpcPeeringConnectionCommand";
import { CreateVpnConnectionCommandInput, CreateVpnConnectionCommandOutput } from "../commands/CreateVpnConnectionCommand";
import { CreateVpnConnectionRouteCommandInput, CreateVpnConnectionRouteCommandOutput } from "../commands/CreateVpnConnectionRouteCommand";
import { CreateVpnGatewayCommandInput, CreateVpnGatewayCommandOutput } from "../commands/CreateVpnGatewayCommand";
import { DeleteCarrierGatewayCommandInput, DeleteCarrierGatewayCommandOutput } from "../commands/DeleteCarrierGatewayCommand";
import { DeleteClientVpnEndpointCommandInput, DeleteClientVpnEndpointCommandOutput } from "../commands/DeleteClientVpnEndpointCommand";
import { DeleteClientVpnRouteCommandInput, DeleteClientVpnRouteCommandOutput } from "../commands/DeleteClientVpnRouteCommand";
import { DeleteCoipCidrCommandInput, DeleteCoipCidrCommandOutput } from "../commands/DeleteCoipCidrCommand";
import { DeleteCoipPoolCommandInput, DeleteCoipPoolCommandOutput } from "../commands/DeleteCoipPoolCommand";
import { DeleteCustomerGatewayCommandInput, DeleteCustomerGatewayCommandOutput } from "../commands/DeleteCustomerGatewayCommand";
import { DeleteDhcpOptionsCommandInput, DeleteDhcpOptionsCommandOutput } from "../commands/DeleteDhcpOptionsCommand";
import { DeleteEgressOnlyInternetGatewayCommandInput, DeleteEgressOnlyInternetGatewayCommandOutput } from "../commands/DeleteEgressOnlyInternetGatewayCommand";
import { DeleteFleetsCommandInput, DeleteFleetsCommandOutput } from "../commands/DeleteFleetsCommand";
import { DeleteFlowLogsCommandInput, DeleteFlowLogsCommandOutput } from "../commands/DeleteFlowLogsCommand";
import { DeleteFpgaImageCommandInput, DeleteFpgaImageCommandOutput } from "../commands/DeleteFpgaImageCommand";
import { DeleteInstanceConnectEndpointCommandInput, DeleteInstanceConnectEndpointCommandOutput } from "../commands/DeleteInstanceConnectEndpointCommand";
import { DeleteInstanceEventWindowCommandInput, DeleteInstanceEventWindowCommandOutput } from "../commands/DeleteInstanceEventWindowCommand";
import { DeleteInternetGatewayCommandInput, DeleteInternetGatewayCommandOutput } from "../commands/DeleteInternetGatewayCommand";
import { DeleteIpamCommandInput, DeleteIpamCommandOutput } from "../commands/DeleteIpamCommand";
import { DeleteIpamPoolCommandInput, DeleteIpamPoolCommandOutput } from "../commands/DeleteIpamPoolCommand";
import { DeleteIpamResourceDiscoveryCommandInput, DeleteIpamResourceDiscoveryCommandOutput } from "../commands/DeleteIpamResourceDiscoveryCommand";
import { DeleteIpamScopeCommandInput, DeleteIpamScopeCommandOutput } from "../commands/DeleteIpamScopeCommand";
import { DeleteKeyPairCommandInput, DeleteKeyPairCommandOutput } from "../commands/DeleteKeyPairCommand";
import { DeleteLaunchTemplateCommandInput, DeleteLaunchTemplateCommandOutput } from "../commands/DeleteLaunchTemplateCommand";
import { DeleteLaunchTemplateVersionsCommandInput, DeleteLaunchTemplateVersionsCommandOutput } from "../commands/DeleteLaunchTemplateVersionsCommand";
import { DeleteLocalGatewayRouteCommandInput, DeleteLocalGatewayRouteCommandOutput } from "../commands/DeleteLocalGatewayRouteCommand";
import { DeleteLocalGatewayRouteTableCommandInput, DeleteLocalGatewayRouteTableCommandOutput } from "../commands/DeleteLocalGatewayRouteTableCommand";
import { DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommandInput, DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommandOutput } from "../commands/DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommand";
import { DeleteLocalGatewayRouteTableVpcAssociationCommandInput, DeleteLocalGatewayRouteTableVpcAssociationCommandOutput } from "../commands/DeleteLocalGatewayRouteTableVpcAssociationCommand";
import { DeleteManagedPrefixListCommandInput, DeleteManagedPrefixListCommandOutput } from "../commands/DeleteManagedPrefixListCommand";
import { DeleteNatGatewayCommandInput, DeleteNatGatewayCommandOutput } from "../commands/DeleteNatGatewayCommand";
import { DeleteNetworkAclCommandInput, DeleteNetworkAclCommandOutput } from "../commands/DeleteNetworkAclCommand";
import { DeleteNetworkAclEntryCommandInput, DeleteNetworkAclEntryCommandOutput } from "../commands/DeleteNetworkAclEntryCommand";
import { DeleteNetworkInsightsAccessScopeAnalysisCommandInput, DeleteNetworkInsightsAccessScopeAnalysisCommandOutput } from "../commands/DeleteNetworkInsightsAccessScopeAnalysisCommand";
import { DeleteNetworkInsightsAccessScopeCommandInput, DeleteNetworkInsightsAccessScopeCommandOutput } from "../commands/DeleteNetworkInsightsAccessScopeCommand";
import { DeleteNetworkInsightsAnalysisCommandInput, DeleteNetworkInsightsAnalysisCommandOutput } from "../commands/DeleteNetworkInsightsAnalysisCommand";
import { DeleteNetworkInsightsPathCommandInput, DeleteNetworkInsightsPathCommandOutput } from "../commands/DeleteNetworkInsightsPathCommand";
import { DeleteNetworkInterfaceCommandInput, DeleteNetworkInterfaceCommandOutput } from "../commands/DeleteNetworkInterfaceCommand";
import { DeleteNetworkInterfacePermissionCommandInput, DeleteNetworkInterfacePermissionCommandOutput } from "../commands/DeleteNetworkInterfacePermissionCommand";
import { DeletePlacementGroupCommandInput, DeletePlacementGroupCommandOutput } from "../commands/DeletePlacementGroupCommand";
import { DeletePublicIpv4PoolCommandInput, DeletePublicIpv4PoolCommandOutput } from "../commands/DeletePublicIpv4PoolCommand";
import { DeleteQueuedReservedInstancesCommandInput, DeleteQueuedReservedInstancesCommandOutput } from "../commands/DeleteQueuedReservedInstancesCommand";
import { DeleteRouteCommandInput, DeleteRouteCommandOutput } from "../commands/DeleteRouteCommand";
import { DeleteRouteTableCommandInput, DeleteRouteTableCommandOutput } from "../commands/DeleteRouteTableCommand";
import { DeleteSecurityGroupCommandInput, DeleteSecurityGroupCommandOutput } from "../commands/DeleteSecurityGroupCommand";
import { DeleteSnapshotCommandInput, DeleteSnapshotCommandOutput } from "../commands/DeleteSnapshotCommand";
import { DeleteSpotDatafeedSubscriptionCommandInput, DeleteSpotDatafeedSubscriptionCommandOutput } from "../commands/DeleteSpotDatafeedSubscriptionCommand";
import { DeleteSubnetCidrReservationCommandInput, DeleteSubnetCidrReservationCommandOutput } from "../commands/DeleteSubnetCidrReservationCommand";
import { DeleteSubnetCommandInput, DeleteSubnetCommandOutput } from "../commands/DeleteSubnetCommand";
import { DeleteTagsCommandInput, DeleteTagsCommandOutput } from "../commands/DeleteTagsCommand";
import { DeleteTrafficMirrorFilterCommandInput, DeleteTrafficMirrorFilterCommandOutput } from "../commands/DeleteTrafficMirrorFilterCommand";
import { DeleteTrafficMirrorFilterRuleCommandInput, DeleteTrafficMirrorFilterRuleCommandOutput } from "../commands/DeleteTrafficMirrorFilterRuleCommand";
import { DeleteTrafficMirrorSessionCommandInput, DeleteTrafficMirrorSessionCommandOutput } from "../commands/DeleteTrafficMirrorSessionCommand";
import { DeleteTrafficMirrorTargetCommandInput, DeleteTrafficMirrorTargetCommandOutput } from "../commands/DeleteTrafficMirrorTargetCommand";
import { DeleteTransitGatewayCommandInput, DeleteTransitGatewayCommandOutput } from "../commands/DeleteTransitGatewayCommand";
import { DeleteTransitGatewayConnectCommandInput, DeleteTransitGatewayConnectCommandOutput } from "../commands/DeleteTransitGatewayConnectCommand";
import { DeleteTransitGatewayConnectPeerCommandInput, DeleteTransitGatewayConnectPeerCommandOutput } from "../commands/DeleteTransitGatewayConnectPeerCommand";
import { DeleteTransitGatewayMulticastDomainCommandInput, DeleteTransitGatewayMulticastDomainCommandOutput } from "../commands/DeleteTransitGatewayMulticastDomainCommand";
import { DeleteTransitGatewayPeeringAttachmentCommandInput, DeleteTransitGatewayPeeringAttachmentCommandOutput } from "../commands/DeleteTransitGatewayPeeringAttachmentCommand";
import { DeleteTransitGatewayPolicyTableCommandInput, DeleteTransitGatewayPolicyTableCommandOutput } from "../commands/DeleteTransitGatewayPolicyTableCommand";
import { DeleteTransitGatewayPrefixListReferenceCommandInput, DeleteTransitGatewayPrefixListReferenceCommandOutput } from "../commands/DeleteTransitGatewayPrefixListReferenceCommand";
import { DeleteTransitGatewayRouteCommandInput, DeleteTransitGatewayRouteCommandOutput } from "../commands/DeleteTransitGatewayRouteCommand";
import { DeleteTransitGatewayRouteTableAnnouncementCommandInput, DeleteTransitGatewayRouteTableAnnouncementCommandOutput } from "../commands/DeleteTransitGatewayRouteTableAnnouncementCommand";
import { DeleteTransitGatewayRouteTableCommandInput, DeleteTransitGatewayRouteTableCommandOutput } from "../commands/DeleteTransitGatewayRouteTableCommand";
import { DeleteTransitGatewayVpcAttachmentCommandInput, DeleteTransitGatewayVpcAttachmentCommandOutput } from "../commands/DeleteTransitGatewayVpcAttachmentCommand";
import { DeleteVerifiedAccessEndpointCommandInput, DeleteVerifiedAccessEndpointCommandOutput } from "../commands/DeleteVerifiedAccessEndpointCommand";
import { DeleteVerifiedAccessGroupCommandInput, DeleteVerifiedAccessGroupCommandOutput } from "../commands/DeleteVerifiedAccessGroupCommand";
import { DeleteVerifiedAccessInstanceCommandInput, DeleteVerifiedAccessInstanceCommandOutput } from "../commands/DeleteVerifiedAccessInstanceCommand";
import { DeleteVerifiedAccessTrustProviderCommandInput, DeleteVerifiedAccessTrustProviderCommandOutput } from "../commands/DeleteVerifiedAccessTrustProviderCommand";
import { DeleteVolumeCommandInput, DeleteVolumeCommandOutput } from "../commands/DeleteVolumeCommand";
import { DeleteVpcCommandInput, DeleteVpcCommandOutput } from "../commands/DeleteVpcCommand";
import { DeleteVpcEndpointConnectionNotificationsCommandInput, DeleteVpcEndpointConnectionNotificationsCommandOutput } from "../commands/DeleteVpcEndpointConnectionNotificationsCommand";
import { DeleteVpcEndpointsCommandInput, DeleteVpcEndpointsCommandOutput } from "../commands/DeleteVpcEndpointsCommand";
import { DeleteVpcEndpointServiceConfigurationsCommandInput, DeleteVpcEndpointServiceConfigurationsCommandOutput } from "../commands/DeleteVpcEndpointServiceConfigurationsCommand";
import { DeleteVpcPeeringConnectionCommandInput, DeleteVpcPeeringConnectionCommandOutput } from "../commands/DeleteVpcPeeringConnectionCommand";
import { DeleteVpnConnectionCommandInput, DeleteVpnConnectionCommandOutput } from "../commands/DeleteVpnConnectionCommand";
import { DeleteVpnConnectionRouteCommandInput, DeleteVpnConnectionRouteCommandOutput } from "../commands/DeleteVpnConnectionRouteCommand";
import { DeleteVpnGatewayCommandInput, DeleteVpnGatewayCommandOutput } from "../commands/DeleteVpnGatewayCommand";
import { DeprovisionByoipCidrCommandInput, DeprovisionByoipCidrCommandOutput } from "../commands/DeprovisionByoipCidrCommand";
import { DeprovisionIpamByoasnCommandInput, DeprovisionIpamByoasnCommandOutput } from "../commands/DeprovisionIpamByoasnCommand";
import { DeprovisionIpamPoolCidrCommandInput, DeprovisionIpamPoolCidrCommandOutput } from "../commands/DeprovisionIpamPoolCidrCommand";
import { DeprovisionPublicIpv4PoolCidrCommandInput, DeprovisionPublicIpv4PoolCidrCommandOutput } from "../commands/DeprovisionPublicIpv4PoolCidrCommand";
import { DeregisterImageCommandInput, DeregisterImageCommandOutput } from "../commands/DeregisterImageCommand";
import { DeregisterInstanceEventNotificationAttributesCommandInput, DeregisterInstanceEventNotificationAttributesCommandOutput } from "../commands/DeregisterInstanceEventNotificationAttributesCommand";
import { DeregisterTransitGatewayMulticastGroupMembersCommandInput, DeregisterTransitGatewayMulticastGroupMembersCommandOutput } from "../commands/DeregisterTransitGatewayMulticastGroupMembersCommand";
import { DeregisterTransitGatewayMulticastGroupSourcesCommandInput, DeregisterTransitGatewayMulticastGroupSourcesCommandOutput } from "../commands/DeregisterTransitGatewayMulticastGroupSourcesCommand";
import { DescribeAccountAttributesCommandInput, DescribeAccountAttributesCommandOutput } from "../commands/DescribeAccountAttributesCommand";
import { DescribeAddressesAttributeCommandInput, DescribeAddressesAttributeCommandOutput } from "../commands/DescribeAddressesAttributeCommand";
import { DescribeAddressesCommandInput, DescribeAddressesCommandOutput } from "../commands/DescribeAddressesCommand";
import { DescribeAddressTransfersCommandInput, DescribeAddressTransfersCommandOutput } from "../commands/DescribeAddressTransfersCommand";
import { DescribeAggregateIdFormatCommandInput, DescribeAggregateIdFormatCommandOutput } from "../commands/DescribeAggregateIdFormatCommand";
import { DescribeAvailabilityZonesCommandInput, DescribeAvailabilityZonesCommandOutput } from "../commands/DescribeAvailabilityZonesCommand";
import { DescribeAwsNetworkPerformanceMetricSubscriptionsCommandInput, DescribeAwsNetworkPerformanceMetricSubscriptionsCommandOutput } from "../commands/DescribeAwsNetworkPerformanceMetricSubscriptionsCommand";
import { DescribeBundleTasksCommandInput, DescribeBundleTasksCommandOutput } from "../commands/DescribeBundleTasksCommand";
import { DescribeByoipCidrsCommandInput, DescribeByoipCidrsCommandOutput } from "../commands/DescribeByoipCidrsCommand";
import { DescribeCapacityBlockOfferingsCommandInput, DescribeCapacityBlockOfferingsCommandOutput } from "../commands/DescribeCapacityBlockOfferingsCommand";
import { DescribeCapacityReservationFleetsCommandInput, DescribeCapacityReservationFleetsCommandOutput } from "../commands/DescribeCapacityReservationFleetsCommand";
import { DescribeCapacityReservationsCommandInput, DescribeCapacityReservationsCommandOutput } from "../commands/DescribeCapacityReservationsCommand";
import { DescribeCarrierGatewaysCommandInput, DescribeCarrierGatewaysCommandOutput } from "../commands/DescribeCarrierGatewaysCommand";
import { DescribeClassicLinkInstancesCommandInput, DescribeClassicLinkInstancesCommandOutput } from "../commands/DescribeClassicLinkInstancesCommand";
import { DescribeClientVpnAuthorizationRulesCommandInput, DescribeClientVpnAuthorizationRulesCommandOutput } from "../commands/DescribeClientVpnAuthorizationRulesCommand";
import { DescribeClientVpnConnectionsCommandInput, DescribeClientVpnConnectionsCommandOutput } from "../commands/DescribeClientVpnConnectionsCommand";
import { DescribeClientVpnEndpointsCommandInput, DescribeClientVpnEndpointsCommandOutput } from "../commands/DescribeClientVpnEndpointsCommand";
import { DescribeClientVpnRoutesCommandInput, DescribeClientVpnRoutesCommandOutput } from "../commands/DescribeClientVpnRoutesCommand";
import { DescribeClientVpnTargetNetworksCommandInput, DescribeClientVpnTargetNetworksCommandOutput } from "../commands/DescribeClientVpnTargetNetworksCommand";
import { DescribeCoipPoolsCommandInput, DescribeCoipPoolsCommandOutput } from "../commands/DescribeCoipPoolsCommand";
import { DescribeConversionTasksCommandInput, DescribeConversionTasksCommandOutput } from "../commands/DescribeConversionTasksCommand";
import { DescribeCustomerGatewaysCommandInput, DescribeCustomerGatewaysCommandOutput } from "../commands/DescribeCustomerGatewaysCommand";
import { DescribeDhcpOptionsCommandInput, DescribeDhcpOptionsCommandOutput } from "../commands/DescribeDhcpOptionsCommand";
import { DescribeEgressOnlyInternetGatewaysCommandInput, DescribeEgressOnlyInternetGatewaysCommandOutput } from "../commands/DescribeEgressOnlyInternetGatewaysCommand";
import { DescribeElasticGpusCommandInput, DescribeElasticGpusCommandOutput } from "../commands/DescribeElasticGpusCommand";
import { DescribeExportImageTasksCommandInput, DescribeExportImageTasksCommandOutput } from "../commands/DescribeExportImageTasksCommand";
import { DescribeExportTasksCommandInput, DescribeExportTasksCommandOutput } from "../commands/DescribeExportTasksCommand";
import { DescribeFastLaunchImagesCommandInput, DescribeFastLaunchImagesCommandOutput } from "../commands/DescribeFastLaunchImagesCommand";
import { DescribeFastSnapshotRestoresCommandInput, DescribeFastSnapshotRestoresCommandOutput } from "../commands/DescribeFastSnapshotRestoresCommand";
import { DescribeFleetHistoryCommandInput, DescribeFleetHistoryCommandOutput } from "../commands/DescribeFleetHistoryCommand";
import { DescribeFleetInstancesCommandInput, DescribeFleetInstancesCommandOutput } from "../commands/DescribeFleetInstancesCommand";
import { DescribeFleetsCommandInput, DescribeFleetsCommandOutput } from "../commands/DescribeFleetsCommand";
import { DescribeFlowLogsCommandInput, DescribeFlowLogsCommandOutput } from "../commands/DescribeFlowLogsCommand";
import { DescribeFpgaImageAttributeCommandInput, DescribeFpgaImageAttributeCommandOutput } from "../commands/DescribeFpgaImageAttributeCommand";
import { DescribeFpgaImagesCommandInput, DescribeFpgaImagesCommandOutput } from "../commands/DescribeFpgaImagesCommand";
import { DescribeHostReservationOfferingsCommandInput, DescribeHostReservationOfferingsCommandOutput } from "../commands/DescribeHostReservationOfferingsCommand";
import { DescribeHostReservationsCommandInput, DescribeHostReservationsCommandOutput } from "../commands/DescribeHostReservationsCommand";
import { DescribeHostsCommandInput, DescribeHostsCommandOutput } from "../commands/DescribeHostsCommand";
import { DescribeIamInstanceProfileAssociationsCommandInput, DescribeIamInstanceProfileAssociationsCommandOutput } from "../commands/DescribeIamInstanceProfileAssociationsCommand";
import { DescribeIdentityIdFormatCommandInput, DescribeIdentityIdFormatCommandOutput } from "../commands/DescribeIdentityIdFormatCommand";
import { DescribeIdFormatCommandInput, DescribeIdFormatCommandOutput } from "../commands/DescribeIdFormatCommand";
import { DescribeImageAttributeCommandInput, DescribeImageAttributeCommandOutput } from "../commands/DescribeImageAttributeCommand";
import { DescribeImagesCommandInput, DescribeImagesCommandOutput } from "../commands/DescribeImagesCommand";
import { DescribeImportImageTasksCommandInput, DescribeImportImageTasksCommandOutput } from "../commands/DescribeImportImageTasksCommand";
import { DescribeImportSnapshotTasksCommandInput, DescribeImportSnapshotTasksCommandOutput } from "../commands/DescribeImportSnapshotTasksCommand";
import { DescribeInstanceAttributeCommandInput, DescribeInstanceAttributeCommandOutput } from "../commands/DescribeInstanceAttributeCommand";
import { DescribeInstanceConnectEndpointsCommandInput, DescribeInstanceConnectEndpointsCommandOutput } from "../commands/DescribeInstanceConnectEndpointsCommand";
import { DescribeInstanceCreditSpecificationsCommandInput, DescribeInstanceCreditSpecificationsCommandOutput } from "../commands/DescribeInstanceCreditSpecificationsCommand";
import { DescribeInstanceEventNotificationAttributesCommandInput, DescribeInstanceEventNotificationAttributesCommandOutput } from "../commands/DescribeInstanceEventNotificationAttributesCommand";
import { DescribeInstanceEventWindowsCommandInput, DescribeInstanceEventWindowsCommandOutput } from "../commands/DescribeInstanceEventWindowsCommand";
import { DescribeInstancesCommandInput, DescribeInstancesCommandOutput } from "../commands/DescribeInstancesCommand";
import { DescribeInstanceStatusCommandInput, DescribeInstanceStatusCommandOutput } from "../commands/DescribeInstanceStatusCommand";
import { DescribeInstanceTopologyCommandInput, DescribeInstanceTopologyCommandOutput } from "../commands/DescribeInstanceTopologyCommand";
import { DescribeInstanceTypeOfferingsCommandInput, DescribeInstanceTypeOfferingsCommandOutput } from "../commands/DescribeInstanceTypeOfferingsCommand";
import { DescribeInstanceTypesCommandInput, DescribeInstanceTypesCommandOutput } from "../commands/DescribeInstanceTypesCommand";
import { DescribeInternetGatewaysCommandInput, DescribeInternetGatewaysCommandOutput } from "../commands/DescribeInternetGatewaysCommand";
import { DescribeIpamByoasnCommandInput, DescribeIpamByoasnCommandOutput } from "../commands/DescribeIpamByoasnCommand";
import { DescribeIpamPoolsCommandInput, DescribeIpamPoolsCommandOutput } from "../commands/DescribeIpamPoolsCommand";
import { DescribeIpamResourceDiscoveriesCommandInput, DescribeIpamResourceDiscoveriesCommandOutput } from "../commands/DescribeIpamResourceDiscoveriesCommand";
import { DescribeIpamResourceDiscoveryAssociationsCommandInput, DescribeIpamResourceDiscoveryAssociationsCommandOutput } from "../commands/DescribeIpamResourceDiscoveryAssociationsCommand";
import { DescribeIpamsCommandInput, DescribeIpamsCommandOutput } from "../commands/DescribeIpamsCommand";
import { DescribeIpamScopesCommandInput, DescribeIpamScopesCommandOutput } from "../commands/DescribeIpamScopesCommand";
import { DescribeIpv6PoolsCommandInput, DescribeIpv6PoolsCommandOutput } from "../commands/DescribeIpv6PoolsCommand";
import { DescribeKeyPairsCommandInput, DescribeKeyPairsCommandOutput } from "../commands/DescribeKeyPairsCommand";
import { DescribeLaunchTemplatesCommandInput, DescribeLaunchTemplatesCommandOutput } from "../commands/DescribeLaunchTemplatesCommand";
import { DescribeLaunchTemplateVersionsCommandInput, DescribeLaunchTemplateVersionsCommandOutput } from "../commands/DescribeLaunchTemplateVersionsCommand";
import { DescribeLocalGatewayRouteTablesCommandInput, DescribeLocalGatewayRouteTablesCommandOutput } from "../commands/DescribeLocalGatewayRouteTablesCommand";
import { DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsCommandInput, DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsCommandOutput } from "../commands/DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsCommand";
import { DescribeLocalGatewayRouteTableVpcAssociationsCommandInput, DescribeLocalGatewayRouteTableVpcAssociationsCommandOutput } from "../commands/DescribeLocalGatewayRouteTableVpcAssociationsCommand";
import { DescribeLocalGatewaysCommandInput, DescribeLocalGatewaysCommandOutput } from "../commands/DescribeLocalGatewaysCommand";
import { DescribeLocalGatewayVirtualInterfaceGroupsCommandInput, DescribeLocalGatewayVirtualInterfaceGroupsCommandOutput } from "../commands/DescribeLocalGatewayVirtualInterfaceGroupsCommand";
import { DescribeLocalGatewayVirtualInterfacesCommandInput, DescribeLocalGatewayVirtualInterfacesCommandOutput } from "../commands/DescribeLocalGatewayVirtualInterfacesCommand";
import { DescribeLockedSnapshotsCommandInput, DescribeLockedSnapshotsCommandOutput } from "../commands/DescribeLockedSnapshotsCommand";
import { DescribeMacHostsCommandInput, DescribeMacHostsCommandOutput } from "../commands/DescribeMacHostsCommand";
import { DescribeManagedPrefixListsCommandInput, DescribeManagedPrefixListsCommandOutput } from "../commands/DescribeManagedPrefixListsCommand";
import { DescribeMovingAddressesCommandInput, DescribeMovingAddressesCommandOutput } from "../commands/DescribeMovingAddressesCommand";
import { DescribeNatGatewaysCommandInput, DescribeNatGatewaysCommandOutput } from "../commands/DescribeNatGatewaysCommand";
import { DescribeNetworkAclsCommandInput, DescribeNetworkAclsCommandOutput } from "../commands/DescribeNetworkAclsCommand";
import { DescribeNetworkInsightsAccessScopeAnalysesCommandInput, DescribeNetworkInsightsAccessScopeAnalysesCommandOutput } from "../commands/DescribeNetworkInsightsAccessScopeAnalysesCommand";
import { DescribeNetworkInsightsAccessScopesCommandInput, DescribeNetworkInsightsAccessScopesCommandOutput } from "../commands/DescribeNetworkInsightsAccessScopesCommand";
import { DescribeNetworkInsightsAnalysesCommandInput, DescribeNetworkInsightsAnalysesCommandOutput } from "../commands/DescribeNetworkInsightsAnalysesCommand";
import { DescribeNetworkInsightsPathsCommandInput, DescribeNetworkInsightsPathsCommandOutput } from "../commands/DescribeNetworkInsightsPathsCommand";
import { DescribeNetworkInterfaceAttributeCommandInput, DescribeNetworkInterfaceAttributeCommandOutput } from "../commands/DescribeNetworkInterfaceAttributeCommand";
import { DescribeNetworkInterfacePermissionsCommandInput, DescribeNetworkInterfacePermissionsCommandOutput } from "../commands/DescribeNetworkInterfacePermissionsCommand";
import { DescribeNetworkInterfacesCommandInput, DescribeNetworkInterfacesCommandOutput } from "../commands/DescribeNetworkInterfacesCommand";
import { DescribePlacementGroupsCommandInput, DescribePlacementGroupsCommandOutput } from "../commands/DescribePlacementGroupsCommand";
import { DescribePrefixListsCommandInput, DescribePrefixListsCommandOutput } from "../commands/DescribePrefixListsCommand";
import { DescribePrincipalIdFormatCommandInput, DescribePrincipalIdFormatCommandOutput } from "../commands/DescribePrincipalIdFormatCommand";
import { DescribePublicIpv4PoolsCommandInput, DescribePublicIpv4PoolsCommandOutput } from "../commands/DescribePublicIpv4PoolsCommand";
import { DescribeRegionsCommandInput, DescribeRegionsCommandOutput } from "../commands/DescribeRegionsCommand";
import { DescribeReplaceRootVolumeTasksCommandInput, DescribeReplaceRootVolumeTasksCommandOutput } from "../commands/DescribeReplaceRootVolumeTasksCommand";
import { DescribeReservedInstancesCommandInput, DescribeReservedInstancesCommandOutput } from "../commands/DescribeReservedInstancesCommand";
import { DescribeReservedInstancesListingsCommandInput, DescribeReservedInstancesListingsCommandOutput } from "../commands/DescribeReservedInstancesListingsCommand";
import { DescribeReservedInstancesModificationsCommandInput, DescribeReservedInstancesModificationsCommandOutput } from "../commands/DescribeReservedInstancesModificationsCommand";
import { DescribeReservedInstancesOfferingsCommandInput, DescribeReservedInstancesOfferingsCommandOutput } from "../commands/DescribeReservedInstancesOfferingsCommand";
import { DescribeRouteTablesCommandInput, DescribeRouteTablesCommandOutput } from "../commands/DescribeRouteTablesCommand";
import { DescribeScheduledInstanceAvailabilityCommandInput, DescribeScheduledInstanceAvailabilityCommandOutput } from "../commands/DescribeScheduledInstanceAvailabilityCommand";
import { DescribeScheduledInstancesCommandInput, DescribeScheduledInstancesCommandOutput } from "../commands/DescribeScheduledInstancesCommand";
import { DescribeSecurityGroupReferencesCommandInput, DescribeSecurityGroupReferencesCommandOutput } from "../commands/DescribeSecurityGroupReferencesCommand";
import { DescribeSecurityGroupRulesCommandInput, DescribeSecurityGroupRulesCommandOutput } from "../commands/DescribeSecurityGroupRulesCommand";
import { DescribeSecurityGroupsCommandInput, DescribeSecurityGroupsCommandOutput } from "../commands/DescribeSecurityGroupsCommand";
import { DescribeSnapshotAttributeCommandInput, DescribeSnapshotAttributeCommandOutput } from "../commands/DescribeSnapshotAttributeCommand";
import { DescribeSnapshotsCommandInput, DescribeSnapshotsCommandOutput } from "../commands/DescribeSnapshotsCommand";
import { DescribeSnapshotTierStatusCommandInput, DescribeSnapshotTierStatusCommandOutput } from "../commands/DescribeSnapshotTierStatusCommand";
import { DescribeSpotDatafeedSubscriptionCommandInput, DescribeSpotDatafeedSubscriptionCommandOutput } from "../commands/DescribeSpotDatafeedSubscriptionCommand";
import { DescribeSpotFleetInstancesCommandInput, DescribeSpotFleetInstancesCommandOutput } from "../commands/DescribeSpotFleetInstancesCommand";
import { DescribeSpotFleetRequestHistoryCommandInput, DescribeSpotFleetRequestHistoryCommandOutput } from "../commands/DescribeSpotFleetRequestHistoryCommand";
import { DescribeSpotFleetRequestsCommandInput, DescribeSpotFleetRequestsCommandOutput } from "../commands/DescribeSpotFleetRequestsCommand";
import { DescribeSpotInstanceRequestsCommandInput, DescribeSpotInstanceRequestsCommandOutput } from "../commands/DescribeSpotInstanceRequestsCommand";
import { DescribeSpotPriceHistoryCommandInput, DescribeSpotPriceHistoryCommandOutput } from "../commands/DescribeSpotPriceHistoryCommand";
import { DescribeStaleSecurityGroupsCommandInput, DescribeStaleSecurityGroupsCommandOutput } from "../commands/DescribeStaleSecurityGroupsCommand";
import { DescribeStoreImageTasksCommandInput, DescribeStoreImageTasksCommandOutput } from "../commands/DescribeStoreImageTasksCommand";
import { DescribeSubnetsCommandInput, DescribeSubnetsCommandOutput } from "../commands/DescribeSubnetsCommand";
import { DescribeTagsCommandInput, DescribeTagsCommandOutput } from "../commands/DescribeTagsCommand";
import { DescribeTrafficMirrorFiltersCommandInput, DescribeTrafficMirrorFiltersCommandOutput } from "../commands/DescribeTrafficMirrorFiltersCommand";
import { DescribeTrafficMirrorSessionsCommandInput, DescribeTrafficMirrorSessionsCommandOutput } from "../commands/DescribeTrafficMirrorSessionsCommand";
import { DescribeTrafficMirrorTargetsCommandInput, DescribeTrafficMirrorTargetsCommandOutput } from "../commands/DescribeTrafficMirrorTargetsCommand";
import { DescribeTransitGatewayAttachmentsCommandInput, DescribeTransitGatewayAttachmentsCommandOutput } from "../commands/DescribeTransitGatewayAttachmentsCommand";
import { DescribeTransitGatewayConnectPeersCommandInput, DescribeTransitGatewayConnectPeersCommandOutput } from "../commands/DescribeTransitGatewayConnectPeersCommand";
import { DescribeTransitGatewayConnectsCommandInput, DescribeTransitGatewayConnectsCommandOutput } from "../commands/DescribeTransitGatewayConnectsCommand";
import { DescribeTransitGatewayMulticastDomainsCommandInput, DescribeTransitGatewayMulticastDomainsCommandOutput } from "../commands/DescribeTransitGatewayMulticastDomainsCommand";
import { DescribeTransitGatewayPeeringAttachmentsCommandInput, DescribeTransitGatewayPeeringAttachmentsCommandOutput } from "../commands/DescribeTransitGatewayPeeringAttachmentsCommand";
import { DescribeTransitGatewayPolicyTablesCommandInput, DescribeTransitGatewayPolicyTablesCommandOutput } from "../commands/DescribeTransitGatewayPolicyTablesCommand";
import { DescribeTransitGatewayRouteTableAnnouncementsCommandInput, DescribeTransitGatewayRouteTableAnnouncementsCommandOutput } from "../commands/DescribeTransitGatewayRouteTableAnnouncementsCommand";
import { DescribeTransitGatewayRouteTablesCommandInput, DescribeTransitGatewayRouteTablesCommandOutput } from "../commands/DescribeTransitGatewayRouteTablesCommand";
import { DescribeTransitGatewaysCommandInput, DescribeTransitGatewaysCommandOutput } from "../commands/DescribeTransitGatewaysCommand";
import { DescribeTransitGatewayVpcAttachmentsCommandInput, DescribeTransitGatewayVpcAttachmentsCommandOutput } from "../commands/DescribeTransitGatewayVpcAttachmentsCommand";
import { DescribeTrunkInterfaceAssociationsCommandInput, DescribeTrunkInterfaceAssociationsCommandOutput } from "../commands/DescribeTrunkInterfaceAssociationsCommand";
import { DescribeVerifiedAccessEndpointsCommandInput, DescribeVerifiedAccessEndpointsCommandOutput } from "../commands/DescribeVerifiedAccessEndpointsCommand";
import { DescribeVerifiedAccessGroupsCommandInput, DescribeVerifiedAccessGroupsCommandOutput } from "../commands/DescribeVerifiedAccessGroupsCommand";
import { DescribeVerifiedAccessInstanceLoggingConfigurationsCommandInput, DescribeVerifiedAccessInstanceLoggingConfigurationsCommandOutput } from "../commands/DescribeVerifiedAccessInstanceLoggingConfigurationsCommand";
import { DescribeVerifiedAccessInstancesCommandInput, DescribeVerifiedAccessInstancesCommandOutput } from "../commands/DescribeVerifiedAccessInstancesCommand";
import { DescribeVerifiedAccessTrustProvidersCommandInput, DescribeVerifiedAccessTrustProvidersCommandOutput } from "../commands/DescribeVerifiedAccessTrustProvidersCommand";
import { DescribeVolumeAttributeCommandInput, DescribeVolumeAttributeCommandOutput } from "../commands/DescribeVolumeAttributeCommand";
import { DescribeVolumesCommandInput, DescribeVolumesCommandOutput } from "../commands/DescribeVolumesCommand";
import { DescribeVolumesModificationsCommandInput, DescribeVolumesModificationsCommandOutput } from "../commands/DescribeVolumesModificationsCommand";
import { DescribeVolumeStatusCommandInput, DescribeVolumeStatusCommandOutput } from "../commands/DescribeVolumeStatusCommand";
import { DescribeVpcAttributeCommandInput, DescribeVpcAttributeCommandOutput } from "../commands/DescribeVpcAttributeCommand";
import { DescribeVpcClassicLinkCommandInput, DescribeVpcClassicLinkCommandOutput } from "../commands/DescribeVpcClassicLinkCommand";
import { DescribeVpcClassicLinkDnsSupportCommandInput, DescribeVpcClassicLinkDnsSupportCommandOutput } from "../commands/DescribeVpcClassicLinkDnsSupportCommand";
import { DescribeVpcEndpointConnectionNotificationsCommandInput, DescribeVpcEndpointConnectionNotificationsCommandOutput } from "../commands/DescribeVpcEndpointConnectionNotificationsCommand";
import { DescribeVpcEndpointConnectionsCommandInput, DescribeVpcEndpointConnectionsCommandOutput } from "../commands/DescribeVpcEndpointConnectionsCommand";
import { DescribeVpcEndpointsCommandInput, DescribeVpcEndpointsCommandOutput } from "../commands/DescribeVpcEndpointsCommand";
import { DescribeVpcEndpointServiceConfigurationsCommandInput, DescribeVpcEndpointServiceConfigurationsCommandOutput } from "../commands/DescribeVpcEndpointServiceConfigurationsCommand";
import { DescribeVpcEndpointServicePermissionsCommandInput, DescribeVpcEndpointServicePermissionsCommandOutput } from "../commands/DescribeVpcEndpointServicePermissionsCommand";
import { DescribeVpcEndpointServicesCommandInput, DescribeVpcEndpointServicesCommandOutput } from "../commands/DescribeVpcEndpointServicesCommand";
import { DescribeVpcPeeringConnectionsCommandInput, DescribeVpcPeeringConnectionsCommandOutput } from "../commands/DescribeVpcPeeringConnectionsCommand";
import { DescribeVpcsCommandInput, DescribeVpcsCommandOutput } from "../commands/DescribeVpcsCommand";
import { DescribeVpnConnectionsCommandInput, DescribeVpnConnectionsCommandOutput } from "../commands/DescribeVpnConnectionsCommand";
import { DescribeVpnGatewaysCommandInput, DescribeVpnGatewaysCommandOutput } from "../commands/DescribeVpnGatewaysCommand";
import { DetachClassicLinkVpcCommandInput, DetachClassicLinkVpcCommandOutput } from "../commands/DetachClassicLinkVpcCommand";
import { DetachInternetGatewayCommandInput, DetachInternetGatewayCommandOutput } from "../commands/DetachInternetGatewayCommand";
import { DetachNetworkInterfaceCommandInput, DetachNetworkInterfaceCommandOutput } from "../commands/DetachNetworkInterfaceCommand";
import { DetachVerifiedAccessTrustProviderCommandInput, DetachVerifiedAccessTrustProviderCommandOutput } from "../commands/DetachVerifiedAccessTrustProviderCommand";
import { DetachVolumeCommandInput, DetachVolumeCommandOutput } from "../commands/DetachVolumeCommand";
import { DetachVpnGatewayCommandInput, DetachVpnGatewayCommandOutput } from "../commands/DetachVpnGatewayCommand";
import { DisableAddressTransferCommandInput, DisableAddressTransferCommandOutput } from "../commands/DisableAddressTransferCommand";
import { DisableAwsNetworkPerformanceMetricSubscriptionCommandInput, DisableAwsNetworkPerformanceMetricSubscriptionCommandOutput } from "../commands/DisableAwsNetworkPerformanceMetricSubscriptionCommand";
import { DisableEbsEncryptionByDefaultCommandInput, DisableEbsEncryptionByDefaultCommandOutput } from "../commands/DisableEbsEncryptionByDefaultCommand";
import { DisableFastLaunchCommandInput, DisableFastLaunchCommandOutput } from "../commands/DisableFastLaunchCommand";
import { DisableFastSnapshotRestoresCommandInput, DisableFastSnapshotRestoresCommandOutput } from "../commands/DisableFastSnapshotRestoresCommand";
import { DisableImageBlockPublicAccessCommandInput, DisableImageBlockPublicAccessCommandOutput } from "../commands/DisableImageBlockPublicAccessCommand";
import { DisableImageCommandInput, DisableImageCommandOutput } from "../commands/DisableImageCommand";
import { DisableImageDeprecationCommandInput, DisableImageDeprecationCommandOutput } from "../commands/DisableImageDeprecationCommand";
import { DisableIpamOrganizationAdminAccountCommandInput, DisableIpamOrganizationAdminAccountCommandOutput } from "../commands/DisableIpamOrganizationAdminAccountCommand";
import { DisableSerialConsoleAccessCommandInput, DisableSerialConsoleAccessCommandOutput } from "../commands/DisableSerialConsoleAccessCommand";
import { DisableSnapshotBlockPublicAccessCommandInput, DisableSnapshotBlockPublicAccessCommandOutput } from "../commands/DisableSnapshotBlockPublicAccessCommand";
import { DisableTransitGatewayRouteTablePropagationCommandInput, DisableTransitGatewayRouteTablePropagationCommandOutput } from "../commands/DisableTransitGatewayRouteTablePropagationCommand";
import { DisableVgwRoutePropagationCommandInput, DisableVgwRoutePropagationCommandOutput } from "../commands/DisableVgwRoutePropagationCommand";
import { DisableVpcClassicLinkCommandInput, DisableVpcClassicLinkCommandOutput } from "../commands/DisableVpcClassicLinkCommand";
import { DisableVpcClassicLinkDnsSupportCommandInput, DisableVpcClassicLinkDnsSupportCommandOutput } from "../commands/DisableVpcClassicLinkDnsSupportCommand";
import { DisassociateAddressCommandInput, DisassociateAddressCommandOutput } from "../commands/DisassociateAddressCommand";
import { DisassociateClientVpnTargetNetworkCommandInput, DisassociateClientVpnTargetNetworkCommandOutput } from "../commands/DisassociateClientVpnTargetNetworkCommand";
import { DisassociateEnclaveCertificateIamRoleCommandInput, DisassociateEnclaveCertificateIamRoleCommandOutput } from "../commands/DisassociateEnclaveCertificateIamRoleCommand";
import { DisassociateIamInstanceProfileCommandInput, DisassociateIamInstanceProfileCommandOutput } from "../commands/DisassociateIamInstanceProfileCommand";
import { DisassociateInstanceEventWindowCommandInput, DisassociateInstanceEventWindowCommandOutput } from "../commands/DisassociateInstanceEventWindowCommand";
import { DisassociateIpamByoasnCommandInput, DisassociateIpamByoasnCommandOutput } from "../commands/DisassociateIpamByoasnCommand";
import { DisassociateIpamResourceDiscoveryCommandInput, DisassociateIpamResourceDiscoveryCommandOutput } from "../commands/DisassociateIpamResourceDiscoveryCommand";
import { DisassociateNatGatewayAddressCommandInput, DisassociateNatGatewayAddressCommandOutput } from "../commands/DisassociateNatGatewayAddressCommand";
import { DisassociateRouteTableCommandInput, DisassociateRouteTableCommandOutput } from "../commands/DisassociateRouteTableCommand";
import { DisassociateSubnetCidrBlockCommandInput, DisassociateSubnetCidrBlockCommandOutput } from "../commands/DisassociateSubnetCidrBlockCommand";
import { DisassociateTransitGatewayMulticastDomainCommandInput, DisassociateTransitGatewayMulticastDomainCommandOutput } from "../commands/DisassociateTransitGatewayMulticastDomainCommand";
import { DisassociateTransitGatewayPolicyTableCommandInput, DisassociateTransitGatewayPolicyTableCommandOutput } from "../commands/DisassociateTransitGatewayPolicyTableCommand";
import { DisassociateTransitGatewayRouteTableCommandInput, DisassociateTransitGatewayRouteTableCommandOutput } from "../commands/DisassociateTransitGatewayRouteTableCommand";
import { DisassociateTrunkInterfaceCommandInput, DisassociateTrunkInterfaceCommandOutput } from "../commands/DisassociateTrunkInterfaceCommand";
import { DisassociateVpcCidrBlockCommandInput, DisassociateVpcCidrBlockCommandOutput } from "../commands/DisassociateVpcCidrBlockCommand";
import { EnableAddressTransferCommandInput, EnableAddressTransferCommandOutput } from "../commands/EnableAddressTransferCommand";
import { EnableAwsNetworkPerformanceMetricSubscriptionCommandInput, EnableAwsNetworkPerformanceMetricSubscriptionCommandOutput } from "../commands/EnableAwsNetworkPerformanceMetricSubscriptionCommand";
import { EnableEbsEncryptionByDefaultCommandInput, EnableEbsEncryptionByDefaultCommandOutput } from "../commands/EnableEbsEncryptionByDefaultCommand";
import { EnableFastLaunchCommandInput, EnableFastLaunchCommandOutput } from "../commands/EnableFastLaunchCommand";
import { EnableFastSnapshotRestoresCommandInput, EnableFastSnapshotRestoresCommandOutput } from "../commands/EnableFastSnapshotRestoresCommand";
import { EnableImageBlockPublicAccessCommandInput, EnableImageBlockPublicAccessCommandOutput } from "../commands/EnableImageBlockPublicAccessCommand";
import { EnableImageCommandInput, EnableImageCommandOutput } from "../commands/EnableImageCommand";
import { EnableImageDeprecationCommandInput, EnableImageDeprecationCommandOutput } from "../commands/EnableImageDeprecationCommand";
import { EnableIpamOrganizationAdminAccountCommandInput, EnableIpamOrganizationAdminAccountCommandOutput } from "../commands/EnableIpamOrganizationAdminAccountCommand";
import { EnableReachabilityAnalyzerOrganizationSharingCommandInput, EnableReachabilityAnalyzerOrganizationSharingCommandOutput } from "../commands/EnableReachabilityAnalyzerOrganizationSharingCommand";
import { EnableSerialConsoleAccessCommandInput, EnableSerialConsoleAccessCommandOutput } from "../commands/EnableSerialConsoleAccessCommand";
import { EnableSnapshotBlockPublicAccessCommandInput, EnableSnapshotBlockPublicAccessCommandOutput } from "../commands/EnableSnapshotBlockPublicAccessCommand";
import { EnableTransitGatewayRouteTablePropagationCommandInput, EnableTransitGatewayRouteTablePropagationCommandOutput } from "../commands/EnableTransitGatewayRouteTablePropagationCommand";
import { EnableVgwRoutePropagationCommandInput, EnableVgwRoutePropagationCommandOutput } from "../commands/EnableVgwRoutePropagationCommand";
import { EnableVolumeIOCommandInput, EnableVolumeIOCommandOutput } from "../commands/EnableVolumeIOCommand";
import { EnableVpcClassicLinkCommandInput, EnableVpcClassicLinkCommandOutput } from "../commands/EnableVpcClassicLinkCommand";
import { EnableVpcClassicLinkDnsSupportCommandInput, EnableVpcClassicLinkDnsSupportCommandOutput } from "../commands/EnableVpcClassicLinkDnsSupportCommand";
import { ExportClientVpnClientCertificateRevocationListCommandInput, ExportClientVpnClientCertificateRevocationListCommandOutput } from "../commands/ExportClientVpnClientCertificateRevocationListCommand";
import { ExportClientVpnClientConfigurationCommandInput, ExportClientVpnClientConfigurationCommandOutput } from "../commands/ExportClientVpnClientConfigurationCommand";
import { ExportImageCommandInput, ExportImageCommandOutput } from "../commands/ExportImageCommand";
import { ExportTransitGatewayRoutesCommandInput, ExportTransitGatewayRoutesCommandOutput } from "../commands/ExportTransitGatewayRoutesCommand";
import { GetAssociatedEnclaveCertificateIamRolesCommandInput, GetAssociatedEnclaveCertificateIamRolesCommandOutput } from "../commands/GetAssociatedEnclaveCertificateIamRolesCommand";
import { GetAssociatedIpv6PoolCidrsCommandInput, GetAssociatedIpv6PoolCidrsCommandOutput } from "../commands/GetAssociatedIpv6PoolCidrsCommand";
import { GetAwsNetworkPerformanceDataCommandInput, GetAwsNetworkPerformanceDataCommandOutput } from "../commands/GetAwsNetworkPerformanceDataCommand";
import { GetCapacityReservationUsageCommandInput, GetCapacityReservationUsageCommandOutput } from "../commands/GetCapacityReservationUsageCommand";
import { GetCoipPoolUsageCommandInput, GetCoipPoolUsageCommandOutput } from "../commands/GetCoipPoolUsageCommand";
import { GetConsoleOutputCommandInput, GetConsoleOutputCommandOutput } from "../commands/GetConsoleOutputCommand";
import { GetConsoleScreenshotCommandInput, GetConsoleScreenshotCommandOutput } from "../commands/GetConsoleScreenshotCommand";
import { GetDefaultCreditSpecificationCommandInput, GetDefaultCreditSpecificationCommandOutput } from "../commands/GetDefaultCreditSpecificationCommand";
import { GetEbsDefaultKmsKeyIdCommandInput, GetEbsDefaultKmsKeyIdCommandOutput } from "../commands/GetEbsDefaultKmsKeyIdCommand";
import { GetEbsEncryptionByDefaultCommandInput, GetEbsEncryptionByDefaultCommandOutput } from "../commands/GetEbsEncryptionByDefaultCommand";
import { GetFlowLogsIntegrationTemplateCommandInput, GetFlowLogsIntegrationTemplateCommandOutput } from "../commands/GetFlowLogsIntegrationTemplateCommand";
import { GetGroupsForCapacityReservationCommandInput, GetGroupsForCapacityReservationCommandOutput } from "../commands/GetGroupsForCapacityReservationCommand";
import { GetHostReservationPurchasePreviewCommandInput, GetHostReservationPurchasePreviewCommandOutput } from "../commands/GetHostReservationPurchasePreviewCommand";
import { GetImageBlockPublicAccessStateCommandInput, GetImageBlockPublicAccessStateCommandOutput } from "../commands/GetImageBlockPublicAccessStateCommand";
import { GetInstanceMetadataDefaultsCommandInput, GetInstanceMetadataDefaultsCommandOutput } from "../commands/GetInstanceMetadataDefaultsCommand";
import { GetInstanceTypesFromInstanceRequirementsCommandInput, GetInstanceTypesFromInstanceRequirementsCommandOutput } from "../commands/GetInstanceTypesFromInstanceRequirementsCommand";
import { GetInstanceUefiDataCommandInput, GetInstanceUefiDataCommandOutput } from "../commands/GetInstanceUefiDataCommand";
import { GetIpamAddressHistoryCommandInput, GetIpamAddressHistoryCommandOutput } from "../commands/GetIpamAddressHistoryCommand";
import { GetIpamDiscoveredAccountsCommandInput, GetIpamDiscoveredAccountsCommandOutput } from "../commands/GetIpamDiscoveredAccountsCommand";
import { GetIpamDiscoveredPublicAddressesCommandInput, GetIpamDiscoveredPublicAddressesCommandOutput } from "../commands/GetIpamDiscoveredPublicAddressesCommand";
import { GetIpamDiscoveredResourceCidrsCommandInput, GetIpamDiscoveredResourceCidrsCommandOutput } from "../commands/GetIpamDiscoveredResourceCidrsCommand";
import { GetIpamPoolAllocationsCommandInput, GetIpamPoolAllocationsCommandOutput } from "../commands/GetIpamPoolAllocationsCommand";
import { GetIpamPoolCidrsCommandInput, GetIpamPoolCidrsCommandOutput } from "../commands/GetIpamPoolCidrsCommand";
import { GetIpamResourceCidrsCommandInput, GetIpamResourceCidrsCommandOutput } from "../commands/GetIpamResourceCidrsCommand";
import { GetLaunchTemplateDataCommandInput, GetLaunchTemplateDataCommandOutput } from "../commands/GetLaunchTemplateDataCommand";
import { GetManagedPrefixListAssociationsCommandInput, GetManagedPrefixListAssociationsCommandOutput } from "../commands/GetManagedPrefixListAssociationsCommand";
import { GetManagedPrefixListEntriesCommandInput, GetManagedPrefixListEntriesCommandOutput } from "../commands/GetManagedPrefixListEntriesCommand";
import { GetNetworkInsightsAccessScopeAnalysisFindingsCommandInput, GetNetworkInsightsAccessScopeAnalysisFindingsCommandOutput } from "../commands/GetNetworkInsightsAccessScopeAnalysisFindingsCommand";
import { GetNetworkInsightsAccessScopeContentCommandInput, GetNetworkInsightsAccessScopeContentCommandOutput } from "../commands/GetNetworkInsightsAccessScopeContentCommand";
import { GetPasswordDataCommandInput, GetPasswordDataCommandOutput } from "../commands/GetPasswordDataCommand";
import { GetReservedInstancesExchangeQuoteCommandInput, GetReservedInstancesExchangeQuoteCommandOutput } from "../commands/GetReservedInstancesExchangeQuoteCommand";
import { GetSecurityGroupsForVpcCommandInput, GetSecurityGroupsForVpcCommandOutput } from "../commands/GetSecurityGroupsForVpcCommand";
import { GetSerialConsoleAccessStatusCommandInput, GetSerialConsoleAccessStatusCommandOutput } from "../commands/GetSerialConsoleAccessStatusCommand";
import { GetSnapshotBlockPublicAccessStateCommandInput, GetSnapshotBlockPublicAccessStateCommandOutput } from "../commands/GetSnapshotBlockPublicAccessStateCommand";
import { GetSpotPlacementScoresCommandInput, GetSpotPlacementScoresCommandOutput } from "../commands/GetSpotPlacementScoresCommand";
import { GetSubnetCidrReservationsCommandInput, GetSubnetCidrReservationsCommandOutput } from "../commands/GetSubnetCidrReservationsCommand";
import { GetTransitGatewayAttachmentPropagationsCommandInput, GetTransitGatewayAttachmentPropagationsCommandOutput } from "../commands/GetTransitGatewayAttachmentPropagationsCommand";
import { GetTransitGatewayMulticastDomainAssociationsCommandInput, GetTransitGatewayMulticastDomainAssociationsCommandOutput } from "../commands/GetTransitGatewayMulticastDomainAssociationsCommand";
import { GetTransitGatewayPolicyTableAssociationsCommandInput, GetTransitGatewayPolicyTableAssociationsCommandOutput } from "../commands/GetTransitGatewayPolicyTableAssociationsCommand";
import { GetTransitGatewayPolicyTableEntriesCommandInput, GetTransitGatewayPolicyTableEntriesCommandOutput } from "../commands/GetTransitGatewayPolicyTableEntriesCommand";
import { GetTransitGatewayPrefixListReferencesCommandInput, GetTransitGatewayPrefixListReferencesCommandOutput } from "../commands/GetTransitGatewayPrefixListReferencesCommand";
import { GetTransitGatewayRouteTableAssociationsCommandInput, GetTransitGatewayRouteTableAssociationsCommandOutput } from "../commands/GetTransitGatewayRouteTableAssociationsCommand";
import { GetTransitGatewayRouteTablePropagationsCommandInput, GetTransitGatewayRouteTablePropagationsCommandOutput } from "../commands/GetTransitGatewayRouteTablePropagationsCommand";
import { GetVerifiedAccessEndpointPolicyCommandInput, GetVerifiedAccessEndpointPolicyCommandOutput } from "../commands/GetVerifiedAccessEndpointPolicyCommand";
import { GetVerifiedAccessGroupPolicyCommandInput, GetVerifiedAccessGroupPolicyCommandOutput } from "../commands/GetVerifiedAccessGroupPolicyCommand";
import { GetVpnConnectionDeviceSampleConfigurationCommandInput, GetVpnConnectionDeviceSampleConfigurationCommandOutput } from "../commands/GetVpnConnectionDeviceSampleConfigurationCommand";
import { GetVpnConnectionDeviceTypesCommandInput, GetVpnConnectionDeviceTypesCommandOutput } from "../commands/GetVpnConnectionDeviceTypesCommand";
import { GetVpnTunnelReplacementStatusCommandInput, GetVpnTunnelReplacementStatusCommandOutput } from "../commands/GetVpnTunnelReplacementStatusCommand";
import { ImportClientVpnClientCertificateRevocationListCommandInput, ImportClientVpnClientCertificateRevocationListCommandOutput } from "../commands/ImportClientVpnClientCertificateRevocationListCommand";
import { ImportImageCommandInput, ImportImageCommandOutput } from "../commands/ImportImageCommand";
import { ImportInstanceCommandInput, ImportInstanceCommandOutput } from "../commands/ImportInstanceCommand";
import { ImportKeyPairCommandInput, ImportKeyPairCommandOutput } from "../commands/ImportKeyPairCommand";
import { ImportSnapshotCommandInput, ImportSnapshotCommandOutput } from "../commands/ImportSnapshotCommand";
import { ImportVolumeCommandInput, ImportVolumeCommandOutput } from "../commands/ImportVolumeCommand";
import { ListImagesInRecycleBinCommandInput, ListImagesInRecycleBinCommandOutput } from "../commands/ListImagesInRecycleBinCommand";
import { ListSnapshotsInRecycleBinCommandInput, ListSnapshotsInRecycleBinCommandOutput } from "../commands/ListSnapshotsInRecycleBinCommand";
import { LockSnapshotCommandInput, LockSnapshotCommandOutput } from "../commands/LockSnapshotCommand";
import { ModifyAddressAttributeCommandInput, ModifyAddressAttributeCommandOutput } from "../commands/ModifyAddressAttributeCommand";
import { ModifyAvailabilityZoneGroupCommandInput, ModifyAvailabilityZoneGroupCommandOutput } from "../commands/ModifyAvailabilityZoneGroupCommand";
import { ModifyCapacityReservationCommandInput, ModifyCapacityReservationCommandOutput } from "../commands/ModifyCapacityReservationCommand";
import { ModifyCapacityReservationFleetCommandInput, ModifyCapacityReservationFleetCommandOutput } from "../commands/ModifyCapacityReservationFleetCommand";
import { ModifyClientVpnEndpointCommandInput, ModifyClientVpnEndpointCommandOutput } from "../commands/ModifyClientVpnEndpointCommand";
import { ModifyDefaultCreditSpecificationCommandInput, ModifyDefaultCreditSpecificationCommandOutput } from "../commands/ModifyDefaultCreditSpecificationCommand";
import { ModifyEbsDefaultKmsKeyIdCommandInput, ModifyEbsDefaultKmsKeyIdCommandOutput } from "../commands/ModifyEbsDefaultKmsKeyIdCommand";
import { ModifyFleetCommandInput, ModifyFleetCommandOutput } from "../commands/ModifyFleetCommand";
import { ModifyFpgaImageAttributeCommandInput, ModifyFpgaImageAttributeCommandOutput } from "../commands/ModifyFpgaImageAttributeCommand";
import { ModifyHostsCommandInput, ModifyHostsCommandOutput } from "../commands/ModifyHostsCommand";
import { ModifyIdentityIdFormatCommandInput, ModifyIdentityIdFormatCommandOutput } from "../commands/ModifyIdentityIdFormatCommand";
import { ModifyIdFormatCommandInput, ModifyIdFormatCommandOutput } from "../commands/ModifyIdFormatCommand";
import { ModifyImageAttributeCommandInput, ModifyImageAttributeCommandOutput } from "../commands/ModifyImageAttributeCommand";
import { ModifyInstanceAttributeCommandInput, ModifyInstanceAttributeCommandOutput } from "../commands/ModifyInstanceAttributeCommand";
import { ModifyInstanceCapacityReservationAttributesCommandInput, ModifyInstanceCapacityReservationAttributesCommandOutput } from "../commands/ModifyInstanceCapacityReservationAttributesCommand";
import { ModifyInstanceCreditSpecificationCommandInput, ModifyInstanceCreditSpecificationCommandOutput } from "../commands/ModifyInstanceCreditSpecificationCommand";
import { ModifyInstanceEventStartTimeCommandInput, ModifyInstanceEventStartTimeCommandOutput } from "../commands/ModifyInstanceEventStartTimeCommand";
import { ModifyInstanceEventWindowCommandInput, ModifyInstanceEventWindowCommandOutput } from "../commands/ModifyInstanceEventWindowCommand";
import { ModifyInstanceMaintenanceOptionsCommandInput, ModifyInstanceMaintenanceOptionsCommandOutput } from "../commands/ModifyInstanceMaintenanceOptionsCommand";
import { ModifyInstanceMetadataDefaultsCommandInput, ModifyInstanceMetadataDefaultsCommandOutput } from "../commands/ModifyInstanceMetadataDefaultsCommand";
import { ModifyInstanceMetadataOptionsCommandInput, ModifyInstanceMetadataOptionsCommandOutput } from "../commands/ModifyInstanceMetadataOptionsCommand";
import { ModifyInstancePlacementCommandInput, ModifyInstancePlacementCommandOutput } from "../commands/ModifyInstancePlacementCommand";
import { ModifyIpamCommandInput, ModifyIpamCommandOutput } from "../commands/ModifyIpamCommand";
import { ModifyIpamPoolCommandInput, ModifyIpamPoolCommandOutput } from "../commands/ModifyIpamPoolCommand";
import { ModifyIpamResourceCidrCommandInput, ModifyIpamResourceCidrCommandOutput } from "../commands/ModifyIpamResourceCidrCommand";
import { ModifyIpamResourceDiscoveryCommandInput, ModifyIpamResourceDiscoveryCommandOutput } from "../commands/ModifyIpamResourceDiscoveryCommand";
import { ModifyIpamScopeCommandInput, ModifyIpamScopeCommandOutput } from "../commands/ModifyIpamScopeCommand";
import { ModifyLaunchTemplateCommandInput, ModifyLaunchTemplateCommandOutput } from "../commands/ModifyLaunchTemplateCommand";
import { ModifyLocalGatewayRouteCommandInput, ModifyLocalGatewayRouteCommandOutput } from "../commands/ModifyLocalGatewayRouteCommand";
import { ModifyManagedPrefixListCommandInput, ModifyManagedPrefixListCommandOutput } from "../commands/ModifyManagedPrefixListCommand";
import { ModifyNetworkInterfaceAttributeCommandInput, ModifyNetworkInterfaceAttributeCommandOutput } from "../commands/ModifyNetworkInterfaceAttributeCommand";
import { ModifyPrivateDnsNameOptionsCommandInput, ModifyPrivateDnsNameOptionsCommandOutput } from "../commands/ModifyPrivateDnsNameOptionsCommand";
import { ModifyReservedInstancesCommandInput, ModifyReservedInstancesCommandOutput } from "../commands/ModifyReservedInstancesCommand";
import { ModifySecurityGroupRulesCommandInput, ModifySecurityGroupRulesCommandOutput } from "../commands/ModifySecurityGroupRulesCommand";
import { ModifySnapshotAttributeCommandInput, ModifySnapshotAttributeCommandOutput } from "../commands/ModifySnapshotAttributeCommand";
import { ModifySnapshotTierCommandInput, ModifySnapshotTierCommandOutput } from "../commands/ModifySnapshotTierCommand";
import { ModifySpotFleetRequestCommandInput, ModifySpotFleetRequestCommandOutput } from "../commands/ModifySpotFleetRequestCommand";
import { ModifySubnetAttributeCommandInput, ModifySubnetAttributeCommandOutput } from "../commands/ModifySubnetAttributeCommand";
import { ModifyTrafficMirrorFilterNetworkServicesCommandInput, ModifyTrafficMirrorFilterNetworkServicesCommandOutput } from "../commands/ModifyTrafficMirrorFilterNetworkServicesCommand";
import { ModifyTrafficMirrorFilterRuleCommandInput, ModifyTrafficMirrorFilterRuleCommandOutput } from "../commands/ModifyTrafficMirrorFilterRuleCommand";
import { ModifyTrafficMirrorSessionCommandInput, ModifyTrafficMirrorSessionCommandOutput } from "../commands/ModifyTrafficMirrorSessionCommand";
import { ModifyTransitGatewayCommandInput, ModifyTransitGatewayCommandOutput } from "../commands/ModifyTransitGatewayCommand";
import { ModifyTransitGatewayPrefixListReferenceCommandInput, ModifyTransitGatewayPrefixListReferenceCommandOutput } from "../commands/ModifyTransitGatewayPrefixListReferenceCommand";
import { ModifyTransitGatewayVpcAttachmentCommandInput, ModifyTransitGatewayVpcAttachmentCommandOutput } from "../commands/ModifyTransitGatewayVpcAttachmentCommand";
import { ModifyVerifiedAccessEndpointCommandInput, ModifyVerifiedAccessEndpointCommandOutput } from "../commands/ModifyVerifiedAccessEndpointCommand";
import { ModifyVerifiedAccessEndpointPolicyCommandInput, ModifyVerifiedAccessEndpointPolicyCommandOutput } from "../commands/ModifyVerifiedAccessEndpointPolicyCommand";
import { ModifyVerifiedAccessGroupCommandInput, ModifyVerifiedAccessGroupCommandOutput } from "../commands/ModifyVerifiedAccessGroupCommand";
import { ModifyVerifiedAccessGroupPolicyCommandInput, ModifyVerifiedAccessGroupPolicyCommandOutput } from "../commands/ModifyVerifiedAccessGroupPolicyCommand";
import { ModifyVerifiedAccessInstanceCommandInput, ModifyVerifiedAccessInstanceCommandOutput } from "../commands/ModifyVerifiedAccessInstanceCommand";
import { ModifyVerifiedAccessInstanceLoggingConfigurationCommandInput, ModifyVerifiedAccessInstanceLoggingConfigurationCommandOutput } from "../commands/ModifyVerifiedAccessInstanceLoggingConfigurationCommand";
import { ModifyVerifiedAccessTrustProviderCommandInput, ModifyVerifiedAccessTrustProviderCommandOutput } from "../commands/ModifyVerifiedAccessTrustProviderCommand";
import { ModifyVolumeAttributeCommandInput, ModifyVolumeAttributeCommandOutput } from "../commands/ModifyVolumeAttributeCommand";
import { ModifyVolumeCommandInput, ModifyVolumeCommandOutput } from "../commands/ModifyVolumeCommand";
import { ModifyVpcAttributeCommandInput, ModifyVpcAttributeCommandOutput } from "../commands/ModifyVpcAttributeCommand";
import { ModifyVpcEndpointCommandInput, ModifyVpcEndpointCommandOutput } from "../commands/ModifyVpcEndpointCommand";
import { ModifyVpcEndpointConnectionNotificationCommandInput, ModifyVpcEndpointConnectionNotificationCommandOutput } from "../commands/ModifyVpcEndpointConnectionNotificationCommand";
import { ModifyVpcEndpointServiceConfigurationCommandInput, ModifyVpcEndpointServiceConfigurationCommandOutput } from "../commands/ModifyVpcEndpointServiceConfigurationCommand";
import { ModifyVpcEndpointServicePayerResponsibilityCommandInput, ModifyVpcEndpointServicePayerResponsibilityCommandOutput } from "../commands/ModifyVpcEndpointServicePayerResponsibilityCommand";
import { ModifyVpcEndpointServicePermissionsCommandInput, ModifyVpcEndpointServicePermissionsCommandOutput } from "../commands/ModifyVpcEndpointServicePermissionsCommand";
import { ModifyVpcPeeringConnectionOptionsCommandInput, ModifyVpcPeeringConnectionOptionsCommandOutput } from "../commands/ModifyVpcPeeringConnectionOptionsCommand";
import { ModifyVpcTenancyCommandInput, ModifyVpcTenancyCommandOutput } from "../commands/ModifyVpcTenancyCommand";
import { ModifyVpnConnectionCommandInput, ModifyVpnConnectionCommandOutput } from "../commands/ModifyVpnConnectionCommand";
import { ModifyVpnConnectionOptionsCommandInput, ModifyVpnConnectionOptionsCommandOutput } from "../commands/ModifyVpnConnectionOptionsCommand";
import { ModifyVpnTunnelCertificateCommandInput, ModifyVpnTunnelCertificateCommandOutput } from "../commands/ModifyVpnTunnelCertificateCommand";
import { ModifyVpnTunnelOptionsCommandInput, ModifyVpnTunnelOptionsCommandOutput } from "../commands/ModifyVpnTunnelOptionsCommand";
import { MonitorInstancesCommandInput, MonitorInstancesCommandOutput } from "../commands/MonitorInstancesCommand";
import { MoveAddressToVpcCommandInput, MoveAddressToVpcCommandOutput } from "../commands/MoveAddressToVpcCommand";
import { MoveByoipCidrToIpamCommandInput, MoveByoipCidrToIpamCommandOutput } from "../commands/MoveByoipCidrToIpamCommand";
import { ProvisionByoipCidrCommandInput, ProvisionByoipCidrCommandOutput } from "../commands/ProvisionByoipCidrCommand";
import { ProvisionIpamByoasnCommandInput, ProvisionIpamByoasnCommandOutput } from "../commands/ProvisionIpamByoasnCommand";
import { ProvisionIpamPoolCidrCommandInput, ProvisionIpamPoolCidrCommandOutput } from "../commands/ProvisionIpamPoolCidrCommand";
import { ProvisionPublicIpv4PoolCidrCommandInput, ProvisionPublicIpv4PoolCidrCommandOutput } from "../commands/ProvisionPublicIpv4PoolCidrCommand";
import { PurchaseCapacityBlockCommandInput, PurchaseCapacityBlockCommandOutput } from "../commands/PurchaseCapacityBlockCommand";
import { PurchaseHostReservationCommandInput, PurchaseHostReservationCommandOutput } from "../commands/PurchaseHostReservationCommand";
import { PurchaseReservedInstancesOfferingCommandInput, PurchaseReservedInstancesOfferingCommandOutput } from "../commands/PurchaseReservedInstancesOfferingCommand";
import { PurchaseScheduledInstancesCommandInput, PurchaseScheduledInstancesCommandOutput } from "../commands/PurchaseScheduledInstancesCommand";
import { RebootInstancesCommandInput, RebootInstancesCommandOutput } from "../commands/RebootInstancesCommand";
import { RegisterImageCommandInput, RegisterImageCommandOutput } from "../commands/RegisterImageCommand";
import { RegisterInstanceEventNotificationAttributesCommandInput, RegisterInstanceEventNotificationAttributesCommandOutput } from "../commands/RegisterInstanceEventNotificationAttributesCommand";
import { RegisterTransitGatewayMulticastGroupMembersCommandInput, RegisterTransitGatewayMulticastGroupMembersCommandOutput } from "../commands/RegisterTransitGatewayMulticastGroupMembersCommand";
import { RegisterTransitGatewayMulticastGroupSourcesCommandInput, RegisterTransitGatewayMulticastGroupSourcesCommandOutput } from "../commands/RegisterTransitGatewayMulticastGroupSourcesCommand";
import { RejectTransitGatewayMulticastDomainAssociationsCommandInput, RejectTransitGatewayMulticastDomainAssociationsCommandOutput } from "../commands/RejectTransitGatewayMulticastDomainAssociationsCommand";
import { RejectTransitGatewayPeeringAttachmentCommandInput, RejectTransitGatewayPeeringAttachmentCommandOutput } from "../commands/RejectTransitGatewayPeeringAttachmentCommand";
import { RejectTransitGatewayVpcAttachmentCommandInput, RejectTransitGatewayVpcAttachmentCommandOutput } from "../commands/RejectTransitGatewayVpcAttachmentCommand";
import { RejectVpcEndpointConnectionsCommandInput, RejectVpcEndpointConnectionsCommandOutput } from "../commands/RejectVpcEndpointConnectionsCommand";
import { RejectVpcPeeringConnectionCommandInput, RejectVpcPeeringConnectionCommandOutput } from "../commands/RejectVpcPeeringConnectionCommand";
import { ReleaseAddressCommandInput, ReleaseAddressCommandOutput } from "../commands/ReleaseAddressCommand";
import { ReleaseHostsCommandInput, ReleaseHostsCommandOutput } from "../commands/ReleaseHostsCommand";
import { ReleaseIpamPoolAllocationCommandInput, ReleaseIpamPoolAllocationCommandOutput } from "../commands/ReleaseIpamPoolAllocationCommand";
import { ReplaceIamInstanceProfileAssociationCommandInput, ReplaceIamInstanceProfileAssociationCommandOutput } from "../commands/ReplaceIamInstanceProfileAssociationCommand";
import { ReplaceNetworkAclAssociationCommandInput, ReplaceNetworkAclAssociationCommandOutput } from "../commands/ReplaceNetworkAclAssociationCommand";
import { ReplaceNetworkAclEntryCommandInput, ReplaceNetworkAclEntryCommandOutput } from "../commands/ReplaceNetworkAclEntryCommand";
import { ReplaceRouteCommandInput, ReplaceRouteCommandOutput } from "../commands/ReplaceRouteCommand";
import { ReplaceRouteTableAssociationCommandInput, ReplaceRouteTableAssociationCommandOutput } from "../commands/ReplaceRouteTableAssociationCommand";
import { ReplaceTransitGatewayRouteCommandInput, ReplaceTransitGatewayRouteCommandOutput } from "../commands/ReplaceTransitGatewayRouteCommand";
import { ReplaceVpnTunnelCommandInput, ReplaceVpnTunnelCommandOutput } from "../commands/ReplaceVpnTunnelCommand";
import { ReportInstanceStatusCommandInput, ReportInstanceStatusCommandOutput } from "../commands/ReportInstanceStatusCommand";
import { RequestSpotFleetCommandInput, RequestSpotFleetCommandOutput } from "../commands/RequestSpotFleetCommand";
import { RequestSpotInstancesCommandInput, RequestSpotInstancesCommandOutput } from "../commands/RequestSpotInstancesCommand";
import { ResetAddressAttributeCommandInput, ResetAddressAttributeCommandOutput } from "../commands/ResetAddressAttributeCommand";
import { ResetEbsDefaultKmsKeyIdCommandInput, ResetEbsDefaultKmsKeyIdCommandOutput } from "../commands/ResetEbsDefaultKmsKeyIdCommand";
import { ResetFpgaImageAttributeCommandInput, ResetFpgaImageAttributeCommandOutput } from "../commands/ResetFpgaImageAttributeCommand";
import { ResetImageAttributeCommandInput, ResetImageAttributeCommandOutput } from "../commands/ResetImageAttributeCommand";
import { ResetInstanceAttributeCommandInput, ResetInstanceAttributeCommandOutput } from "../commands/ResetInstanceAttributeCommand";
import { ResetNetworkInterfaceAttributeCommandInput, ResetNetworkInterfaceAttributeCommandOutput } from "../commands/ResetNetworkInterfaceAttributeCommand";
import { ResetSnapshotAttributeCommandInput, ResetSnapshotAttributeCommandOutput } from "../commands/ResetSnapshotAttributeCommand";
import { RestoreAddressToClassicCommandInput, RestoreAddressToClassicCommandOutput } from "../commands/RestoreAddressToClassicCommand";
import { RestoreImageFromRecycleBinCommandInput, RestoreImageFromRecycleBinCommandOutput } from "../commands/RestoreImageFromRecycleBinCommand";
import { RestoreManagedPrefixListVersionCommandInput, RestoreManagedPrefixListVersionCommandOutput } from "../commands/RestoreManagedPrefixListVersionCommand";
import { RestoreSnapshotFromRecycleBinCommandInput, RestoreSnapshotFromRecycleBinCommandOutput } from "../commands/RestoreSnapshotFromRecycleBinCommand";
import { RestoreSnapshotTierCommandInput, RestoreSnapshotTierCommandOutput } from "../commands/RestoreSnapshotTierCommand";
import { RevokeClientVpnIngressCommandInput, RevokeClientVpnIngressCommandOutput } from "../commands/RevokeClientVpnIngressCommand";
import { RevokeSecurityGroupEgressCommandInput, RevokeSecurityGroupEgressCommandOutput } from "../commands/RevokeSecurityGroupEgressCommand";
import { RevokeSecurityGroupIngressCommandInput, RevokeSecurityGroupIngressCommandOutput } from "../commands/RevokeSecurityGroupIngressCommand";
import { RunInstancesCommandInput, RunInstancesCommandOutput } from "../commands/RunInstancesCommand";
import { RunScheduledInstancesCommandInput, RunScheduledInstancesCommandOutput } from "../commands/RunScheduledInstancesCommand";
import { SearchLocalGatewayRoutesCommandInput, SearchLocalGatewayRoutesCommandOutput } from "../commands/SearchLocalGatewayRoutesCommand";
import { SearchTransitGatewayMulticastGroupsCommandInput, SearchTransitGatewayMulticastGroupsCommandOutput } from "../commands/SearchTransitGatewayMulticastGroupsCommand";
import { SearchTransitGatewayRoutesCommandInput, SearchTransitGatewayRoutesCommandOutput } from "../commands/SearchTransitGatewayRoutesCommand";
import { SendDiagnosticInterruptCommandInput, SendDiagnosticInterruptCommandOutput } from "../commands/SendDiagnosticInterruptCommand";
import { StartInstancesCommandInput, StartInstancesCommandOutput } from "../commands/StartInstancesCommand";
import { StartNetworkInsightsAccessScopeAnalysisCommandInput, StartNetworkInsightsAccessScopeAnalysisCommandOutput } from "../commands/StartNetworkInsightsAccessScopeAnalysisCommand";
import { StartNetworkInsightsAnalysisCommandInput, StartNetworkInsightsAnalysisCommandOutput } from "../commands/StartNetworkInsightsAnalysisCommand";
import { StartVpcEndpointServicePrivateDnsVerificationCommandInput, StartVpcEndpointServicePrivateDnsVerificationCommandOutput } from "../commands/StartVpcEndpointServicePrivateDnsVerificationCommand";
import { StopInstancesCommandInput, StopInstancesCommandOutput } from "../commands/StopInstancesCommand";
import { TerminateClientVpnConnectionsCommandInput, TerminateClientVpnConnectionsCommandOutput } from "../commands/TerminateClientVpnConnectionsCommand";
import { TerminateInstancesCommandInput, TerminateInstancesCommandOutput } from "../commands/TerminateInstancesCommand";
import { UnassignIpv6AddressesCommandInput, UnassignIpv6AddressesCommandOutput } from "../commands/UnassignIpv6AddressesCommand";
import { UnassignPrivateIpAddressesCommandInput, UnassignPrivateIpAddressesCommandOutput } from "../commands/UnassignPrivateIpAddressesCommand";
import { UnassignPrivateNatGatewayAddressCommandInput, UnassignPrivateNatGatewayAddressCommandOutput } from "../commands/UnassignPrivateNatGatewayAddressCommand";
import { UnlockSnapshotCommandInput, UnlockSnapshotCommandOutput } from "../commands/UnlockSnapshotCommand";
import { UnmonitorInstancesCommandInput, UnmonitorInstancesCommandOutput } from "../commands/UnmonitorInstancesCommand";
import { UpdateSecurityGroupRuleDescriptionsEgressCommandInput, UpdateSecurityGroupRuleDescriptionsEgressCommandOutput } from "../commands/UpdateSecurityGroupRuleDescriptionsEgressCommand";
import { UpdateSecurityGroupRuleDescriptionsIngressCommandInput, UpdateSecurityGroupRuleDescriptionsIngressCommandOutput } from "../commands/UpdateSecurityGroupRuleDescriptionsIngressCommand";
import { WithdrawByoipCidrCommandInput, WithdrawByoipCidrCommandOutput } from "../commands/WithdrawByoipCidrCommand";
/**
 * serializeAws_ec2AcceptAddressTransferCommand
 */
export declare const se_AcceptAddressTransferCommand: (input: AcceptAddressTransferCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AcceptReservedInstancesExchangeQuoteCommand
 */
export declare const se_AcceptReservedInstancesExchangeQuoteCommand: (input: AcceptReservedInstancesExchangeQuoteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AcceptTransitGatewayMulticastDomainAssociationsCommand
 */
export declare const se_AcceptTransitGatewayMulticastDomainAssociationsCommand: (input: AcceptTransitGatewayMulticastDomainAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AcceptTransitGatewayPeeringAttachmentCommand
 */
export declare const se_AcceptTransitGatewayPeeringAttachmentCommand: (input: AcceptTransitGatewayPeeringAttachmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AcceptTransitGatewayVpcAttachmentCommand
 */
export declare const se_AcceptTransitGatewayVpcAttachmentCommand: (input: AcceptTransitGatewayVpcAttachmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AcceptVpcEndpointConnectionsCommand
 */
export declare const se_AcceptVpcEndpointConnectionsCommand: (input: AcceptVpcEndpointConnectionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AcceptVpcPeeringConnectionCommand
 */
export declare const se_AcceptVpcPeeringConnectionCommand: (input: AcceptVpcPeeringConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AdvertiseByoipCidrCommand
 */
export declare const se_AdvertiseByoipCidrCommand: (input: AdvertiseByoipCidrCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AllocateAddressCommand
 */
export declare const se_AllocateAddressCommand: (input: AllocateAddressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AllocateHostsCommand
 */
export declare const se_AllocateHostsCommand: (input: AllocateHostsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AllocateIpamPoolCidrCommand
 */
export declare const se_AllocateIpamPoolCidrCommand: (input: AllocateIpamPoolCidrCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ApplySecurityGroupsToClientVpnTargetNetworkCommand
 */
export declare const se_ApplySecurityGroupsToClientVpnTargetNetworkCommand: (input: ApplySecurityGroupsToClientVpnTargetNetworkCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssignIpv6AddressesCommand
 */
export declare const se_AssignIpv6AddressesCommand: (input: AssignIpv6AddressesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssignPrivateIpAddressesCommand
 */
export declare const se_AssignPrivateIpAddressesCommand: (input: AssignPrivateIpAddressesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssignPrivateNatGatewayAddressCommand
 */
export declare const se_AssignPrivateNatGatewayAddressCommand: (input: AssignPrivateNatGatewayAddressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateAddressCommand
 */
export declare const se_AssociateAddressCommand: (input: AssociateAddressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateClientVpnTargetNetworkCommand
 */
export declare const se_AssociateClientVpnTargetNetworkCommand: (input: AssociateClientVpnTargetNetworkCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateDhcpOptionsCommand
 */
export declare const se_AssociateDhcpOptionsCommand: (input: AssociateDhcpOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateEnclaveCertificateIamRoleCommand
 */
export declare const se_AssociateEnclaveCertificateIamRoleCommand: (input: AssociateEnclaveCertificateIamRoleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateIamInstanceProfileCommand
 */
export declare const se_AssociateIamInstanceProfileCommand: (input: AssociateIamInstanceProfileCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateInstanceEventWindowCommand
 */
export declare const se_AssociateInstanceEventWindowCommand: (input: AssociateInstanceEventWindowCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateIpamByoasnCommand
 */
export declare const se_AssociateIpamByoasnCommand: (input: AssociateIpamByoasnCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateIpamResourceDiscoveryCommand
 */
export declare const se_AssociateIpamResourceDiscoveryCommand: (input: AssociateIpamResourceDiscoveryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateNatGatewayAddressCommand
 */
export declare const se_AssociateNatGatewayAddressCommand: (input: AssociateNatGatewayAddressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateRouteTableCommand
 */
export declare const se_AssociateRouteTableCommand: (input: AssociateRouteTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateSubnetCidrBlockCommand
 */
export declare const se_AssociateSubnetCidrBlockCommand: (input: AssociateSubnetCidrBlockCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateTransitGatewayMulticastDomainCommand
 */
export declare const se_AssociateTransitGatewayMulticastDomainCommand: (input: AssociateTransitGatewayMulticastDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateTransitGatewayPolicyTableCommand
 */
export declare const se_AssociateTransitGatewayPolicyTableCommand: (input: AssociateTransitGatewayPolicyTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateTransitGatewayRouteTableCommand
 */
export declare const se_AssociateTransitGatewayRouteTableCommand: (input: AssociateTransitGatewayRouteTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateTrunkInterfaceCommand
 */
export declare const se_AssociateTrunkInterfaceCommand: (input: AssociateTrunkInterfaceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AssociateVpcCidrBlockCommand
 */
export declare const se_AssociateVpcCidrBlockCommand: (input: AssociateVpcCidrBlockCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AttachClassicLinkVpcCommand
 */
export declare const se_AttachClassicLinkVpcCommand: (input: AttachClassicLinkVpcCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AttachInternetGatewayCommand
 */
export declare const se_AttachInternetGatewayCommand: (input: AttachInternetGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AttachNetworkInterfaceCommand
 */
export declare const se_AttachNetworkInterfaceCommand: (input: AttachNetworkInterfaceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AttachVerifiedAccessTrustProviderCommand
 */
export declare const se_AttachVerifiedAccessTrustProviderCommand: (input: AttachVerifiedAccessTrustProviderCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AttachVolumeCommand
 */
export declare const se_AttachVolumeCommand: (input: AttachVolumeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AttachVpnGatewayCommand
 */
export declare const se_AttachVpnGatewayCommand: (input: AttachVpnGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AuthorizeClientVpnIngressCommand
 */
export declare const se_AuthorizeClientVpnIngressCommand: (input: AuthorizeClientVpnIngressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AuthorizeSecurityGroupEgressCommand
 */
export declare const se_AuthorizeSecurityGroupEgressCommand: (input: AuthorizeSecurityGroupEgressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2AuthorizeSecurityGroupIngressCommand
 */
export declare const se_AuthorizeSecurityGroupIngressCommand: (input: AuthorizeSecurityGroupIngressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2BundleInstanceCommand
 */
export declare const se_BundleInstanceCommand: (input: BundleInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CancelBundleTaskCommand
 */
export declare const se_CancelBundleTaskCommand: (input: CancelBundleTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CancelCapacityReservationCommand
 */
export declare const se_CancelCapacityReservationCommand: (input: CancelCapacityReservationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CancelCapacityReservationFleetsCommand
 */
export declare const se_CancelCapacityReservationFleetsCommand: (input: CancelCapacityReservationFleetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CancelConversionTaskCommand
 */
export declare const se_CancelConversionTaskCommand: (input: CancelConversionTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CancelExportTaskCommand
 */
export declare const se_CancelExportTaskCommand: (input: CancelExportTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CancelImageLaunchPermissionCommand
 */
export declare const se_CancelImageLaunchPermissionCommand: (input: CancelImageLaunchPermissionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CancelImportTaskCommand
 */
export declare const se_CancelImportTaskCommand: (input: CancelImportTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CancelReservedInstancesListingCommand
 */
export declare const se_CancelReservedInstancesListingCommand: (input: CancelReservedInstancesListingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CancelSpotFleetRequestsCommand
 */
export declare const se_CancelSpotFleetRequestsCommand: (input: CancelSpotFleetRequestsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CancelSpotInstanceRequestsCommand
 */
export declare const se_CancelSpotInstanceRequestsCommand: (input: CancelSpotInstanceRequestsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ConfirmProductInstanceCommand
 */
export declare const se_ConfirmProductInstanceCommand: (input: ConfirmProductInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CopyFpgaImageCommand
 */
export declare const se_CopyFpgaImageCommand: (input: CopyFpgaImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CopyImageCommand
 */
export declare const se_CopyImageCommand: (input: CopyImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CopySnapshotCommand
 */
export declare const se_CopySnapshotCommand: (input: CopySnapshotCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateCapacityReservationCommand
 */
export declare const se_CreateCapacityReservationCommand: (input: CreateCapacityReservationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateCapacityReservationFleetCommand
 */
export declare const se_CreateCapacityReservationFleetCommand: (input: CreateCapacityReservationFleetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateCarrierGatewayCommand
 */
export declare const se_CreateCarrierGatewayCommand: (input: CreateCarrierGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateClientVpnEndpointCommand
 */
export declare const se_CreateClientVpnEndpointCommand: (input: CreateClientVpnEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateClientVpnRouteCommand
 */
export declare const se_CreateClientVpnRouteCommand: (input: CreateClientVpnRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateCoipCidrCommand
 */
export declare const se_CreateCoipCidrCommand: (input: CreateCoipCidrCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateCoipPoolCommand
 */
export declare const se_CreateCoipPoolCommand: (input: CreateCoipPoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateCustomerGatewayCommand
 */
export declare const se_CreateCustomerGatewayCommand: (input: CreateCustomerGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateDefaultSubnetCommand
 */
export declare const se_CreateDefaultSubnetCommand: (input: CreateDefaultSubnetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateDefaultVpcCommand
 */
export declare const se_CreateDefaultVpcCommand: (input: CreateDefaultVpcCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateDhcpOptionsCommand
 */
export declare const se_CreateDhcpOptionsCommand: (input: CreateDhcpOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateEgressOnlyInternetGatewayCommand
 */
export declare const se_CreateEgressOnlyInternetGatewayCommand: (input: CreateEgressOnlyInternetGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateFleetCommand
 */
export declare const se_CreateFleetCommand: (input: CreateFleetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateFlowLogsCommand
 */
export declare const se_CreateFlowLogsCommand: (input: CreateFlowLogsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateFpgaImageCommand
 */
export declare const se_CreateFpgaImageCommand: (input: CreateFpgaImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateImageCommand
 */
export declare const se_CreateImageCommand: (input: CreateImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateInstanceConnectEndpointCommand
 */
export declare const se_CreateInstanceConnectEndpointCommand: (input: CreateInstanceConnectEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateInstanceEventWindowCommand
 */
export declare const se_CreateInstanceEventWindowCommand: (input: CreateInstanceEventWindowCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateInstanceExportTaskCommand
 */
export declare const se_CreateInstanceExportTaskCommand: (input: CreateInstanceExportTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateInternetGatewayCommand
 */
export declare const se_CreateInternetGatewayCommand: (input: CreateInternetGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateIpamCommand
 */
export declare const se_CreateIpamCommand: (input: CreateIpamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateIpamPoolCommand
 */
export declare const se_CreateIpamPoolCommand: (input: CreateIpamPoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateIpamResourceDiscoveryCommand
 */
export declare const se_CreateIpamResourceDiscoveryCommand: (input: CreateIpamResourceDiscoveryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateIpamScopeCommand
 */
export declare const se_CreateIpamScopeCommand: (input: CreateIpamScopeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateKeyPairCommand
 */
export declare const se_CreateKeyPairCommand: (input: CreateKeyPairCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateLaunchTemplateCommand
 */
export declare const se_CreateLaunchTemplateCommand: (input: CreateLaunchTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateLaunchTemplateVersionCommand
 */
export declare const se_CreateLaunchTemplateVersionCommand: (input: CreateLaunchTemplateVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateLocalGatewayRouteCommand
 */
export declare const se_CreateLocalGatewayRouteCommand: (input: CreateLocalGatewayRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateLocalGatewayRouteTableCommand
 */
export declare const se_CreateLocalGatewayRouteTableCommand: (input: CreateLocalGatewayRouteTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommand
 */
export declare const se_CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommand: (input: CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateLocalGatewayRouteTableVpcAssociationCommand
 */
export declare const se_CreateLocalGatewayRouteTableVpcAssociationCommand: (input: CreateLocalGatewayRouteTableVpcAssociationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateManagedPrefixListCommand
 */
export declare const se_CreateManagedPrefixListCommand: (input: CreateManagedPrefixListCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateNatGatewayCommand
 */
export declare const se_CreateNatGatewayCommand: (input: CreateNatGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateNetworkAclCommand
 */
export declare const se_CreateNetworkAclCommand: (input: CreateNetworkAclCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateNetworkAclEntryCommand
 */
export declare const se_CreateNetworkAclEntryCommand: (input: CreateNetworkAclEntryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateNetworkInsightsAccessScopeCommand
 */
export declare const se_CreateNetworkInsightsAccessScopeCommand: (input: CreateNetworkInsightsAccessScopeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateNetworkInsightsPathCommand
 */
export declare const se_CreateNetworkInsightsPathCommand: (input: CreateNetworkInsightsPathCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateNetworkInterfaceCommand
 */
export declare const se_CreateNetworkInterfaceCommand: (input: CreateNetworkInterfaceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateNetworkInterfacePermissionCommand
 */
export declare const se_CreateNetworkInterfacePermissionCommand: (input: CreateNetworkInterfacePermissionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreatePlacementGroupCommand
 */
export declare const se_CreatePlacementGroupCommand: (input: CreatePlacementGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreatePublicIpv4PoolCommand
 */
export declare const se_CreatePublicIpv4PoolCommand: (input: CreatePublicIpv4PoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateReplaceRootVolumeTaskCommand
 */
export declare const se_CreateReplaceRootVolumeTaskCommand: (input: CreateReplaceRootVolumeTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateReservedInstancesListingCommand
 */
export declare const se_CreateReservedInstancesListingCommand: (input: CreateReservedInstancesListingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateRestoreImageTaskCommand
 */
export declare const se_CreateRestoreImageTaskCommand: (input: CreateRestoreImageTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateRouteCommand
 */
export declare const se_CreateRouteCommand: (input: CreateRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateRouteTableCommand
 */
export declare const se_CreateRouteTableCommand: (input: CreateRouteTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateSecurityGroupCommand
 */
export declare const se_CreateSecurityGroupCommand: (input: CreateSecurityGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateSnapshotCommand
 */
export declare const se_CreateSnapshotCommand: (input: CreateSnapshotCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateSnapshotsCommand
 */
export declare const se_CreateSnapshotsCommand: (input: CreateSnapshotsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateSpotDatafeedSubscriptionCommand
 */
export declare const se_CreateSpotDatafeedSubscriptionCommand: (input: CreateSpotDatafeedSubscriptionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateStoreImageTaskCommand
 */
export declare const se_CreateStoreImageTaskCommand: (input: CreateStoreImageTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateSubnetCommand
 */
export declare const se_CreateSubnetCommand: (input: CreateSubnetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateSubnetCidrReservationCommand
 */
export declare const se_CreateSubnetCidrReservationCommand: (input: CreateSubnetCidrReservationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTagsCommand
 */
export declare const se_CreateTagsCommand: (input: CreateTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTrafficMirrorFilterCommand
 */
export declare const se_CreateTrafficMirrorFilterCommand: (input: CreateTrafficMirrorFilterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTrafficMirrorFilterRuleCommand
 */
export declare const se_CreateTrafficMirrorFilterRuleCommand: (input: CreateTrafficMirrorFilterRuleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTrafficMirrorSessionCommand
 */
export declare const se_CreateTrafficMirrorSessionCommand: (input: CreateTrafficMirrorSessionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTrafficMirrorTargetCommand
 */
export declare const se_CreateTrafficMirrorTargetCommand: (input: CreateTrafficMirrorTargetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTransitGatewayCommand
 */
export declare const se_CreateTransitGatewayCommand: (input: CreateTransitGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTransitGatewayConnectCommand
 */
export declare const se_CreateTransitGatewayConnectCommand: (input: CreateTransitGatewayConnectCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTransitGatewayConnectPeerCommand
 */
export declare const se_CreateTransitGatewayConnectPeerCommand: (input: CreateTransitGatewayConnectPeerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTransitGatewayMulticastDomainCommand
 */
export declare const se_CreateTransitGatewayMulticastDomainCommand: (input: CreateTransitGatewayMulticastDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTransitGatewayPeeringAttachmentCommand
 */
export declare const se_CreateTransitGatewayPeeringAttachmentCommand: (input: CreateTransitGatewayPeeringAttachmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTransitGatewayPolicyTableCommand
 */
export declare const se_CreateTransitGatewayPolicyTableCommand: (input: CreateTransitGatewayPolicyTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTransitGatewayPrefixListReferenceCommand
 */
export declare const se_CreateTransitGatewayPrefixListReferenceCommand: (input: CreateTransitGatewayPrefixListReferenceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTransitGatewayRouteCommand
 */
export declare const se_CreateTransitGatewayRouteCommand: (input: CreateTransitGatewayRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTransitGatewayRouteTableCommand
 */
export declare const se_CreateTransitGatewayRouteTableCommand: (input: CreateTransitGatewayRouteTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTransitGatewayRouteTableAnnouncementCommand
 */
export declare const se_CreateTransitGatewayRouteTableAnnouncementCommand: (input: CreateTransitGatewayRouteTableAnnouncementCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateTransitGatewayVpcAttachmentCommand
 */
export declare const se_CreateTransitGatewayVpcAttachmentCommand: (input: CreateTransitGatewayVpcAttachmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVerifiedAccessEndpointCommand
 */
export declare const se_CreateVerifiedAccessEndpointCommand: (input: CreateVerifiedAccessEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVerifiedAccessGroupCommand
 */
export declare const se_CreateVerifiedAccessGroupCommand: (input: CreateVerifiedAccessGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVerifiedAccessInstanceCommand
 */
export declare const se_CreateVerifiedAccessInstanceCommand: (input: CreateVerifiedAccessInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVerifiedAccessTrustProviderCommand
 */
export declare const se_CreateVerifiedAccessTrustProviderCommand: (input: CreateVerifiedAccessTrustProviderCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVolumeCommand
 */
export declare const se_CreateVolumeCommand: (input: CreateVolumeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVpcCommand
 */
export declare const se_CreateVpcCommand: (input: CreateVpcCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVpcEndpointCommand
 */
export declare const se_CreateVpcEndpointCommand: (input: CreateVpcEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVpcEndpointConnectionNotificationCommand
 */
export declare const se_CreateVpcEndpointConnectionNotificationCommand: (input: CreateVpcEndpointConnectionNotificationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVpcEndpointServiceConfigurationCommand
 */
export declare const se_CreateVpcEndpointServiceConfigurationCommand: (input: CreateVpcEndpointServiceConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVpcPeeringConnectionCommand
 */
export declare const se_CreateVpcPeeringConnectionCommand: (input: CreateVpcPeeringConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVpnConnectionCommand
 */
export declare const se_CreateVpnConnectionCommand: (input: CreateVpnConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVpnConnectionRouteCommand
 */
export declare const se_CreateVpnConnectionRouteCommand: (input: CreateVpnConnectionRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2CreateVpnGatewayCommand
 */
export declare const se_CreateVpnGatewayCommand: (input: CreateVpnGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteCarrierGatewayCommand
 */
export declare const se_DeleteCarrierGatewayCommand: (input: DeleteCarrierGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteClientVpnEndpointCommand
 */
export declare const se_DeleteClientVpnEndpointCommand: (input: DeleteClientVpnEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteClientVpnRouteCommand
 */
export declare const se_DeleteClientVpnRouteCommand: (input: DeleteClientVpnRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteCoipCidrCommand
 */
export declare const se_DeleteCoipCidrCommand: (input: DeleteCoipCidrCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteCoipPoolCommand
 */
export declare const se_DeleteCoipPoolCommand: (input: DeleteCoipPoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteCustomerGatewayCommand
 */
export declare const se_DeleteCustomerGatewayCommand: (input: DeleteCustomerGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteDhcpOptionsCommand
 */
export declare const se_DeleteDhcpOptionsCommand: (input: DeleteDhcpOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteEgressOnlyInternetGatewayCommand
 */
export declare const se_DeleteEgressOnlyInternetGatewayCommand: (input: DeleteEgressOnlyInternetGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteFleetsCommand
 */
export declare const se_DeleteFleetsCommand: (input: DeleteFleetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteFlowLogsCommand
 */
export declare const se_DeleteFlowLogsCommand: (input: DeleteFlowLogsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteFpgaImageCommand
 */
export declare const se_DeleteFpgaImageCommand: (input: DeleteFpgaImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteInstanceConnectEndpointCommand
 */
export declare const se_DeleteInstanceConnectEndpointCommand: (input: DeleteInstanceConnectEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteInstanceEventWindowCommand
 */
export declare const se_DeleteInstanceEventWindowCommand: (input: DeleteInstanceEventWindowCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteInternetGatewayCommand
 */
export declare const se_DeleteInternetGatewayCommand: (input: DeleteInternetGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteIpamCommand
 */
export declare const se_DeleteIpamCommand: (input: DeleteIpamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteIpamPoolCommand
 */
export declare const se_DeleteIpamPoolCommand: (input: DeleteIpamPoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteIpamResourceDiscoveryCommand
 */
export declare const se_DeleteIpamResourceDiscoveryCommand: (input: DeleteIpamResourceDiscoveryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteIpamScopeCommand
 */
export declare const se_DeleteIpamScopeCommand: (input: DeleteIpamScopeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteKeyPairCommand
 */
export declare const se_DeleteKeyPairCommand: (input: DeleteKeyPairCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteLaunchTemplateCommand
 */
export declare const se_DeleteLaunchTemplateCommand: (input: DeleteLaunchTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteLaunchTemplateVersionsCommand
 */
export declare const se_DeleteLaunchTemplateVersionsCommand: (input: DeleteLaunchTemplateVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteLocalGatewayRouteCommand
 */
export declare const se_DeleteLocalGatewayRouteCommand: (input: DeleteLocalGatewayRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteLocalGatewayRouteTableCommand
 */
export declare const se_DeleteLocalGatewayRouteTableCommand: (input: DeleteLocalGatewayRouteTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommand
 */
export declare const se_DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommand: (input: DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteLocalGatewayRouteTableVpcAssociationCommand
 */
export declare const se_DeleteLocalGatewayRouteTableVpcAssociationCommand: (input: DeleteLocalGatewayRouteTableVpcAssociationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteManagedPrefixListCommand
 */
export declare const se_DeleteManagedPrefixListCommand: (input: DeleteManagedPrefixListCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteNatGatewayCommand
 */
export declare const se_DeleteNatGatewayCommand: (input: DeleteNatGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteNetworkAclCommand
 */
export declare const se_DeleteNetworkAclCommand: (input: DeleteNetworkAclCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteNetworkAclEntryCommand
 */
export declare const se_DeleteNetworkAclEntryCommand: (input: DeleteNetworkAclEntryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteNetworkInsightsAccessScopeCommand
 */
export declare const se_DeleteNetworkInsightsAccessScopeCommand: (input: DeleteNetworkInsightsAccessScopeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteNetworkInsightsAccessScopeAnalysisCommand
 */
export declare const se_DeleteNetworkInsightsAccessScopeAnalysisCommand: (input: DeleteNetworkInsightsAccessScopeAnalysisCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteNetworkInsightsAnalysisCommand
 */
export declare const se_DeleteNetworkInsightsAnalysisCommand: (input: DeleteNetworkInsightsAnalysisCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteNetworkInsightsPathCommand
 */
export declare const se_DeleteNetworkInsightsPathCommand: (input: DeleteNetworkInsightsPathCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteNetworkInterfaceCommand
 */
export declare const se_DeleteNetworkInterfaceCommand: (input: DeleteNetworkInterfaceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteNetworkInterfacePermissionCommand
 */
export declare const se_DeleteNetworkInterfacePermissionCommand: (input: DeleteNetworkInterfacePermissionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeletePlacementGroupCommand
 */
export declare const se_DeletePlacementGroupCommand: (input: DeletePlacementGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeletePublicIpv4PoolCommand
 */
export declare const se_DeletePublicIpv4PoolCommand: (input: DeletePublicIpv4PoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteQueuedReservedInstancesCommand
 */
export declare const se_DeleteQueuedReservedInstancesCommand: (input: DeleteQueuedReservedInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteRouteCommand
 */
export declare const se_DeleteRouteCommand: (input: DeleteRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteRouteTableCommand
 */
export declare const se_DeleteRouteTableCommand: (input: DeleteRouteTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteSecurityGroupCommand
 */
export declare const se_DeleteSecurityGroupCommand: (input: DeleteSecurityGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteSnapshotCommand
 */
export declare const se_DeleteSnapshotCommand: (input: DeleteSnapshotCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteSpotDatafeedSubscriptionCommand
 */
export declare const se_DeleteSpotDatafeedSubscriptionCommand: (input: DeleteSpotDatafeedSubscriptionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteSubnetCommand
 */
export declare const se_DeleteSubnetCommand: (input: DeleteSubnetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteSubnetCidrReservationCommand
 */
export declare const se_DeleteSubnetCidrReservationCommand: (input: DeleteSubnetCidrReservationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTagsCommand
 */
export declare const se_DeleteTagsCommand: (input: DeleteTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTrafficMirrorFilterCommand
 */
export declare const se_DeleteTrafficMirrorFilterCommand: (input: DeleteTrafficMirrorFilterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTrafficMirrorFilterRuleCommand
 */
export declare const se_DeleteTrafficMirrorFilterRuleCommand: (input: DeleteTrafficMirrorFilterRuleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTrafficMirrorSessionCommand
 */
export declare const se_DeleteTrafficMirrorSessionCommand: (input: DeleteTrafficMirrorSessionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTrafficMirrorTargetCommand
 */
export declare const se_DeleteTrafficMirrorTargetCommand: (input: DeleteTrafficMirrorTargetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTransitGatewayCommand
 */
export declare const se_DeleteTransitGatewayCommand: (input: DeleteTransitGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTransitGatewayConnectCommand
 */
export declare const se_DeleteTransitGatewayConnectCommand: (input: DeleteTransitGatewayConnectCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTransitGatewayConnectPeerCommand
 */
export declare const se_DeleteTransitGatewayConnectPeerCommand: (input: DeleteTransitGatewayConnectPeerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTransitGatewayMulticastDomainCommand
 */
export declare const se_DeleteTransitGatewayMulticastDomainCommand: (input: DeleteTransitGatewayMulticastDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTransitGatewayPeeringAttachmentCommand
 */
export declare const se_DeleteTransitGatewayPeeringAttachmentCommand: (input: DeleteTransitGatewayPeeringAttachmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTransitGatewayPolicyTableCommand
 */
export declare const se_DeleteTransitGatewayPolicyTableCommand: (input: DeleteTransitGatewayPolicyTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTransitGatewayPrefixListReferenceCommand
 */
export declare const se_DeleteTransitGatewayPrefixListReferenceCommand: (input: DeleteTransitGatewayPrefixListReferenceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTransitGatewayRouteCommand
 */
export declare const se_DeleteTransitGatewayRouteCommand: (input: DeleteTransitGatewayRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTransitGatewayRouteTableCommand
 */
export declare const se_DeleteTransitGatewayRouteTableCommand: (input: DeleteTransitGatewayRouteTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTransitGatewayRouteTableAnnouncementCommand
 */
export declare const se_DeleteTransitGatewayRouteTableAnnouncementCommand: (input: DeleteTransitGatewayRouteTableAnnouncementCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteTransitGatewayVpcAttachmentCommand
 */
export declare const se_DeleteTransitGatewayVpcAttachmentCommand: (input: DeleteTransitGatewayVpcAttachmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVerifiedAccessEndpointCommand
 */
export declare const se_DeleteVerifiedAccessEndpointCommand: (input: DeleteVerifiedAccessEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVerifiedAccessGroupCommand
 */
export declare const se_DeleteVerifiedAccessGroupCommand: (input: DeleteVerifiedAccessGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVerifiedAccessInstanceCommand
 */
export declare const se_DeleteVerifiedAccessInstanceCommand: (input: DeleteVerifiedAccessInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVerifiedAccessTrustProviderCommand
 */
export declare const se_DeleteVerifiedAccessTrustProviderCommand: (input: DeleteVerifiedAccessTrustProviderCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVolumeCommand
 */
export declare const se_DeleteVolumeCommand: (input: DeleteVolumeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVpcCommand
 */
export declare const se_DeleteVpcCommand: (input: DeleteVpcCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVpcEndpointConnectionNotificationsCommand
 */
export declare const se_DeleteVpcEndpointConnectionNotificationsCommand: (input: DeleteVpcEndpointConnectionNotificationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVpcEndpointsCommand
 */
export declare const se_DeleteVpcEndpointsCommand: (input: DeleteVpcEndpointsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVpcEndpointServiceConfigurationsCommand
 */
export declare const se_DeleteVpcEndpointServiceConfigurationsCommand: (input: DeleteVpcEndpointServiceConfigurationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVpcPeeringConnectionCommand
 */
export declare const se_DeleteVpcPeeringConnectionCommand: (input: DeleteVpcPeeringConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVpnConnectionCommand
 */
export declare const se_DeleteVpnConnectionCommand: (input: DeleteVpnConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVpnConnectionRouteCommand
 */
export declare const se_DeleteVpnConnectionRouteCommand: (input: DeleteVpnConnectionRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeleteVpnGatewayCommand
 */
export declare const se_DeleteVpnGatewayCommand: (input: DeleteVpnGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeprovisionByoipCidrCommand
 */
export declare const se_DeprovisionByoipCidrCommand: (input: DeprovisionByoipCidrCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeprovisionIpamByoasnCommand
 */
export declare const se_DeprovisionIpamByoasnCommand: (input: DeprovisionIpamByoasnCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeprovisionIpamPoolCidrCommand
 */
export declare const se_DeprovisionIpamPoolCidrCommand: (input: DeprovisionIpamPoolCidrCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeprovisionPublicIpv4PoolCidrCommand
 */
export declare const se_DeprovisionPublicIpv4PoolCidrCommand: (input: DeprovisionPublicIpv4PoolCidrCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeregisterImageCommand
 */
export declare const se_DeregisterImageCommand: (input: DeregisterImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeregisterInstanceEventNotificationAttributesCommand
 */
export declare const se_DeregisterInstanceEventNotificationAttributesCommand: (input: DeregisterInstanceEventNotificationAttributesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeregisterTransitGatewayMulticastGroupMembersCommand
 */
export declare const se_DeregisterTransitGatewayMulticastGroupMembersCommand: (input: DeregisterTransitGatewayMulticastGroupMembersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DeregisterTransitGatewayMulticastGroupSourcesCommand
 */
export declare const se_DeregisterTransitGatewayMulticastGroupSourcesCommand: (input: DeregisterTransitGatewayMulticastGroupSourcesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeAccountAttributesCommand
 */
export declare const se_DescribeAccountAttributesCommand: (input: DescribeAccountAttributesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeAddressesCommand
 */
export declare const se_DescribeAddressesCommand: (input: DescribeAddressesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeAddressesAttributeCommand
 */
export declare const se_DescribeAddressesAttributeCommand: (input: DescribeAddressesAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeAddressTransfersCommand
 */
export declare const se_DescribeAddressTransfersCommand: (input: DescribeAddressTransfersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeAggregateIdFormatCommand
 */
export declare const se_DescribeAggregateIdFormatCommand: (input: DescribeAggregateIdFormatCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeAvailabilityZonesCommand
 */
export declare const se_DescribeAvailabilityZonesCommand: (input: DescribeAvailabilityZonesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeAwsNetworkPerformanceMetricSubscriptionsCommand
 */
export declare const se_DescribeAwsNetworkPerformanceMetricSubscriptionsCommand: (input: DescribeAwsNetworkPerformanceMetricSubscriptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeBundleTasksCommand
 */
export declare const se_DescribeBundleTasksCommand: (input: DescribeBundleTasksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeByoipCidrsCommand
 */
export declare const se_DescribeByoipCidrsCommand: (input: DescribeByoipCidrsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeCapacityBlockOfferingsCommand
 */
export declare const se_DescribeCapacityBlockOfferingsCommand: (input: DescribeCapacityBlockOfferingsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeCapacityReservationFleetsCommand
 */
export declare const se_DescribeCapacityReservationFleetsCommand: (input: DescribeCapacityReservationFleetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeCapacityReservationsCommand
 */
export declare const se_DescribeCapacityReservationsCommand: (input: DescribeCapacityReservationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeCarrierGatewaysCommand
 */
export declare const se_DescribeCarrierGatewaysCommand: (input: DescribeCarrierGatewaysCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeClassicLinkInstancesCommand
 */
export declare const se_DescribeClassicLinkInstancesCommand: (input: DescribeClassicLinkInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeClientVpnAuthorizationRulesCommand
 */
export declare const se_DescribeClientVpnAuthorizationRulesCommand: (input: DescribeClientVpnAuthorizationRulesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeClientVpnConnectionsCommand
 */
export declare const se_DescribeClientVpnConnectionsCommand: (input: DescribeClientVpnConnectionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeClientVpnEndpointsCommand
 */
export declare const se_DescribeClientVpnEndpointsCommand: (input: DescribeClientVpnEndpointsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeClientVpnRoutesCommand
 */
export declare const se_DescribeClientVpnRoutesCommand: (input: DescribeClientVpnRoutesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeClientVpnTargetNetworksCommand
 */
export declare const se_DescribeClientVpnTargetNetworksCommand: (input: DescribeClientVpnTargetNetworksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeCoipPoolsCommand
 */
export declare const se_DescribeCoipPoolsCommand: (input: DescribeCoipPoolsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeConversionTasksCommand
 */
export declare const se_DescribeConversionTasksCommand: (input: DescribeConversionTasksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeCustomerGatewaysCommand
 */
export declare const se_DescribeCustomerGatewaysCommand: (input: DescribeCustomerGatewaysCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeDhcpOptionsCommand
 */
export declare const se_DescribeDhcpOptionsCommand: (input: DescribeDhcpOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeEgressOnlyInternetGatewaysCommand
 */
export declare const se_DescribeEgressOnlyInternetGatewaysCommand: (input: DescribeEgressOnlyInternetGatewaysCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeElasticGpusCommand
 */
export declare const se_DescribeElasticGpusCommand: (input: DescribeElasticGpusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeExportImageTasksCommand
 */
export declare const se_DescribeExportImageTasksCommand: (input: DescribeExportImageTasksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeExportTasksCommand
 */
export declare const se_DescribeExportTasksCommand: (input: DescribeExportTasksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeFastLaunchImagesCommand
 */
export declare const se_DescribeFastLaunchImagesCommand: (input: DescribeFastLaunchImagesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeFastSnapshotRestoresCommand
 */
export declare const se_DescribeFastSnapshotRestoresCommand: (input: DescribeFastSnapshotRestoresCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeFleetHistoryCommand
 */
export declare const se_DescribeFleetHistoryCommand: (input: DescribeFleetHistoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeFleetInstancesCommand
 */
export declare const se_DescribeFleetInstancesCommand: (input: DescribeFleetInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeFleetsCommand
 */
export declare const se_DescribeFleetsCommand: (input: DescribeFleetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeFlowLogsCommand
 */
export declare const se_DescribeFlowLogsCommand: (input: DescribeFlowLogsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeFpgaImageAttributeCommand
 */
export declare const se_DescribeFpgaImageAttributeCommand: (input: DescribeFpgaImageAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeFpgaImagesCommand
 */
export declare const se_DescribeFpgaImagesCommand: (input: DescribeFpgaImagesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeHostReservationOfferingsCommand
 */
export declare const se_DescribeHostReservationOfferingsCommand: (input: DescribeHostReservationOfferingsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeHostReservationsCommand
 */
export declare const se_DescribeHostReservationsCommand: (input: DescribeHostReservationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeHostsCommand
 */
export declare const se_DescribeHostsCommand: (input: DescribeHostsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeIamInstanceProfileAssociationsCommand
 */
export declare const se_DescribeIamInstanceProfileAssociationsCommand: (input: DescribeIamInstanceProfileAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeIdentityIdFormatCommand
 */
export declare const se_DescribeIdentityIdFormatCommand: (input: DescribeIdentityIdFormatCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeIdFormatCommand
 */
export declare const se_DescribeIdFormatCommand: (input: DescribeIdFormatCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeImageAttributeCommand
 */
export declare const se_DescribeImageAttributeCommand: (input: DescribeImageAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeImagesCommand
 */
export declare const se_DescribeImagesCommand: (input: DescribeImagesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeImportImageTasksCommand
 */
export declare const se_DescribeImportImageTasksCommand: (input: DescribeImportImageTasksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeImportSnapshotTasksCommand
 */
export declare const se_DescribeImportSnapshotTasksCommand: (input: DescribeImportSnapshotTasksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeInstanceAttributeCommand
 */
export declare const se_DescribeInstanceAttributeCommand: (input: DescribeInstanceAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeInstanceConnectEndpointsCommand
 */
export declare const se_DescribeInstanceConnectEndpointsCommand: (input: DescribeInstanceConnectEndpointsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeInstanceCreditSpecificationsCommand
 */
export declare const se_DescribeInstanceCreditSpecificationsCommand: (input: DescribeInstanceCreditSpecificationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeInstanceEventNotificationAttributesCommand
 */
export declare const se_DescribeInstanceEventNotificationAttributesCommand: (input: DescribeInstanceEventNotificationAttributesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeInstanceEventWindowsCommand
 */
export declare const se_DescribeInstanceEventWindowsCommand: (input: DescribeInstanceEventWindowsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeInstancesCommand
 */
export declare const se_DescribeInstancesCommand: (input: DescribeInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeInstanceStatusCommand
 */
export declare const se_DescribeInstanceStatusCommand: (input: DescribeInstanceStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeInstanceTopologyCommand
 */
export declare const se_DescribeInstanceTopologyCommand: (input: DescribeInstanceTopologyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeInstanceTypeOfferingsCommand
 */
export declare const se_DescribeInstanceTypeOfferingsCommand: (input: DescribeInstanceTypeOfferingsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeInstanceTypesCommand
 */
export declare const se_DescribeInstanceTypesCommand: (input: DescribeInstanceTypesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeInternetGatewaysCommand
 */
export declare const se_DescribeInternetGatewaysCommand: (input: DescribeInternetGatewaysCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeIpamByoasnCommand
 */
export declare const se_DescribeIpamByoasnCommand: (input: DescribeIpamByoasnCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeIpamPoolsCommand
 */
export declare const se_DescribeIpamPoolsCommand: (input: DescribeIpamPoolsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeIpamResourceDiscoveriesCommand
 */
export declare const se_DescribeIpamResourceDiscoveriesCommand: (input: DescribeIpamResourceDiscoveriesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeIpamResourceDiscoveryAssociationsCommand
 */
export declare const se_DescribeIpamResourceDiscoveryAssociationsCommand: (input: DescribeIpamResourceDiscoveryAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeIpamsCommand
 */
export declare const se_DescribeIpamsCommand: (input: DescribeIpamsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeIpamScopesCommand
 */
export declare const se_DescribeIpamScopesCommand: (input: DescribeIpamScopesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeIpv6PoolsCommand
 */
export declare const se_DescribeIpv6PoolsCommand: (input: DescribeIpv6PoolsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeKeyPairsCommand
 */
export declare const se_DescribeKeyPairsCommand: (input: DescribeKeyPairsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeLaunchTemplatesCommand
 */
export declare const se_DescribeLaunchTemplatesCommand: (input: DescribeLaunchTemplatesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeLaunchTemplateVersionsCommand
 */
export declare const se_DescribeLaunchTemplateVersionsCommand: (input: DescribeLaunchTemplateVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeLocalGatewayRouteTablesCommand
 */
export declare const se_DescribeLocalGatewayRouteTablesCommand: (input: DescribeLocalGatewayRouteTablesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsCommand
 */
export declare const se_DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsCommand: (input: DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeLocalGatewayRouteTableVpcAssociationsCommand
 */
export declare const se_DescribeLocalGatewayRouteTableVpcAssociationsCommand: (input: DescribeLocalGatewayRouteTableVpcAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeLocalGatewaysCommand
 */
export declare const se_DescribeLocalGatewaysCommand: (input: DescribeLocalGatewaysCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeLocalGatewayVirtualInterfaceGroupsCommand
 */
export declare const se_DescribeLocalGatewayVirtualInterfaceGroupsCommand: (input: DescribeLocalGatewayVirtualInterfaceGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeLocalGatewayVirtualInterfacesCommand
 */
export declare const se_DescribeLocalGatewayVirtualInterfacesCommand: (input: DescribeLocalGatewayVirtualInterfacesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeLockedSnapshotsCommand
 */
export declare const se_DescribeLockedSnapshotsCommand: (input: DescribeLockedSnapshotsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeMacHostsCommand
 */
export declare const se_DescribeMacHostsCommand: (input: DescribeMacHostsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeManagedPrefixListsCommand
 */
export declare const se_DescribeManagedPrefixListsCommand: (input: DescribeManagedPrefixListsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeMovingAddressesCommand
 */
export declare const se_DescribeMovingAddressesCommand: (input: DescribeMovingAddressesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeNatGatewaysCommand
 */
export declare const se_DescribeNatGatewaysCommand: (input: DescribeNatGatewaysCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeNetworkAclsCommand
 */
export declare const se_DescribeNetworkAclsCommand: (input: DescribeNetworkAclsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeNetworkInsightsAccessScopeAnalysesCommand
 */
export declare const se_DescribeNetworkInsightsAccessScopeAnalysesCommand: (input: DescribeNetworkInsightsAccessScopeAnalysesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeNetworkInsightsAccessScopesCommand
 */
export declare const se_DescribeNetworkInsightsAccessScopesCommand: (input: DescribeNetworkInsightsAccessScopesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeNetworkInsightsAnalysesCommand
 */
export declare const se_DescribeNetworkInsightsAnalysesCommand: (input: DescribeNetworkInsightsAnalysesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeNetworkInsightsPathsCommand
 */
export declare const se_DescribeNetworkInsightsPathsCommand: (input: DescribeNetworkInsightsPathsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeNetworkInterfaceAttributeCommand
 */
export declare const se_DescribeNetworkInterfaceAttributeCommand: (input: DescribeNetworkInterfaceAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeNetworkInterfacePermissionsCommand
 */
export declare const se_DescribeNetworkInterfacePermissionsCommand: (input: DescribeNetworkInterfacePermissionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeNetworkInterfacesCommand
 */
export declare const se_DescribeNetworkInterfacesCommand: (input: DescribeNetworkInterfacesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribePlacementGroupsCommand
 */
export declare const se_DescribePlacementGroupsCommand: (input: DescribePlacementGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribePrefixListsCommand
 */
export declare const se_DescribePrefixListsCommand: (input: DescribePrefixListsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribePrincipalIdFormatCommand
 */
export declare const se_DescribePrincipalIdFormatCommand: (input: DescribePrincipalIdFormatCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribePublicIpv4PoolsCommand
 */
export declare const se_DescribePublicIpv4PoolsCommand: (input: DescribePublicIpv4PoolsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeRegionsCommand
 */
export declare const se_DescribeRegionsCommand: (input: DescribeRegionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeReplaceRootVolumeTasksCommand
 */
export declare const se_DescribeReplaceRootVolumeTasksCommand: (input: DescribeReplaceRootVolumeTasksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeReservedInstancesCommand
 */
export declare const se_DescribeReservedInstancesCommand: (input: DescribeReservedInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeReservedInstancesListingsCommand
 */
export declare const se_DescribeReservedInstancesListingsCommand: (input: DescribeReservedInstancesListingsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeReservedInstancesModificationsCommand
 */
export declare const se_DescribeReservedInstancesModificationsCommand: (input: DescribeReservedInstancesModificationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeReservedInstancesOfferingsCommand
 */
export declare const se_DescribeReservedInstancesOfferingsCommand: (input: DescribeReservedInstancesOfferingsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeRouteTablesCommand
 */
export declare const se_DescribeRouteTablesCommand: (input: DescribeRouteTablesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeScheduledInstanceAvailabilityCommand
 */
export declare const se_DescribeScheduledInstanceAvailabilityCommand: (input: DescribeScheduledInstanceAvailabilityCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeScheduledInstancesCommand
 */
export declare const se_DescribeScheduledInstancesCommand: (input: DescribeScheduledInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSecurityGroupReferencesCommand
 */
export declare const se_DescribeSecurityGroupReferencesCommand: (input: DescribeSecurityGroupReferencesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSecurityGroupRulesCommand
 */
export declare const se_DescribeSecurityGroupRulesCommand: (input: DescribeSecurityGroupRulesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSecurityGroupsCommand
 */
export declare const se_DescribeSecurityGroupsCommand: (input: DescribeSecurityGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSnapshotAttributeCommand
 */
export declare const se_DescribeSnapshotAttributeCommand: (input: DescribeSnapshotAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSnapshotsCommand
 */
export declare const se_DescribeSnapshotsCommand: (input: DescribeSnapshotsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSnapshotTierStatusCommand
 */
export declare const se_DescribeSnapshotTierStatusCommand: (input: DescribeSnapshotTierStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSpotDatafeedSubscriptionCommand
 */
export declare const se_DescribeSpotDatafeedSubscriptionCommand: (input: DescribeSpotDatafeedSubscriptionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSpotFleetInstancesCommand
 */
export declare const se_DescribeSpotFleetInstancesCommand: (input: DescribeSpotFleetInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSpotFleetRequestHistoryCommand
 */
export declare const se_DescribeSpotFleetRequestHistoryCommand: (input: DescribeSpotFleetRequestHistoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSpotFleetRequestsCommand
 */
export declare const se_DescribeSpotFleetRequestsCommand: (input: DescribeSpotFleetRequestsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSpotInstanceRequestsCommand
 */
export declare const se_DescribeSpotInstanceRequestsCommand: (input: DescribeSpotInstanceRequestsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSpotPriceHistoryCommand
 */
export declare const se_DescribeSpotPriceHistoryCommand: (input: DescribeSpotPriceHistoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeStaleSecurityGroupsCommand
 */
export declare const se_DescribeStaleSecurityGroupsCommand: (input: DescribeStaleSecurityGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeStoreImageTasksCommand
 */
export declare const se_DescribeStoreImageTasksCommand: (input: DescribeStoreImageTasksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeSubnetsCommand
 */
export declare const se_DescribeSubnetsCommand: (input: DescribeSubnetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTagsCommand
 */
export declare const se_DescribeTagsCommand: (input: DescribeTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTrafficMirrorFiltersCommand
 */
export declare const se_DescribeTrafficMirrorFiltersCommand: (input: DescribeTrafficMirrorFiltersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTrafficMirrorSessionsCommand
 */
export declare const se_DescribeTrafficMirrorSessionsCommand: (input: DescribeTrafficMirrorSessionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTrafficMirrorTargetsCommand
 */
export declare const se_DescribeTrafficMirrorTargetsCommand: (input: DescribeTrafficMirrorTargetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTransitGatewayAttachmentsCommand
 */
export declare const se_DescribeTransitGatewayAttachmentsCommand: (input: DescribeTransitGatewayAttachmentsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTransitGatewayConnectPeersCommand
 */
export declare const se_DescribeTransitGatewayConnectPeersCommand: (input: DescribeTransitGatewayConnectPeersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTransitGatewayConnectsCommand
 */
export declare const se_DescribeTransitGatewayConnectsCommand: (input: DescribeTransitGatewayConnectsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTransitGatewayMulticastDomainsCommand
 */
export declare const se_DescribeTransitGatewayMulticastDomainsCommand: (input: DescribeTransitGatewayMulticastDomainsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTransitGatewayPeeringAttachmentsCommand
 */
export declare const se_DescribeTransitGatewayPeeringAttachmentsCommand: (input: DescribeTransitGatewayPeeringAttachmentsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTransitGatewayPolicyTablesCommand
 */
export declare const se_DescribeTransitGatewayPolicyTablesCommand: (input: DescribeTransitGatewayPolicyTablesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTransitGatewayRouteTableAnnouncementsCommand
 */
export declare const se_DescribeTransitGatewayRouteTableAnnouncementsCommand: (input: DescribeTransitGatewayRouteTableAnnouncementsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTransitGatewayRouteTablesCommand
 */
export declare const se_DescribeTransitGatewayRouteTablesCommand: (input: DescribeTransitGatewayRouteTablesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTransitGatewaysCommand
 */
export declare const se_DescribeTransitGatewaysCommand: (input: DescribeTransitGatewaysCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTransitGatewayVpcAttachmentsCommand
 */
export declare const se_DescribeTransitGatewayVpcAttachmentsCommand: (input: DescribeTransitGatewayVpcAttachmentsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeTrunkInterfaceAssociationsCommand
 */
export declare const se_DescribeTrunkInterfaceAssociationsCommand: (input: DescribeTrunkInterfaceAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVerifiedAccessEndpointsCommand
 */
export declare const se_DescribeVerifiedAccessEndpointsCommand: (input: DescribeVerifiedAccessEndpointsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVerifiedAccessGroupsCommand
 */
export declare const se_DescribeVerifiedAccessGroupsCommand: (input: DescribeVerifiedAccessGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVerifiedAccessInstanceLoggingConfigurationsCommand
 */
export declare const se_DescribeVerifiedAccessInstanceLoggingConfigurationsCommand: (input: DescribeVerifiedAccessInstanceLoggingConfigurationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVerifiedAccessInstancesCommand
 */
export declare const se_DescribeVerifiedAccessInstancesCommand: (input: DescribeVerifiedAccessInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVerifiedAccessTrustProvidersCommand
 */
export declare const se_DescribeVerifiedAccessTrustProvidersCommand: (input: DescribeVerifiedAccessTrustProvidersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVolumeAttributeCommand
 */
export declare const se_DescribeVolumeAttributeCommand: (input: DescribeVolumeAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVolumesCommand
 */
export declare const se_DescribeVolumesCommand: (input: DescribeVolumesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVolumesModificationsCommand
 */
export declare const se_DescribeVolumesModificationsCommand: (input: DescribeVolumesModificationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVolumeStatusCommand
 */
export declare const se_DescribeVolumeStatusCommand: (input: DescribeVolumeStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpcAttributeCommand
 */
export declare const se_DescribeVpcAttributeCommand: (input: DescribeVpcAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpcClassicLinkCommand
 */
export declare const se_DescribeVpcClassicLinkCommand: (input: DescribeVpcClassicLinkCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpcClassicLinkDnsSupportCommand
 */
export declare const se_DescribeVpcClassicLinkDnsSupportCommand: (input: DescribeVpcClassicLinkDnsSupportCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpcEndpointConnectionNotificationsCommand
 */
export declare const se_DescribeVpcEndpointConnectionNotificationsCommand: (input: DescribeVpcEndpointConnectionNotificationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpcEndpointConnectionsCommand
 */
export declare const se_DescribeVpcEndpointConnectionsCommand: (input: DescribeVpcEndpointConnectionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpcEndpointsCommand
 */
export declare const se_DescribeVpcEndpointsCommand: (input: DescribeVpcEndpointsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpcEndpointServiceConfigurationsCommand
 */
export declare const se_DescribeVpcEndpointServiceConfigurationsCommand: (input: DescribeVpcEndpointServiceConfigurationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpcEndpointServicePermissionsCommand
 */
export declare const se_DescribeVpcEndpointServicePermissionsCommand: (input: DescribeVpcEndpointServicePermissionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpcEndpointServicesCommand
 */
export declare const se_DescribeVpcEndpointServicesCommand: (input: DescribeVpcEndpointServicesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpcPeeringConnectionsCommand
 */
export declare const se_DescribeVpcPeeringConnectionsCommand: (input: DescribeVpcPeeringConnectionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpcsCommand
 */
export declare const se_DescribeVpcsCommand: (input: DescribeVpcsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpnConnectionsCommand
 */
export declare const se_DescribeVpnConnectionsCommand: (input: DescribeVpnConnectionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DescribeVpnGatewaysCommand
 */
export declare const se_DescribeVpnGatewaysCommand: (input: DescribeVpnGatewaysCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DetachClassicLinkVpcCommand
 */
export declare const se_DetachClassicLinkVpcCommand: (input: DetachClassicLinkVpcCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DetachInternetGatewayCommand
 */
export declare const se_DetachInternetGatewayCommand: (input: DetachInternetGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DetachNetworkInterfaceCommand
 */
export declare const se_DetachNetworkInterfaceCommand: (input: DetachNetworkInterfaceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DetachVerifiedAccessTrustProviderCommand
 */
export declare const se_DetachVerifiedAccessTrustProviderCommand: (input: DetachVerifiedAccessTrustProviderCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DetachVolumeCommand
 */
export declare const se_DetachVolumeCommand: (input: DetachVolumeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DetachVpnGatewayCommand
 */
export declare const se_DetachVpnGatewayCommand: (input: DetachVpnGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableAddressTransferCommand
 */
export declare const se_DisableAddressTransferCommand: (input: DisableAddressTransferCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableAwsNetworkPerformanceMetricSubscriptionCommand
 */
export declare const se_DisableAwsNetworkPerformanceMetricSubscriptionCommand: (input: DisableAwsNetworkPerformanceMetricSubscriptionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableEbsEncryptionByDefaultCommand
 */
export declare const se_DisableEbsEncryptionByDefaultCommand: (input: DisableEbsEncryptionByDefaultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableFastLaunchCommand
 */
export declare const se_DisableFastLaunchCommand: (input: DisableFastLaunchCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableFastSnapshotRestoresCommand
 */
export declare const se_DisableFastSnapshotRestoresCommand: (input: DisableFastSnapshotRestoresCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableImageCommand
 */
export declare const se_DisableImageCommand: (input: DisableImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableImageBlockPublicAccessCommand
 */
export declare const se_DisableImageBlockPublicAccessCommand: (input: DisableImageBlockPublicAccessCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableImageDeprecationCommand
 */
export declare const se_DisableImageDeprecationCommand: (input: DisableImageDeprecationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableIpamOrganizationAdminAccountCommand
 */
export declare const se_DisableIpamOrganizationAdminAccountCommand: (input: DisableIpamOrganizationAdminAccountCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableSerialConsoleAccessCommand
 */
export declare const se_DisableSerialConsoleAccessCommand: (input: DisableSerialConsoleAccessCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableSnapshotBlockPublicAccessCommand
 */
export declare const se_DisableSnapshotBlockPublicAccessCommand: (input: DisableSnapshotBlockPublicAccessCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableTransitGatewayRouteTablePropagationCommand
 */
export declare const se_DisableTransitGatewayRouteTablePropagationCommand: (input: DisableTransitGatewayRouteTablePropagationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableVgwRoutePropagationCommand
 */
export declare const se_DisableVgwRoutePropagationCommand: (input: DisableVgwRoutePropagationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableVpcClassicLinkCommand
 */
export declare const se_DisableVpcClassicLinkCommand: (input: DisableVpcClassicLinkCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisableVpcClassicLinkDnsSupportCommand
 */
export declare const se_DisableVpcClassicLinkDnsSupportCommand: (input: DisableVpcClassicLinkDnsSupportCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateAddressCommand
 */
export declare const se_DisassociateAddressCommand: (input: DisassociateAddressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateClientVpnTargetNetworkCommand
 */
export declare const se_DisassociateClientVpnTargetNetworkCommand: (input: DisassociateClientVpnTargetNetworkCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateEnclaveCertificateIamRoleCommand
 */
export declare const se_DisassociateEnclaveCertificateIamRoleCommand: (input: DisassociateEnclaveCertificateIamRoleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateIamInstanceProfileCommand
 */
export declare const se_DisassociateIamInstanceProfileCommand: (input: DisassociateIamInstanceProfileCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateInstanceEventWindowCommand
 */
export declare const se_DisassociateInstanceEventWindowCommand: (input: DisassociateInstanceEventWindowCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateIpamByoasnCommand
 */
export declare const se_DisassociateIpamByoasnCommand: (input: DisassociateIpamByoasnCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateIpamResourceDiscoveryCommand
 */
export declare const se_DisassociateIpamResourceDiscoveryCommand: (input: DisassociateIpamResourceDiscoveryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateNatGatewayAddressCommand
 */
export declare const se_DisassociateNatGatewayAddressCommand: (input: DisassociateNatGatewayAddressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateRouteTableCommand
 */
export declare const se_DisassociateRouteTableCommand: (input: DisassociateRouteTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateSubnetCidrBlockCommand
 */
export declare const se_DisassociateSubnetCidrBlockCommand: (input: DisassociateSubnetCidrBlockCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateTransitGatewayMulticastDomainCommand
 */
export declare const se_DisassociateTransitGatewayMulticastDomainCommand: (input: DisassociateTransitGatewayMulticastDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateTransitGatewayPolicyTableCommand
 */
export declare const se_DisassociateTransitGatewayPolicyTableCommand: (input: DisassociateTransitGatewayPolicyTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateTransitGatewayRouteTableCommand
 */
export declare const se_DisassociateTransitGatewayRouteTableCommand: (input: DisassociateTransitGatewayRouteTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateTrunkInterfaceCommand
 */
export declare const se_DisassociateTrunkInterfaceCommand: (input: DisassociateTrunkInterfaceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2DisassociateVpcCidrBlockCommand
 */
export declare const se_DisassociateVpcCidrBlockCommand: (input: DisassociateVpcCidrBlockCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableAddressTransferCommand
 */
export declare const se_EnableAddressTransferCommand: (input: EnableAddressTransferCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableAwsNetworkPerformanceMetricSubscriptionCommand
 */
export declare const se_EnableAwsNetworkPerformanceMetricSubscriptionCommand: (input: EnableAwsNetworkPerformanceMetricSubscriptionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableEbsEncryptionByDefaultCommand
 */
export declare const se_EnableEbsEncryptionByDefaultCommand: (input: EnableEbsEncryptionByDefaultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableFastLaunchCommand
 */
export declare const se_EnableFastLaunchCommand: (input: EnableFastLaunchCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableFastSnapshotRestoresCommand
 */
export declare const se_EnableFastSnapshotRestoresCommand: (input: EnableFastSnapshotRestoresCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableImageCommand
 */
export declare const se_EnableImageCommand: (input: EnableImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableImageBlockPublicAccessCommand
 */
export declare const se_EnableImageBlockPublicAccessCommand: (input: EnableImageBlockPublicAccessCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableImageDeprecationCommand
 */
export declare const se_EnableImageDeprecationCommand: (input: EnableImageDeprecationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableIpamOrganizationAdminAccountCommand
 */
export declare const se_EnableIpamOrganizationAdminAccountCommand: (input: EnableIpamOrganizationAdminAccountCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableReachabilityAnalyzerOrganizationSharingCommand
 */
export declare const se_EnableReachabilityAnalyzerOrganizationSharingCommand: (input: EnableReachabilityAnalyzerOrganizationSharingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableSerialConsoleAccessCommand
 */
export declare const se_EnableSerialConsoleAccessCommand: (input: EnableSerialConsoleAccessCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableSnapshotBlockPublicAccessCommand
 */
export declare const se_EnableSnapshotBlockPublicAccessCommand: (input: EnableSnapshotBlockPublicAccessCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableTransitGatewayRouteTablePropagationCommand
 */
export declare const se_EnableTransitGatewayRouteTablePropagationCommand: (input: EnableTransitGatewayRouteTablePropagationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableVgwRoutePropagationCommand
 */
export declare const se_EnableVgwRoutePropagationCommand: (input: EnableVgwRoutePropagationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableVolumeIOCommand
 */
export declare const se_EnableVolumeIOCommand: (input: EnableVolumeIOCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableVpcClassicLinkCommand
 */
export declare const se_EnableVpcClassicLinkCommand: (input: EnableVpcClassicLinkCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2EnableVpcClassicLinkDnsSupportCommand
 */
export declare const se_EnableVpcClassicLinkDnsSupportCommand: (input: EnableVpcClassicLinkDnsSupportCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ExportClientVpnClientCertificateRevocationListCommand
 */
export declare const se_ExportClientVpnClientCertificateRevocationListCommand: (input: ExportClientVpnClientCertificateRevocationListCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ExportClientVpnClientConfigurationCommand
 */
export declare const se_ExportClientVpnClientConfigurationCommand: (input: ExportClientVpnClientConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ExportImageCommand
 */
export declare const se_ExportImageCommand: (input: ExportImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ExportTransitGatewayRoutesCommand
 */
export declare const se_ExportTransitGatewayRoutesCommand: (input: ExportTransitGatewayRoutesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetAssociatedEnclaveCertificateIamRolesCommand
 */
export declare const se_GetAssociatedEnclaveCertificateIamRolesCommand: (input: GetAssociatedEnclaveCertificateIamRolesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetAssociatedIpv6PoolCidrsCommand
 */
export declare const se_GetAssociatedIpv6PoolCidrsCommand: (input: GetAssociatedIpv6PoolCidrsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetAwsNetworkPerformanceDataCommand
 */
export declare const se_GetAwsNetworkPerformanceDataCommand: (input: GetAwsNetworkPerformanceDataCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetCapacityReservationUsageCommand
 */
export declare const se_GetCapacityReservationUsageCommand: (input: GetCapacityReservationUsageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetCoipPoolUsageCommand
 */
export declare const se_GetCoipPoolUsageCommand: (input: GetCoipPoolUsageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetConsoleOutputCommand
 */
export declare const se_GetConsoleOutputCommand: (input: GetConsoleOutputCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetConsoleScreenshotCommand
 */
export declare const se_GetConsoleScreenshotCommand: (input: GetConsoleScreenshotCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetDefaultCreditSpecificationCommand
 */
export declare const se_GetDefaultCreditSpecificationCommand: (input: GetDefaultCreditSpecificationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetEbsDefaultKmsKeyIdCommand
 */
export declare const se_GetEbsDefaultKmsKeyIdCommand: (input: GetEbsDefaultKmsKeyIdCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetEbsEncryptionByDefaultCommand
 */
export declare const se_GetEbsEncryptionByDefaultCommand: (input: GetEbsEncryptionByDefaultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetFlowLogsIntegrationTemplateCommand
 */
export declare const se_GetFlowLogsIntegrationTemplateCommand: (input: GetFlowLogsIntegrationTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetGroupsForCapacityReservationCommand
 */
export declare const se_GetGroupsForCapacityReservationCommand: (input: GetGroupsForCapacityReservationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetHostReservationPurchasePreviewCommand
 */
export declare const se_GetHostReservationPurchasePreviewCommand: (input: GetHostReservationPurchasePreviewCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetImageBlockPublicAccessStateCommand
 */
export declare const se_GetImageBlockPublicAccessStateCommand: (input: GetImageBlockPublicAccessStateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetInstanceMetadataDefaultsCommand
 */
export declare const se_GetInstanceMetadataDefaultsCommand: (input: GetInstanceMetadataDefaultsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetInstanceTypesFromInstanceRequirementsCommand
 */
export declare const se_GetInstanceTypesFromInstanceRequirementsCommand: (input: GetInstanceTypesFromInstanceRequirementsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetInstanceUefiDataCommand
 */
export declare const se_GetInstanceUefiDataCommand: (input: GetInstanceUefiDataCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetIpamAddressHistoryCommand
 */
export declare const se_GetIpamAddressHistoryCommand: (input: GetIpamAddressHistoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetIpamDiscoveredAccountsCommand
 */
export declare const se_GetIpamDiscoveredAccountsCommand: (input: GetIpamDiscoveredAccountsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetIpamDiscoveredPublicAddressesCommand
 */
export declare const se_GetIpamDiscoveredPublicAddressesCommand: (input: GetIpamDiscoveredPublicAddressesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetIpamDiscoveredResourceCidrsCommand
 */
export declare const se_GetIpamDiscoveredResourceCidrsCommand: (input: GetIpamDiscoveredResourceCidrsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetIpamPoolAllocationsCommand
 */
export declare const se_GetIpamPoolAllocationsCommand: (input: GetIpamPoolAllocationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetIpamPoolCidrsCommand
 */
export declare const se_GetIpamPoolCidrsCommand: (input: GetIpamPoolCidrsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetIpamResourceCidrsCommand
 */
export declare const se_GetIpamResourceCidrsCommand: (input: GetIpamResourceCidrsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetLaunchTemplateDataCommand
 */
export declare const se_GetLaunchTemplateDataCommand: (input: GetLaunchTemplateDataCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetManagedPrefixListAssociationsCommand
 */
export declare const se_GetManagedPrefixListAssociationsCommand: (input: GetManagedPrefixListAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetManagedPrefixListEntriesCommand
 */
export declare const se_GetManagedPrefixListEntriesCommand: (input: GetManagedPrefixListEntriesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetNetworkInsightsAccessScopeAnalysisFindingsCommand
 */
export declare const se_GetNetworkInsightsAccessScopeAnalysisFindingsCommand: (input: GetNetworkInsightsAccessScopeAnalysisFindingsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetNetworkInsightsAccessScopeContentCommand
 */
export declare const se_GetNetworkInsightsAccessScopeContentCommand: (input: GetNetworkInsightsAccessScopeContentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetPasswordDataCommand
 */
export declare const se_GetPasswordDataCommand: (input: GetPasswordDataCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetReservedInstancesExchangeQuoteCommand
 */
export declare const se_GetReservedInstancesExchangeQuoteCommand: (input: GetReservedInstancesExchangeQuoteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetSecurityGroupsForVpcCommand
 */
export declare const se_GetSecurityGroupsForVpcCommand: (input: GetSecurityGroupsForVpcCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetSerialConsoleAccessStatusCommand
 */
export declare const se_GetSerialConsoleAccessStatusCommand: (input: GetSerialConsoleAccessStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetSnapshotBlockPublicAccessStateCommand
 */
export declare const se_GetSnapshotBlockPublicAccessStateCommand: (input: GetSnapshotBlockPublicAccessStateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetSpotPlacementScoresCommand
 */
export declare const se_GetSpotPlacementScoresCommand: (input: GetSpotPlacementScoresCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetSubnetCidrReservationsCommand
 */
export declare const se_GetSubnetCidrReservationsCommand: (input: GetSubnetCidrReservationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetTransitGatewayAttachmentPropagationsCommand
 */
export declare const se_GetTransitGatewayAttachmentPropagationsCommand: (input: GetTransitGatewayAttachmentPropagationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetTransitGatewayMulticastDomainAssociationsCommand
 */
export declare const se_GetTransitGatewayMulticastDomainAssociationsCommand: (input: GetTransitGatewayMulticastDomainAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetTransitGatewayPolicyTableAssociationsCommand
 */
export declare const se_GetTransitGatewayPolicyTableAssociationsCommand: (input: GetTransitGatewayPolicyTableAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetTransitGatewayPolicyTableEntriesCommand
 */
export declare const se_GetTransitGatewayPolicyTableEntriesCommand: (input: GetTransitGatewayPolicyTableEntriesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetTransitGatewayPrefixListReferencesCommand
 */
export declare const se_GetTransitGatewayPrefixListReferencesCommand: (input: GetTransitGatewayPrefixListReferencesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetTransitGatewayRouteTableAssociationsCommand
 */
export declare const se_GetTransitGatewayRouteTableAssociationsCommand: (input: GetTransitGatewayRouteTableAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetTransitGatewayRouteTablePropagationsCommand
 */
export declare const se_GetTransitGatewayRouteTablePropagationsCommand: (input: GetTransitGatewayRouteTablePropagationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetVerifiedAccessEndpointPolicyCommand
 */
export declare const se_GetVerifiedAccessEndpointPolicyCommand: (input: GetVerifiedAccessEndpointPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetVerifiedAccessGroupPolicyCommand
 */
export declare const se_GetVerifiedAccessGroupPolicyCommand: (input: GetVerifiedAccessGroupPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetVpnConnectionDeviceSampleConfigurationCommand
 */
export declare const se_GetVpnConnectionDeviceSampleConfigurationCommand: (input: GetVpnConnectionDeviceSampleConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetVpnConnectionDeviceTypesCommand
 */
export declare const se_GetVpnConnectionDeviceTypesCommand: (input: GetVpnConnectionDeviceTypesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2GetVpnTunnelReplacementStatusCommand
 */
export declare const se_GetVpnTunnelReplacementStatusCommand: (input: GetVpnTunnelReplacementStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ImportClientVpnClientCertificateRevocationListCommand
 */
export declare const se_ImportClientVpnClientCertificateRevocationListCommand: (input: ImportClientVpnClientCertificateRevocationListCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ImportImageCommand
 */
export declare const se_ImportImageCommand: (input: ImportImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ImportInstanceCommand
 */
export declare const se_ImportInstanceCommand: (input: ImportInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ImportKeyPairCommand
 */
export declare const se_ImportKeyPairCommand: (input: ImportKeyPairCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ImportSnapshotCommand
 */
export declare const se_ImportSnapshotCommand: (input: ImportSnapshotCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ImportVolumeCommand
 */
export declare const se_ImportVolumeCommand: (input: ImportVolumeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ListImagesInRecycleBinCommand
 */
export declare const se_ListImagesInRecycleBinCommand: (input: ListImagesInRecycleBinCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ListSnapshotsInRecycleBinCommand
 */
export declare const se_ListSnapshotsInRecycleBinCommand: (input: ListSnapshotsInRecycleBinCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2LockSnapshotCommand
 */
export declare const se_LockSnapshotCommand: (input: LockSnapshotCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyAddressAttributeCommand
 */
export declare const se_ModifyAddressAttributeCommand: (input: ModifyAddressAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyAvailabilityZoneGroupCommand
 */
export declare const se_ModifyAvailabilityZoneGroupCommand: (input: ModifyAvailabilityZoneGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyCapacityReservationCommand
 */
export declare const se_ModifyCapacityReservationCommand: (input: ModifyCapacityReservationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyCapacityReservationFleetCommand
 */
export declare const se_ModifyCapacityReservationFleetCommand: (input: ModifyCapacityReservationFleetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyClientVpnEndpointCommand
 */
export declare const se_ModifyClientVpnEndpointCommand: (input: ModifyClientVpnEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyDefaultCreditSpecificationCommand
 */
export declare const se_ModifyDefaultCreditSpecificationCommand: (input: ModifyDefaultCreditSpecificationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyEbsDefaultKmsKeyIdCommand
 */
export declare const se_ModifyEbsDefaultKmsKeyIdCommand: (input: ModifyEbsDefaultKmsKeyIdCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyFleetCommand
 */
export declare const se_ModifyFleetCommand: (input: ModifyFleetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyFpgaImageAttributeCommand
 */
export declare const se_ModifyFpgaImageAttributeCommand: (input: ModifyFpgaImageAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyHostsCommand
 */
export declare const se_ModifyHostsCommand: (input: ModifyHostsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyIdentityIdFormatCommand
 */
export declare const se_ModifyIdentityIdFormatCommand: (input: ModifyIdentityIdFormatCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyIdFormatCommand
 */
export declare const se_ModifyIdFormatCommand: (input: ModifyIdFormatCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyImageAttributeCommand
 */
export declare const se_ModifyImageAttributeCommand: (input: ModifyImageAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyInstanceAttributeCommand
 */
export declare const se_ModifyInstanceAttributeCommand: (input: ModifyInstanceAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyInstanceCapacityReservationAttributesCommand
 */
export declare const se_ModifyInstanceCapacityReservationAttributesCommand: (input: ModifyInstanceCapacityReservationAttributesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyInstanceCreditSpecificationCommand
 */
export declare const se_ModifyInstanceCreditSpecificationCommand: (input: ModifyInstanceCreditSpecificationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyInstanceEventStartTimeCommand
 */
export declare const se_ModifyInstanceEventStartTimeCommand: (input: ModifyInstanceEventStartTimeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyInstanceEventWindowCommand
 */
export declare const se_ModifyInstanceEventWindowCommand: (input: ModifyInstanceEventWindowCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyInstanceMaintenanceOptionsCommand
 */
export declare const se_ModifyInstanceMaintenanceOptionsCommand: (input: ModifyInstanceMaintenanceOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyInstanceMetadataDefaultsCommand
 */
export declare const se_ModifyInstanceMetadataDefaultsCommand: (input: ModifyInstanceMetadataDefaultsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyInstanceMetadataOptionsCommand
 */
export declare const se_ModifyInstanceMetadataOptionsCommand: (input: ModifyInstanceMetadataOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyInstancePlacementCommand
 */
export declare const se_ModifyInstancePlacementCommand: (input: ModifyInstancePlacementCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyIpamCommand
 */
export declare const se_ModifyIpamCommand: (input: ModifyIpamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyIpamPoolCommand
 */
export declare const se_ModifyIpamPoolCommand: (input: ModifyIpamPoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyIpamResourceCidrCommand
 */
export declare const se_ModifyIpamResourceCidrCommand: (input: ModifyIpamResourceCidrCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyIpamResourceDiscoveryCommand
 */
export declare const se_ModifyIpamResourceDiscoveryCommand: (input: ModifyIpamResourceDiscoveryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyIpamScopeCommand
 */
export declare const se_ModifyIpamScopeCommand: (input: ModifyIpamScopeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyLaunchTemplateCommand
 */
export declare const se_ModifyLaunchTemplateCommand: (input: ModifyLaunchTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyLocalGatewayRouteCommand
 */
export declare const se_ModifyLocalGatewayRouteCommand: (input: ModifyLocalGatewayRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyManagedPrefixListCommand
 */
export declare const se_ModifyManagedPrefixListCommand: (input: ModifyManagedPrefixListCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyNetworkInterfaceAttributeCommand
 */
export declare const se_ModifyNetworkInterfaceAttributeCommand: (input: ModifyNetworkInterfaceAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyPrivateDnsNameOptionsCommand
 */
export declare const se_ModifyPrivateDnsNameOptionsCommand: (input: ModifyPrivateDnsNameOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyReservedInstancesCommand
 */
export declare const se_ModifyReservedInstancesCommand: (input: ModifyReservedInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifySecurityGroupRulesCommand
 */
export declare const se_ModifySecurityGroupRulesCommand: (input: ModifySecurityGroupRulesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifySnapshotAttributeCommand
 */
export declare const se_ModifySnapshotAttributeCommand: (input: ModifySnapshotAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifySnapshotTierCommand
 */
export declare const se_ModifySnapshotTierCommand: (input: ModifySnapshotTierCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifySpotFleetRequestCommand
 */
export declare const se_ModifySpotFleetRequestCommand: (input: ModifySpotFleetRequestCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifySubnetAttributeCommand
 */
export declare const se_ModifySubnetAttributeCommand: (input: ModifySubnetAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyTrafficMirrorFilterNetworkServicesCommand
 */
export declare const se_ModifyTrafficMirrorFilterNetworkServicesCommand: (input: ModifyTrafficMirrorFilterNetworkServicesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyTrafficMirrorFilterRuleCommand
 */
export declare const se_ModifyTrafficMirrorFilterRuleCommand: (input: ModifyTrafficMirrorFilterRuleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyTrafficMirrorSessionCommand
 */
export declare const se_ModifyTrafficMirrorSessionCommand: (input: ModifyTrafficMirrorSessionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyTransitGatewayCommand
 */
export declare const se_ModifyTransitGatewayCommand: (input: ModifyTransitGatewayCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyTransitGatewayPrefixListReferenceCommand
 */
export declare const se_ModifyTransitGatewayPrefixListReferenceCommand: (input: ModifyTransitGatewayPrefixListReferenceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyTransitGatewayVpcAttachmentCommand
 */
export declare const se_ModifyTransitGatewayVpcAttachmentCommand: (input: ModifyTransitGatewayVpcAttachmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVerifiedAccessEndpointCommand
 */
export declare const se_ModifyVerifiedAccessEndpointCommand: (input: ModifyVerifiedAccessEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVerifiedAccessEndpointPolicyCommand
 */
export declare const se_ModifyVerifiedAccessEndpointPolicyCommand: (input: ModifyVerifiedAccessEndpointPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVerifiedAccessGroupCommand
 */
export declare const se_ModifyVerifiedAccessGroupCommand: (input: ModifyVerifiedAccessGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVerifiedAccessGroupPolicyCommand
 */
export declare const se_ModifyVerifiedAccessGroupPolicyCommand: (input: ModifyVerifiedAccessGroupPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVerifiedAccessInstanceCommand
 */
export declare const se_ModifyVerifiedAccessInstanceCommand: (input: ModifyVerifiedAccessInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVerifiedAccessInstanceLoggingConfigurationCommand
 */
export declare const se_ModifyVerifiedAccessInstanceLoggingConfigurationCommand: (input: ModifyVerifiedAccessInstanceLoggingConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVerifiedAccessTrustProviderCommand
 */
export declare const se_ModifyVerifiedAccessTrustProviderCommand: (input: ModifyVerifiedAccessTrustProviderCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVolumeCommand
 */
export declare const se_ModifyVolumeCommand: (input: ModifyVolumeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVolumeAttributeCommand
 */
export declare const se_ModifyVolumeAttributeCommand: (input: ModifyVolumeAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVpcAttributeCommand
 */
export declare const se_ModifyVpcAttributeCommand: (input: ModifyVpcAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVpcEndpointCommand
 */
export declare const se_ModifyVpcEndpointCommand: (input: ModifyVpcEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVpcEndpointConnectionNotificationCommand
 */
export declare const se_ModifyVpcEndpointConnectionNotificationCommand: (input: ModifyVpcEndpointConnectionNotificationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVpcEndpointServiceConfigurationCommand
 */
export declare const se_ModifyVpcEndpointServiceConfigurationCommand: (input: ModifyVpcEndpointServiceConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVpcEndpointServicePayerResponsibilityCommand
 */
export declare const se_ModifyVpcEndpointServicePayerResponsibilityCommand: (input: ModifyVpcEndpointServicePayerResponsibilityCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVpcEndpointServicePermissionsCommand
 */
export declare const se_ModifyVpcEndpointServicePermissionsCommand: (input: ModifyVpcEndpointServicePermissionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVpcPeeringConnectionOptionsCommand
 */
export declare const se_ModifyVpcPeeringConnectionOptionsCommand: (input: ModifyVpcPeeringConnectionOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVpcTenancyCommand
 */
export declare const se_ModifyVpcTenancyCommand: (input: ModifyVpcTenancyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVpnConnectionCommand
 */
export declare const se_ModifyVpnConnectionCommand: (input: ModifyVpnConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVpnConnectionOptionsCommand
 */
export declare const se_ModifyVpnConnectionOptionsCommand: (input: ModifyVpnConnectionOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVpnTunnelCertificateCommand
 */
export declare const se_ModifyVpnTunnelCertificateCommand: (input: ModifyVpnTunnelCertificateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ModifyVpnTunnelOptionsCommand
 */
export declare const se_ModifyVpnTunnelOptionsCommand: (input: ModifyVpnTunnelOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2MonitorInstancesCommand
 */
export declare const se_MonitorInstancesCommand: (input: MonitorInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2MoveAddressToVpcCommand
 */
export declare const se_MoveAddressToVpcCommand: (input: MoveAddressToVpcCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2MoveByoipCidrToIpamCommand
 */
export declare const se_MoveByoipCidrToIpamCommand: (input: MoveByoipCidrToIpamCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ProvisionByoipCidrCommand
 */
export declare const se_ProvisionByoipCidrCommand: (input: ProvisionByoipCidrCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ProvisionIpamByoasnCommand
 */
export declare const se_ProvisionIpamByoasnCommand: (input: ProvisionIpamByoasnCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ProvisionIpamPoolCidrCommand
 */
export declare const se_ProvisionIpamPoolCidrCommand: (input: ProvisionIpamPoolCidrCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ProvisionPublicIpv4PoolCidrCommand
 */
export declare const se_ProvisionPublicIpv4PoolCidrCommand: (input: ProvisionPublicIpv4PoolCidrCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2PurchaseCapacityBlockCommand
 */
export declare const se_PurchaseCapacityBlockCommand: (input: PurchaseCapacityBlockCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2PurchaseHostReservationCommand
 */
export declare const se_PurchaseHostReservationCommand: (input: PurchaseHostReservationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2PurchaseReservedInstancesOfferingCommand
 */
export declare const se_PurchaseReservedInstancesOfferingCommand: (input: PurchaseReservedInstancesOfferingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2PurchaseScheduledInstancesCommand
 */
export declare const se_PurchaseScheduledInstancesCommand: (input: PurchaseScheduledInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RebootInstancesCommand
 */
export declare const se_RebootInstancesCommand: (input: RebootInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RegisterImageCommand
 */
export declare const se_RegisterImageCommand: (input: RegisterImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RegisterInstanceEventNotificationAttributesCommand
 */
export declare const se_RegisterInstanceEventNotificationAttributesCommand: (input: RegisterInstanceEventNotificationAttributesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RegisterTransitGatewayMulticastGroupMembersCommand
 */
export declare const se_RegisterTransitGatewayMulticastGroupMembersCommand: (input: RegisterTransitGatewayMulticastGroupMembersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RegisterTransitGatewayMulticastGroupSourcesCommand
 */
export declare const se_RegisterTransitGatewayMulticastGroupSourcesCommand: (input: RegisterTransitGatewayMulticastGroupSourcesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RejectTransitGatewayMulticastDomainAssociationsCommand
 */
export declare const se_RejectTransitGatewayMulticastDomainAssociationsCommand: (input: RejectTransitGatewayMulticastDomainAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RejectTransitGatewayPeeringAttachmentCommand
 */
export declare const se_RejectTransitGatewayPeeringAttachmentCommand: (input: RejectTransitGatewayPeeringAttachmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RejectTransitGatewayVpcAttachmentCommand
 */
export declare const se_RejectTransitGatewayVpcAttachmentCommand: (input: RejectTransitGatewayVpcAttachmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RejectVpcEndpointConnectionsCommand
 */
export declare const se_RejectVpcEndpointConnectionsCommand: (input: RejectVpcEndpointConnectionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RejectVpcPeeringConnectionCommand
 */
export declare const se_RejectVpcPeeringConnectionCommand: (input: RejectVpcPeeringConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ReleaseAddressCommand
 */
export declare const se_ReleaseAddressCommand: (input: ReleaseAddressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ReleaseHostsCommand
 */
export declare const se_ReleaseHostsCommand: (input: ReleaseHostsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ReleaseIpamPoolAllocationCommand
 */
export declare const se_ReleaseIpamPoolAllocationCommand: (input: ReleaseIpamPoolAllocationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ReplaceIamInstanceProfileAssociationCommand
 */
export declare const se_ReplaceIamInstanceProfileAssociationCommand: (input: ReplaceIamInstanceProfileAssociationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ReplaceNetworkAclAssociationCommand
 */
export declare const se_ReplaceNetworkAclAssociationCommand: (input: ReplaceNetworkAclAssociationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ReplaceNetworkAclEntryCommand
 */
export declare const se_ReplaceNetworkAclEntryCommand: (input: ReplaceNetworkAclEntryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ReplaceRouteCommand
 */
export declare const se_ReplaceRouteCommand: (input: ReplaceRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ReplaceRouteTableAssociationCommand
 */
export declare const se_ReplaceRouteTableAssociationCommand: (input: ReplaceRouteTableAssociationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ReplaceTransitGatewayRouteCommand
 */
export declare const se_ReplaceTransitGatewayRouteCommand: (input: ReplaceTransitGatewayRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ReplaceVpnTunnelCommand
 */
export declare const se_ReplaceVpnTunnelCommand: (input: ReplaceVpnTunnelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ReportInstanceStatusCommand
 */
export declare const se_ReportInstanceStatusCommand: (input: ReportInstanceStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RequestSpotFleetCommand
 */
export declare const se_RequestSpotFleetCommand: (input: RequestSpotFleetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RequestSpotInstancesCommand
 */
export declare const se_RequestSpotInstancesCommand: (input: RequestSpotInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ResetAddressAttributeCommand
 */
export declare const se_ResetAddressAttributeCommand: (input: ResetAddressAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ResetEbsDefaultKmsKeyIdCommand
 */
export declare const se_ResetEbsDefaultKmsKeyIdCommand: (input: ResetEbsDefaultKmsKeyIdCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ResetFpgaImageAttributeCommand
 */
export declare const se_ResetFpgaImageAttributeCommand: (input: ResetFpgaImageAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ResetImageAttributeCommand
 */
export declare const se_ResetImageAttributeCommand: (input: ResetImageAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ResetInstanceAttributeCommand
 */
export declare const se_ResetInstanceAttributeCommand: (input: ResetInstanceAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ResetNetworkInterfaceAttributeCommand
 */
export declare const se_ResetNetworkInterfaceAttributeCommand: (input: ResetNetworkInterfaceAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2ResetSnapshotAttributeCommand
 */
export declare const se_ResetSnapshotAttributeCommand: (input: ResetSnapshotAttributeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RestoreAddressToClassicCommand
 */
export declare const se_RestoreAddressToClassicCommand: (input: RestoreAddressToClassicCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RestoreImageFromRecycleBinCommand
 */
export declare const se_RestoreImageFromRecycleBinCommand: (input: RestoreImageFromRecycleBinCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RestoreManagedPrefixListVersionCommand
 */
export declare const se_RestoreManagedPrefixListVersionCommand: (input: RestoreManagedPrefixListVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RestoreSnapshotFromRecycleBinCommand
 */
export declare const se_RestoreSnapshotFromRecycleBinCommand: (input: RestoreSnapshotFromRecycleBinCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RestoreSnapshotTierCommand
 */
export declare const se_RestoreSnapshotTierCommand: (input: RestoreSnapshotTierCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RevokeClientVpnIngressCommand
 */
export declare const se_RevokeClientVpnIngressCommand: (input: RevokeClientVpnIngressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RevokeSecurityGroupEgressCommand
 */
export declare const se_RevokeSecurityGroupEgressCommand: (input: RevokeSecurityGroupEgressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RevokeSecurityGroupIngressCommand
 */
export declare const se_RevokeSecurityGroupIngressCommand: (input: RevokeSecurityGroupIngressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RunInstancesCommand
 */
export declare const se_RunInstancesCommand: (input: RunInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2RunScheduledInstancesCommand
 */
export declare const se_RunScheduledInstancesCommand: (input: RunScheduledInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2SearchLocalGatewayRoutesCommand
 */
export declare const se_SearchLocalGatewayRoutesCommand: (input: SearchLocalGatewayRoutesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2SearchTransitGatewayMulticastGroupsCommand
 */
export declare const se_SearchTransitGatewayMulticastGroupsCommand: (input: SearchTransitGatewayMulticastGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2SearchTransitGatewayRoutesCommand
 */
export declare const se_SearchTransitGatewayRoutesCommand: (input: SearchTransitGatewayRoutesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2SendDiagnosticInterruptCommand
 */
export declare const se_SendDiagnosticInterruptCommand: (input: SendDiagnosticInterruptCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2StartInstancesCommand
 */
export declare const se_StartInstancesCommand: (input: StartInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2StartNetworkInsightsAccessScopeAnalysisCommand
 */
export declare const se_StartNetworkInsightsAccessScopeAnalysisCommand: (input: StartNetworkInsightsAccessScopeAnalysisCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2StartNetworkInsightsAnalysisCommand
 */
export declare const se_StartNetworkInsightsAnalysisCommand: (input: StartNetworkInsightsAnalysisCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2StartVpcEndpointServicePrivateDnsVerificationCommand
 */
export declare const se_StartVpcEndpointServicePrivateDnsVerificationCommand: (input: StartVpcEndpointServicePrivateDnsVerificationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2StopInstancesCommand
 */
export declare const se_StopInstancesCommand: (input: StopInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2TerminateClientVpnConnectionsCommand
 */
export declare const se_TerminateClientVpnConnectionsCommand: (input: TerminateClientVpnConnectionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2TerminateInstancesCommand
 */
export declare const se_TerminateInstancesCommand: (input: TerminateInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2UnassignIpv6AddressesCommand
 */
export declare const se_UnassignIpv6AddressesCommand: (input: UnassignIpv6AddressesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2UnassignPrivateIpAddressesCommand
 */
export declare const se_UnassignPrivateIpAddressesCommand: (input: UnassignPrivateIpAddressesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2UnassignPrivateNatGatewayAddressCommand
 */
export declare const se_UnassignPrivateNatGatewayAddressCommand: (input: UnassignPrivateNatGatewayAddressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2UnlockSnapshotCommand
 */
export declare const se_UnlockSnapshotCommand: (input: UnlockSnapshotCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2UnmonitorInstancesCommand
 */
export declare const se_UnmonitorInstancesCommand: (input: UnmonitorInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2UpdateSecurityGroupRuleDescriptionsEgressCommand
 */
export declare const se_UpdateSecurityGroupRuleDescriptionsEgressCommand: (input: UpdateSecurityGroupRuleDescriptionsEgressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2UpdateSecurityGroupRuleDescriptionsIngressCommand
 */
export declare const se_UpdateSecurityGroupRuleDescriptionsIngressCommand: (input: UpdateSecurityGroupRuleDescriptionsIngressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_ec2WithdrawByoipCidrCommand
 */
export declare const se_WithdrawByoipCidrCommand: (input: WithdrawByoipCidrCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_ec2AcceptAddressTransferCommand
 */
export declare const de_AcceptAddressTransferCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcceptAddressTransferCommandOutput>;
/**
 * deserializeAws_ec2AcceptReservedInstancesExchangeQuoteCommand
 */
export declare const de_AcceptReservedInstancesExchangeQuoteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcceptReservedInstancesExchangeQuoteCommandOutput>;
/**
 * deserializeAws_ec2AcceptTransitGatewayMulticastDomainAssociationsCommand
 */
export declare const de_AcceptTransitGatewayMulticastDomainAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcceptTransitGatewayMulticastDomainAssociationsCommandOutput>;
/**
 * deserializeAws_ec2AcceptTransitGatewayPeeringAttachmentCommand
 */
export declare const de_AcceptTransitGatewayPeeringAttachmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcceptTransitGatewayPeeringAttachmentCommandOutput>;
/**
 * deserializeAws_ec2AcceptTransitGatewayVpcAttachmentCommand
 */
export declare const de_AcceptTransitGatewayVpcAttachmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcceptTransitGatewayVpcAttachmentCommandOutput>;
/**
 * deserializeAws_ec2AcceptVpcEndpointConnectionsCommand
 */
export declare const de_AcceptVpcEndpointConnectionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcceptVpcEndpointConnectionsCommandOutput>;
/**
 * deserializeAws_ec2AcceptVpcPeeringConnectionCommand
 */
export declare const de_AcceptVpcPeeringConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcceptVpcPeeringConnectionCommandOutput>;
/**
 * deserializeAws_ec2AdvertiseByoipCidrCommand
 */
export declare const de_AdvertiseByoipCidrCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AdvertiseByoipCidrCommandOutput>;
/**
 * deserializeAws_ec2AllocateAddressCommand
 */
export declare const de_AllocateAddressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AllocateAddressCommandOutput>;
/**
 * deserializeAws_ec2AllocateHostsCommand
 */
export declare const de_AllocateHostsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AllocateHostsCommandOutput>;
/**
 * deserializeAws_ec2AllocateIpamPoolCidrCommand
 */
export declare const de_AllocateIpamPoolCidrCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AllocateIpamPoolCidrCommandOutput>;
/**
 * deserializeAws_ec2ApplySecurityGroupsToClientVpnTargetNetworkCommand
 */
export declare const de_ApplySecurityGroupsToClientVpnTargetNetworkCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ApplySecurityGroupsToClientVpnTargetNetworkCommandOutput>;
/**
 * deserializeAws_ec2AssignIpv6AddressesCommand
 */
export declare const de_AssignIpv6AddressesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssignIpv6AddressesCommandOutput>;
/**
 * deserializeAws_ec2AssignPrivateIpAddressesCommand
 */
export declare const de_AssignPrivateIpAddressesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssignPrivateIpAddressesCommandOutput>;
/**
 * deserializeAws_ec2AssignPrivateNatGatewayAddressCommand
 */
export declare const de_AssignPrivateNatGatewayAddressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssignPrivateNatGatewayAddressCommandOutput>;
/**
 * deserializeAws_ec2AssociateAddressCommand
 */
export declare const de_AssociateAddressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateAddressCommandOutput>;
/**
 * deserializeAws_ec2AssociateClientVpnTargetNetworkCommand
 */
export declare const de_AssociateClientVpnTargetNetworkCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateClientVpnTargetNetworkCommandOutput>;
/**
 * deserializeAws_ec2AssociateDhcpOptionsCommand
 */
export declare const de_AssociateDhcpOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateDhcpOptionsCommandOutput>;
/**
 * deserializeAws_ec2AssociateEnclaveCertificateIamRoleCommand
 */
export declare const de_AssociateEnclaveCertificateIamRoleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateEnclaveCertificateIamRoleCommandOutput>;
/**
 * deserializeAws_ec2AssociateIamInstanceProfileCommand
 */
export declare const de_AssociateIamInstanceProfileCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateIamInstanceProfileCommandOutput>;
/**
 * deserializeAws_ec2AssociateInstanceEventWindowCommand
 */
export declare const de_AssociateInstanceEventWindowCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateInstanceEventWindowCommandOutput>;
/**
 * deserializeAws_ec2AssociateIpamByoasnCommand
 */
export declare const de_AssociateIpamByoasnCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateIpamByoasnCommandOutput>;
/**
 * deserializeAws_ec2AssociateIpamResourceDiscoveryCommand
 */
export declare const de_AssociateIpamResourceDiscoveryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateIpamResourceDiscoveryCommandOutput>;
/**
 * deserializeAws_ec2AssociateNatGatewayAddressCommand
 */
export declare const de_AssociateNatGatewayAddressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateNatGatewayAddressCommandOutput>;
/**
 * deserializeAws_ec2AssociateRouteTableCommand
 */
export declare const de_AssociateRouteTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateRouteTableCommandOutput>;
/**
 * deserializeAws_ec2AssociateSubnetCidrBlockCommand
 */
export declare const de_AssociateSubnetCidrBlockCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateSubnetCidrBlockCommandOutput>;
/**
 * deserializeAws_ec2AssociateTransitGatewayMulticastDomainCommand
 */
export declare const de_AssociateTransitGatewayMulticastDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateTransitGatewayMulticastDomainCommandOutput>;
/**
 * deserializeAws_ec2AssociateTransitGatewayPolicyTableCommand
 */
export declare const de_AssociateTransitGatewayPolicyTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateTransitGatewayPolicyTableCommandOutput>;
/**
 * deserializeAws_ec2AssociateTransitGatewayRouteTableCommand
 */
export declare const de_AssociateTransitGatewayRouteTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateTransitGatewayRouteTableCommandOutput>;
/**
 * deserializeAws_ec2AssociateTrunkInterfaceCommand
 */
export declare const de_AssociateTrunkInterfaceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateTrunkInterfaceCommandOutput>;
/**
 * deserializeAws_ec2AssociateVpcCidrBlockCommand
 */
export declare const de_AssociateVpcCidrBlockCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateVpcCidrBlockCommandOutput>;
/**
 * deserializeAws_ec2AttachClassicLinkVpcCommand
 */
export declare const de_AttachClassicLinkVpcCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AttachClassicLinkVpcCommandOutput>;
/**
 * deserializeAws_ec2AttachInternetGatewayCommand
 */
export declare const de_AttachInternetGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AttachInternetGatewayCommandOutput>;
/**
 * deserializeAws_ec2AttachNetworkInterfaceCommand
 */
export declare const de_AttachNetworkInterfaceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AttachNetworkInterfaceCommandOutput>;
/**
 * deserializeAws_ec2AttachVerifiedAccessTrustProviderCommand
 */
export declare const de_AttachVerifiedAccessTrustProviderCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AttachVerifiedAccessTrustProviderCommandOutput>;
/**
 * deserializeAws_ec2AttachVolumeCommand
 */
export declare const de_AttachVolumeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AttachVolumeCommandOutput>;
/**
 * deserializeAws_ec2AttachVpnGatewayCommand
 */
export declare const de_AttachVpnGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AttachVpnGatewayCommandOutput>;
/**
 * deserializeAws_ec2AuthorizeClientVpnIngressCommand
 */
export declare const de_AuthorizeClientVpnIngressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AuthorizeClientVpnIngressCommandOutput>;
/**
 * deserializeAws_ec2AuthorizeSecurityGroupEgressCommand
 */
export declare const de_AuthorizeSecurityGroupEgressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AuthorizeSecurityGroupEgressCommandOutput>;
/**
 * deserializeAws_ec2AuthorizeSecurityGroupIngressCommand
 */
export declare const de_AuthorizeSecurityGroupIngressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AuthorizeSecurityGroupIngressCommandOutput>;
/**
 * deserializeAws_ec2BundleInstanceCommand
 */
export declare const de_BundleInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BundleInstanceCommandOutput>;
/**
 * deserializeAws_ec2CancelBundleTaskCommand
 */
export declare const de_CancelBundleTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelBundleTaskCommandOutput>;
/**
 * deserializeAws_ec2CancelCapacityReservationCommand
 */
export declare const de_CancelCapacityReservationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelCapacityReservationCommandOutput>;
/**
 * deserializeAws_ec2CancelCapacityReservationFleetsCommand
 */
export declare const de_CancelCapacityReservationFleetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelCapacityReservationFleetsCommandOutput>;
/**
 * deserializeAws_ec2CancelConversionTaskCommand
 */
export declare const de_CancelConversionTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelConversionTaskCommandOutput>;
/**
 * deserializeAws_ec2CancelExportTaskCommand
 */
export declare const de_CancelExportTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelExportTaskCommandOutput>;
/**
 * deserializeAws_ec2CancelImageLaunchPermissionCommand
 */
export declare const de_CancelImageLaunchPermissionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelImageLaunchPermissionCommandOutput>;
/**
 * deserializeAws_ec2CancelImportTaskCommand
 */
export declare const de_CancelImportTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelImportTaskCommandOutput>;
/**
 * deserializeAws_ec2CancelReservedInstancesListingCommand
 */
export declare const de_CancelReservedInstancesListingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelReservedInstancesListingCommandOutput>;
/**
 * deserializeAws_ec2CancelSpotFleetRequestsCommand
 */
export declare const de_CancelSpotFleetRequestsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelSpotFleetRequestsCommandOutput>;
/**
 * deserializeAws_ec2CancelSpotInstanceRequestsCommand
 */
export declare const de_CancelSpotInstanceRequestsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelSpotInstanceRequestsCommandOutput>;
/**
 * deserializeAws_ec2ConfirmProductInstanceCommand
 */
export declare const de_ConfirmProductInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ConfirmProductInstanceCommandOutput>;
/**
 * deserializeAws_ec2CopyFpgaImageCommand
 */
export declare const de_CopyFpgaImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CopyFpgaImageCommandOutput>;
/**
 * deserializeAws_ec2CopyImageCommand
 */
export declare const de_CopyImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CopyImageCommandOutput>;
/**
 * deserializeAws_ec2CopySnapshotCommand
 */
export declare const de_CopySnapshotCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CopySnapshotCommandOutput>;
/**
 * deserializeAws_ec2CreateCapacityReservationCommand
 */
export declare const de_CreateCapacityReservationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCapacityReservationCommandOutput>;
/**
 * deserializeAws_ec2CreateCapacityReservationFleetCommand
 */
export declare const de_CreateCapacityReservationFleetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCapacityReservationFleetCommandOutput>;
/**
 * deserializeAws_ec2CreateCarrierGatewayCommand
 */
export declare const de_CreateCarrierGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCarrierGatewayCommandOutput>;
/**
 * deserializeAws_ec2CreateClientVpnEndpointCommand
 */
export declare const de_CreateClientVpnEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateClientVpnEndpointCommandOutput>;
/**
 * deserializeAws_ec2CreateClientVpnRouteCommand
 */
export declare const de_CreateClientVpnRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateClientVpnRouteCommandOutput>;
/**
 * deserializeAws_ec2CreateCoipCidrCommand
 */
export declare const de_CreateCoipCidrCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCoipCidrCommandOutput>;
/**
 * deserializeAws_ec2CreateCoipPoolCommand
 */
export declare const de_CreateCoipPoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCoipPoolCommandOutput>;
/**
 * deserializeAws_ec2CreateCustomerGatewayCommand
 */
export declare const de_CreateCustomerGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCustomerGatewayCommandOutput>;
/**
 * deserializeAws_ec2CreateDefaultSubnetCommand
 */
export declare const de_CreateDefaultSubnetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDefaultSubnetCommandOutput>;
/**
 * deserializeAws_ec2CreateDefaultVpcCommand
 */
export declare const de_CreateDefaultVpcCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDefaultVpcCommandOutput>;
/**
 * deserializeAws_ec2CreateDhcpOptionsCommand
 */
export declare const de_CreateDhcpOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDhcpOptionsCommandOutput>;
/**
 * deserializeAws_ec2CreateEgressOnlyInternetGatewayCommand
 */
export declare const de_CreateEgressOnlyInternetGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateEgressOnlyInternetGatewayCommandOutput>;
/**
 * deserializeAws_ec2CreateFleetCommand
 */
export declare const de_CreateFleetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateFleetCommandOutput>;
/**
 * deserializeAws_ec2CreateFlowLogsCommand
 */
export declare const de_CreateFlowLogsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateFlowLogsCommandOutput>;
/**
 * deserializeAws_ec2CreateFpgaImageCommand
 */
export declare const de_CreateFpgaImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateFpgaImageCommandOutput>;
/**
 * deserializeAws_ec2CreateImageCommand
 */
export declare const de_CreateImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateImageCommandOutput>;
/**
 * deserializeAws_ec2CreateInstanceConnectEndpointCommand
 */
export declare const de_CreateInstanceConnectEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateInstanceConnectEndpointCommandOutput>;
/**
 * deserializeAws_ec2CreateInstanceEventWindowCommand
 */
export declare const de_CreateInstanceEventWindowCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateInstanceEventWindowCommandOutput>;
/**
 * deserializeAws_ec2CreateInstanceExportTaskCommand
 */
export declare const de_CreateInstanceExportTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateInstanceExportTaskCommandOutput>;
/**
 * deserializeAws_ec2CreateInternetGatewayCommand
 */
export declare const de_CreateInternetGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateInternetGatewayCommandOutput>;
/**
 * deserializeAws_ec2CreateIpamCommand
 */
export declare const de_CreateIpamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateIpamCommandOutput>;
/**
 * deserializeAws_ec2CreateIpamPoolCommand
 */
export declare const de_CreateIpamPoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateIpamPoolCommandOutput>;
/**
 * deserializeAws_ec2CreateIpamResourceDiscoveryCommand
 */
export declare const de_CreateIpamResourceDiscoveryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateIpamResourceDiscoveryCommandOutput>;
/**
 * deserializeAws_ec2CreateIpamScopeCommand
 */
export declare const de_CreateIpamScopeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateIpamScopeCommandOutput>;
/**
 * deserializeAws_ec2CreateKeyPairCommand
 */
export declare const de_CreateKeyPairCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateKeyPairCommandOutput>;
/**
 * deserializeAws_ec2CreateLaunchTemplateCommand
 */
export declare const de_CreateLaunchTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateLaunchTemplateCommandOutput>;
/**
 * deserializeAws_ec2CreateLaunchTemplateVersionCommand
 */
export declare const de_CreateLaunchTemplateVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateLaunchTemplateVersionCommandOutput>;
/**
 * deserializeAws_ec2CreateLocalGatewayRouteCommand
 */
export declare const de_CreateLocalGatewayRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateLocalGatewayRouteCommandOutput>;
/**
 * deserializeAws_ec2CreateLocalGatewayRouteTableCommand
 */
export declare const de_CreateLocalGatewayRouteTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateLocalGatewayRouteTableCommandOutput>;
/**
 * deserializeAws_ec2CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommand
 */
export declare const de_CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommandOutput>;
/**
 * deserializeAws_ec2CreateLocalGatewayRouteTableVpcAssociationCommand
 */
export declare const de_CreateLocalGatewayRouteTableVpcAssociationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateLocalGatewayRouteTableVpcAssociationCommandOutput>;
/**
 * deserializeAws_ec2CreateManagedPrefixListCommand
 */
export declare const de_CreateManagedPrefixListCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateManagedPrefixListCommandOutput>;
/**
 * deserializeAws_ec2CreateNatGatewayCommand
 */
export declare const de_CreateNatGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateNatGatewayCommandOutput>;
/**
 * deserializeAws_ec2CreateNetworkAclCommand
 */
export declare const de_CreateNetworkAclCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateNetworkAclCommandOutput>;
/**
 * deserializeAws_ec2CreateNetworkAclEntryCommand
 */
export declare const de_CreateNetworkAclEntryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateNetworkAclEntryCommandOutput>;
/**
 * deserializeAws_ec2CreateNetworkInsightsAccessScopeCommand
 */
export declare const de_CreateNetworkInsightsAccessScopeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateNetworkInsightsAccessScopeCommandOutput>;
/**
 * deserializeAws_ec2CreateNetworkInsightsPathCommand
 */
export declare const de_CreateNetworkInsightsPathCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateNetworkInsightsPathCommandOutput>;
/**
 * deserializeAws_ec2CreateNetworkInterfaceCommand
 */
export declare const de_CreateNetworkInterfaceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateNetworkInterfaceCommandOutput>;
/**
 * deserializeAws_ec2CreateNetworkInterfacePermissionCommand
 */
export declare const de_CreateNetworkInterfacePermissionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateNetworkInterfacePermissionCommandOutput>;
/**
 * deserializeAws_ec2CreatePlacementGroupCommand
 */
export declare const de_CreatePlacementGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreatePlacementGroupCommandOutput>;
/**
 * deserializeAws_ec2CreatePublicIpv4PoolCommand
 */
export declare const de_CreatePublicIpv4PoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreatePublicIpv4PoolCommandOutput>;
/**
 * deserializeAws_ec2CreateReplaceRootVolumeTaskCommand
 */
export declare const de_CreateReplaceRootVolumeTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateReplaceRootVolumeTaskCommandOutput>;
/**
 * deserializeAws_ec2CreateReservedInstancesListingCommand
 */
export declare const de_CreateReservedInstancesListingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateReservedInstancesListingCommandOutput>;
/**
 * deserializeAws_ec2CreateRestoreImageTaskCommand
 */
export declare const de_CreateRestoreImageTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateRestoreImageTaskCommandOutput>;
/**
 * deserializeAws_ec2CreateRouteCommand
 */
export declare const de_CreateRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateRouteCommandOutput>;
/**
 * deserializeAws_ec2CreateRouteTableCommand
 */
export declare const de_CreateRouteTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateRouteTableCommandOutput>;
/**
 * deserializeAws_ec2CreateSecurityGroupCommand
 */
export declare const de_CreateSecurityGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateSecurityGroupCommandOutput>;
/**
 * deserializeAws_ec2CreateSnapshotCommand
 */
export declare const de_CreateSnapshotCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateSnapshotCommandOutput>;
/**
 * deserializeAws_ec2CreateSnapshotsCommand
 */
export declare const de_CreateSnapshotsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateSnapshotsCommandOutput>;
/**
 * deserializeAws_ec2CreateSpotDatafeedSubscriptionCommand
 */
export declare const de_CreateSpotDatafeedSubscriptionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateSpotDatafeedSubscriptionCommandOutput>;
/**
 * deserializeAws_ec2CreateStoreImageTaskCommand
 */
export declare const de_CreateStoreImageTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateStoreImageTaskCommandOutput>;
/**
 * deserializeAws_ec2CreateSubnetCommand
 */
export declare const de_CreateSubnetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateSubnetCommandOutput>;
/**
 * deserializeAws_ec2CreateSubnetCidrReservationCommand
 */
export declare const de_CreateSubnetCidrReservationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateSubnetCidrReservationCommandOutput>;
/**
 * deserializeAws_ec2CreateTagsCommand
 */
export declare const de_CreateTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTagsCommandOutput>;
/**
 * deserializeAws_ec2CreateTrafficMirrorFilterCommand
 */
export declare const de_CreateTrafficMirrorFilterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTrafficMirrorFilterCommandOutput>;
/**
 * deserializeAws_ec2CreateTrafficMirrorFilterRuleCommand
 */
export declare const de_CreateTrafficMirrorFilterRuleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTrafficMirrorFilterRuleCommandOutput>;
/**
 * deserializeAws_ec2CreateTrafficMirrorSessionCommand
 */
export declare const de_CreateTrafficMirrorSessionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTrafficMirrorSessionCommandOutput>;
/**
 * deserializeAws_ec2CreateTrafficMirrorTargetCommand
 */
export declare const de_CreateTrafficMirrorTargetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTrafficMirrorTargetCommandOutput>;
/**
 * deserializeAws_ec2CreateTransitGatewayCommand
 */
export declare const de_CreateTransitGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTransitGatewayCommandOutput>;
/**
 * deserializeAws_ec2CreateTransitGatewayConnectCommand
 */
export declare const de_CreateTransitGatewayConnectCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTransitGatewayConnectCommandOutput>;
/**
 * deserializeAws_ec2CreateTransitGatewayConnectPeerCommand
 */
export declare const de_CreateTransitGatewayConnectPeerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTransitGatewayConnectPeerCommandOutput>;
/**
 * deserializeAws_ec2CreateTransitGatewayMulticastDomainCommand
 */
export declare const de_CreateTransitGatewayMulticastDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTransitGatewayMulticastDomainCommandOutput>;
/**
 * deserializeAws_ec2CreateTransitGatewayPeeringAttachmentCommand
 */
export declare const de_CreateTransitGatewayPeeringAttachmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTransitGatewayPeeringAttachmentCommandOutput>;
/**
 * deserializeAws_ec2CreateTransitGatewayPolicyTableCommand
 */
export declare const de_CreateTransitGatewayPolicyTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTransitGatewayPolicyTableCommandOutput>;
/**
 * deserializeAws_ec2CreateTransitGatewayPrefixListReferenceCommand
 */
export declare const de_CreateTransitGatewayPrefixListReferenceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTransitGatewayPrefixListReferenceCommandOutput>;
/**
 * deserializeAws_ec2CreateTransitGatewayRouteCommand
 */
export declare const de_CreateTransitGatewayRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTransitGatewayRouteCommandOutput>;
/**
 * deserializeAws_ec2CreateTransitGatewayRouteTableCommand
 */
export declare const de_CreateTransitGatewayRouteTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTransitGatewayRouteTableCommandOutput>;
/**
 * deserializeAws_ec2CreateTransitGatewayRouteTableAnnouncementCommand
 */
export declare const de_CreateTransitGatewayRouteTableAnnouncementCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTransitGatewayRouteTableAnnouncementCommandOutput>;
/**
 * deserializeAws_ec2CreateTransitGatewayVpcAttachmentCommand
 */
export declare const de_CreateTransitGatewayVpcAttachmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTransitGatewayVpcAttachmentCommandOutput>;
/**
 * deserializeAws_ec2CreateVerifiedAccessEndpointCommand
 */
export declare const de_CreateVerifiedAccessEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVerifiedAccessEndpointCommandOutput>;
/**
 * deserializeAws_ec2CreateVerifiedAccessGroupCommand
 */
export declare const de_CreateVerifiedAccessGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVerifiedAccessGroupCommandOutput>;
/**
 * deserializeAws_ec2CreateVerifiedAccessInstanceCommand
 */
export declare const de_CreateVerifiedAccessInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVerifiedAccessInstanceCommandOutput>;
/**
 * deserializeAws_ec2CreateVerifiedAccessTrustProviderCommand
 */
export declare const de_CreateVerifiedAccessTrustProviderCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVerifiedAccessTrustProviderCommandOutput>;
/**
 * deserializeAws_ec2CreateVolumeCommand
 */
export declare const de_CreateVolumeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVolumeCommandOutput>;
/**
 * deserializeAws_ec2CreateVpcCommand
 */
export declare const de_CreateVpcCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVpcCommandOutput>;
/**
 * deserializeAws_ec2CreateVpcEndpointCommand
 */
export declare const de_CreateVpcEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVpcEndpointCommandOutput>;
/**
 * deserializeAws_ec2CreateVpcEndpointConnectionNotificationCommand
 */
export declare const de_CreateVpcEndpointConnectionNotificationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVpcEndpointConnectionNotificationCommandOutput>;
/**
 * deserializeAws_ec2CreateVpcEndpointServiceConfigurationCommand
 */
export declare const de_CreateVpcEndpointServiceConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVpcEndpointServiceConfigurationCommandOutput>;
/**
 * deserializeAws_ec2CreateVpcPeeringConnectionCommand
 */
export declare const de_CreateVpcPeeringConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVpcPeeringConnectionCommandOutput>;
/**
 * deserializeAws_ec2CreateVpnConnectionCommand
 */
export declare const de_CreateVpnConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVpnConnectionCommandOutput>;
/**
 * deserializeAws_ec2CreateVpnConnectionRouteCommand
 */
export declare const de_CreateVpnConnectionRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVpnConnectionRouteCommandOutput>;
/**
 * deserializeAws_ec2CreateVpnGatewayCommand
 */
export declare const de_CreateVpnGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVpnGatewayCommandOutput>;
/**
 * deserializeAws_ec2DeleteCarrierGatewayCommand
 */
export declare const de_DeleteCarrierGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteCarrierGatewayCommandOutput>;
/**
 * deserializeAws_ec2DeleteClientVpnEndpointCommand
 */
export declare const de_DeleteClientVpnEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteClientVpnEndpointCommandOutput>;
/**
 * deserializeAws_ec2DeleteClientVpnRouteCommand
 */
export declare const de_DeleteClientVpnRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteClientVpnRouteCommandOutput>;
/**
 * deserializeAws_ec2DeleteCoipCidrCommand
 */
export declare const de_DeleteCoipCidrCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteCoipCidrCommandOutput>;
/**
 * deserializeAws_ec2DeleteCoipPoolCommand
 */
export declare const de_DeleteCoipPoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteCoipPoolCommandOutput>;
/**
 * deserializeAws_ec2DeleteCustomerGatewayCommand
 */
export declare const de_DeleteCustomerGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteCustomerGatewayCommandOutput>;
/**
 * deserializeAws_ec2DeleteDhcpOptionsCommand
 */
export declare const de_DeleteDhcpOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDhcpOptionsCommandOutput>;
/**
 * deserializeAws_ec2DeleteEgressOnlyInternetGatewayCommand
 */
export declare const de_DeleteEgressOnlyInternetGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteEgressOnlyInternetGatewayCommandOutput>;
/**
 * deserializeAws_ec2DeleteFleetsCommand
 */
export declare const de_DeleteFleetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteFleetsCommandOutput>;
/**
 * deserializeAws_ec2DeleteFlowLogsCommand
 */
export declare const de_DeleteFlowLogsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteFlowLogsCommandOutput>;
/**
 * deserializeAws_ec2DeleteFpgaImageCommand
 */
export declare const de_DeleteFpgaImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteFpgaImageCommandOutput>;
/**
 * deserializeAws_ec2DeleteInstanceConnectEndpointCommand
 */
export declare const de_DeleteInstanceConnectEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteInstanceConnectEndpointCommandOutput>;
/**
 * deserializeAws_ec2DeleteInstanceEventWindowCommand
 */
export declare const de_DeleteInstanceEventWindowCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteInstanceEventWindowCommandOutput>;
/**
 * deserializeAws_ec2DeleteInternetGatewayCommand
 */
export declare const de_DeleteInternetGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteInternetGatewayCommandOutput>;
/**
 * deserializeAws_ec2DeleteIpamCommand
 */
export declare const de_DeleteIpamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteIpamCommandOutput>;
/**
 * deserializeAws_ec2DeleteIpamPoolCommand
 */
export declare const de_DeleteIpamPoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteIpamPoolCommandOutput>;
/**
 * deserializeAws_ec2DeleteIpamResourceDiscoveryCommand
 */
export declare const de_DeleteIpamResourceDiscoveryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteIpamResourceDiscoveryCommandOutput>;
/**
 * deserializeAws_ec2DeleteIpamScopeCommand
 */
export declare const de_DeleteIpamScopeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteIpamScopeCommandOutput>;
/**
 * deserializeAws_ec2DeleteKeyPairCommand
 */
export declare const de_DeleteKeyPairCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteKeyPairCommandOutput>;
/**
 * deserializeAws_ec2DeleteLaunchTemplateCommand
 */
export declare const de_DeleteLaunchTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteLaunchTemplateCommandOutput>;
/**
 * deserializeAws_ec2DeleteLaunchTemplateVersionsCommand
 */
export declare const de_DeleteLaunchTemplateVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteLaunchTemplateVersionsCommandOutput>;
/**
 * deserializeAws_ec2DeleteLocalGatewayRouteCommand
 */
export declare const de_DeleteLocalGatewayRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteLocalGatewayRouteCommandOutput>;
/**
 * deserializeAws_ec2DeleteLocalGatewayRouteTableCommand
 */
export declare const de_DeleteLocalGatewayRouteTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteLocalGatewayRouteTableCommandOutput>;
/**
 * deserializeAws_ec2DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommand
 */
export declare const de_DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationCommandOutput>;
/**
 * deserializeAws_ec2DeleteLocalGatewayRouteTableVpcAssociationCommand
 */
export declare const de_DeleteLocalGatewayRouteTableVpcAssociationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteLocalGatewayRouteTableVpcAssociationCommandOutput>;
/**
 * deserializeAws_ec2DeleteManagedPrefixListCommand
 */
export declare const de_DeleteManagedPrefixListCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteManagedPrefixListCommandOutput>;
/**
 * deserializeAws_ec2DeleteNatGatewayCommand
 */
export declare const de_DeleteNatGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteNatGatewayCommandOutput>;
/**
 * deserializeAws_ec2DeleteNetworkAclCommand
 */
export declare const de_DeleteNetworkAclCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteNetworkAclCommandOutput>;
/**
 * deserializeAws_ec2DeleteNetworkAclEntryCommand
 */
export declare const de_DeleteNetworkAclEntryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteNetworkAclEntryCommandOutput>;
/**
 * deserializeAws_ec2DeleteNetworkInsightsAccessScopeCommand
 */
export declare const de_DeleteNetworkInsightsAccessScopeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteNetworkInsightsAccessScopeCommandOutput>;
/**
 * deserializeAws_ec2DeleteNetworkInsightsAccessScopeAnalysisCommand
 */
export declare const de_DeleteNetworkInsightsAccessScopeAnalysisCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteNetworkInsightsAccessScopeAnalysisCommandOutput>;
/**
 * deserializeAws_ec2DeleteNetworkInsightsAnalysisCommand
 */
export declare const de_DeleteNetworkInsightsAnalysisCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteNetworkInsightsAnalysisCommandOutput>;
/**
 * deserializeAws_ec2DeleteNetworkInsightsPathCommand
 */
export declare const de_DeleteNetworkInsightsPathCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteNetworkInsightsPathCommandOutput>;
/**
 * deserializeAws_ec2DeleteNetworkInterfaceCommand
 */
export declare const de_DeleteNetworkInterfaceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteNetworkInterfaceCommandOutput>;
/**
 * deserializeAws_ec2DeleteNetworkInterfacePermissionCommand
 */
export declare const de_DeleteNetworkInterfacePermissionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteNetworkInterfacePermissionCommandOutput>;
/**
 * deserializeAws_ec2DeletePlacementGroupCommand
 */
export declare const de_DeletePlacementGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeletePlacementGroupCommandOutput>;
/**
 * deserializeAws_ec2DeletePublicIpv4PoolCommand
 */
export declare const de_DeletePublicIpv4PoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeletePublicIpv4PoolCommandOutput>;
/**
 * deserializeAws_ec2DeleteQueuedReservedInstancesCommand
 */
export declare const de_DeleteQueuedReservedInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteQueuedReservedInstancesCommandOutput>;
/**
 * deserializeAws_ec2DeleteRouteCommand
 */
export declare const de_DeleteRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRouteCommandOutput>;
/**
 * deserializeAws_ec2DeleteRouteTableCommand
 */
export declare const de_DeleteRouteTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRouteTableCommandOutput>;
/**
 * deserializeAws_ec2DeleteSecurityGroupCommand
 */
export declare const de_DeleteSecurityGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteSecurityGroupCommandOutput>;
/**
 * deserializeAws_ec2DeleteSnapshotCommand
 */
export declare const de_DeleteSnapshotCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteSnapshotCommandOutput>;
/**
 * deserializeAws_ec2DeleteSpotDatafeedSubscriptionCommand
 */
export declare const de_DeleteSpotDatafeedSubscriptionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteSpotDatafeedSubscriptionCommandOutput>;
/**
 * deserializeAws_ec2DeleteSubnetCommand
 */
export declare const de_DeleteSubnetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteSubnetCommandOutput>;
/**
 * deserializeAws_ec2DeleteSubnetCidrReservationCommand
 */
export declare const de_DeleteSubnetCidrReservationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteSubnetCidrReservationCommandOutput>;
/**
 * deserializeAws_ec2DeleteTagsCommand
 */
export declare const de_DeleteTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTagsCommandOutput>;
/**
 * deserializeAws_ec2DeleteTrafficMirrorFilterCommand
 */
export declare const de_DeleteTrafficMirrorFilterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTrafficMirrorFilterCommandOutput>;
/**
 * deserializeAws_ec2DeleteTrafficMirrorFilterRuleCommand
 */
export declare const de_DeleteTrafficMirrorFilterRuleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTrafficMirrorFilterRuleCommandOutput>;
/**
 * deserializeAws_ec2DeleteTrafficMirrorSessionCommand
 */
export declare const de_DeleteTrafficMirrorSessionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTrafficMirrorSessionCommandOutput>;
/**
 * deserializeAws_ec2DeleteTrafficMirrorTargetCommand
 */
export declare const de_DeleteTrafficMirrorTargetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTrafficMirrorTargetCommandOutput>;
/**
 * deserializeAws_ec2DeleteTransitGatewayCommand
 */
export declare const de_DeleteTransitGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTransitGatewayCommandOutput>;
/**
 * deserializeAws_ec2DeleteTransitGatewayConnectCommand
 */
export declare const de_DeleteTransitGatewayConnectCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTransitGatewayConnectCommandOutput>;
/**
 * deserializeAws_ec2DeleteTransitGatewayConnectPeerCommand
 */
export declare const de_DeleteTransitGatewayConnectPeerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTransitGatewayConnectPeerCommandOutput>;
/**
 * deserializeAws_ec2DeleteTransitGatewayMulticastDomainCommand
 */
export declare const de_DeleteTransitGatewayMulticastDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTransitGatewayMulticastDomainCommandOutput>;
/**
 * deserializeAws_ec2DeleteTransitGatewayPeeringAttachmentCommand
 */
export declare const de_DeleteTransitGatewayPeeringAttachmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTransitGatewayPeeringAttachmentCommandOutput>;
/**
 * deserializeAws_ec2DeleteTransitGatewayPolicyTableCommand
 */
export declare const de_DeleteTransitGatewayPolicyTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTransitGatewayPolicyTableCommandOutput>;
/**
 * deserializeAws_ec2DeleteTransitGatewayPrefixListReferenceCommand
 */
export declare const de_DeleteTransitGatewayPrefixListReferenceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTransitGatewayPrefixListReferenceCommandOutput>;
/**
 * deserializeAws_ec2DeleteTransitGatewayRouteCommand
 */
export declare const de_DeleteTransitGatewayRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTransitGatewayRouteCommandOutput>;
/**
 * deserializeAws_ec2DeleteTransitGatewayRouteTableCommand
 */
export declare const de_DeleteTransitGatewayRouteTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTransitGatewayRouteTableCommandOutput>;
/**
 * deserializeAws_ec2DeleteTransitGatewayRouteTableAnnouncementCommand
 */
export declare const de_DeleteTransitGatewayRouteTableAnnouncementCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTransitGatewayRouteTableAnnouncementCommandOutput>;
/**
 * deserializeAws_ec2DeleteTransitGatewayVpcAttachmentCommand
 */
export declare const de_DeleteTransitGatewayVpcAttachmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTransitGatewayVpcAttachmentCommandOutput>;
/**
 * deserializeAws_ec2DeleteVerifiedAccessEndpointCommand
 */
export declare const de_DeleteVerifiedAccessEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVerifiedAccessEndpointCommandOutput>;
/**
 * deserializeAws_ec2DeleteVerifiedAccessGroupCommand
 */
export declare const de_DeleteVerifiedAccessGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVerifiedAccessGroupCommandOutput>;
/**
 * deserializeAws_ec2DeleteVerifiedAccessInstanceCommand
 */
export declare const de_DeleteVerifiedAccessInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVerifiedAccessInstanceCommandOutput>;
/**
 * deserializeAws_ec2DeleteVerifiedAccessTrustProviderCommand
 */
export declare const de_DeleteVerifiedAccessTrustProviderCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVerifiedAccessTrustProviderCommandOutput>;
/**
 * deserializeAws_ec2DeleteVolumeCommand
 */
export declare const de_DeleteVolumeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVolumeCommandOutput>;
/**
 * deserializeAws_ec2DeleteVpcCommand
 */
export declare const de_DeleteVpcCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVpcCommandOutput>;
/**
 * deserializeAws_ec2DeleteVpcEndpointConnectionNotificationsCommand
 */
export declare const de_DeleteVpcEndpointConnectionNotificationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVpcEndpointConnectionNotificationsCommandOutput>;
/**
 * deserializeAws_ec2DeleteVpcEndpointsCommand
 */
export declare const de_DeleteVpcEndpointsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVpcEndpointsCommandOutput>;
/**
 * deserializeAws_ec2DeleteVpcEndpointServiceConfigurationsCommand
 */
export declare const de_DeleteVpcEndpointServiceConfigurationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVpcEndpointServiceConfigurationsCommandOutput>;
/**
 * deserializeAws_ec2DeleteVpcPeeringConnectionCommand
 */
export declare const de_DeleteVpcPeeringConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVpcPeeringConnectionCommandOutput>;
/**
 * deserializeAws_ec2DeleteVpnConnectionCommand
 */
export declare const de_DeleteVpnConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVpnConnectionCommandOutput>;
/**
 * deserializeAws_ec2DeleteVpnConnectionRouteCommand
 */
export declare const de_DeleteVpnConnectionRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVpnConnectionRouteCommandOutput>;
/**
 * deserializeAws_ec2DeleteVpnGatewayCommand
 */
export declare const de_DeleteVpnGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVpnGatewayCommandOutput>;
/**
 * deserializeAws_ec2DeprovisionByoipCidrCommand
 */
export declare const de_DeprovisionByoipCidrCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeprovisionByoipCidrCommandOutput>;
/**
 * deserializeAws_ec2DeprovisionIpamByoasnCommand
 */
export declare const de_DeprovisionIpamByoasnCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeprovisionIpamByoasnCommandOutput>;
/**
 * deserializeAws_ec2DeprovisionIpamPoolCidrCommand
 */
export declare const de_DeprovisionIpamPoolCidrCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeprovisionIpamPoolCidrCommandOutput>;
/**
 * deserializeAws_ec2DeprovisionPublicIpv4PoolCidrCommand
 */
export declare const de_DeprovisionPublicIpv4PoolCidrCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeprovisionPublicIpv4PoolCidrCommandOutput>;
/**
 * deserializeAws_ec2DeregisterImageCommand
 */
export declare const de_DeregisterImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeregisterImageCommandOutput>;
/**
 * deserializeAws_ec2DeregisterInstanceEventNotificationAttributesCommand
 */
export declare const de_DeregisterInstanceEventNotificationAttributesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeregisterInstanceEventNotificationAttributesCommandOutput>;
/**
 * deserializeAws_ec2DeregisterTransitGatewayMulticastGroupMembersCommand
 */
export declare const de_DeregisterTransitGatewayMulticastGroupMembersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeregisterTransitGatewayMulticastGroupMembersCommandOutput>;
/**
 * deserializeAws_ec2DeregisterTransitGatewayMulticastGroupSourcesCommand
 */
export declare const de_DeregisterTransitGatewayMulticastGroupSourcesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeregisterTransitGatewayMulticastGroupSourcesCommandOutput>;
/**
 * deserializeAws_ec2DescribeAccountAttributesCommand
 */
export declare const de_DescribeAccountAttributesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAccountAttributesCommandOutput>;
/**
 * deserializeAws_ec2DescribeAddressesCommand
 */
export declare const de_DescribeAddressesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAddressesCommandOutput>;
/**
 * deserializeAws_ec2DescribeAddressesAttributeCommand
 */
export declare const de_DescribeAddressesAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAddressesAttributeCommandOutput>;
/**
 * deserializeAws_ec2DescribeAddressTransfersCommand
 */
export declare const de_DescribeAddressTransfersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAddressTransfersCommandOutput>;
/**
 * deserializeAws_ec2DescribeAggregateIdFormatCommand
 */
export declare const de_DescribeAggregateIdFormatCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAggregateIdFormatCommandOutput>;
/**
 * deserializeAws_ec2DescribeAvailabilityZonesCommand
 */
export declare const de_DescribeAvailabilityZonesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAvailabilityZonesCommandOutput>;
/**
 * deserializeAws_ec2DescribeAwsNetworkPerformanceMetricSubscriptionsCommand
 */
export declare const de_DescribeAwsNetworkPerformanceMetricSubscriptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAwsNetworkPerformanceMetricSubscriptionsCommandOutput>;
/**
 * deserializeAws_ec2DescribeBundleTasksCommand
 */
export declare const de_DescribeBundleTasksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeBundleTasksCommandOutput>;
/**
 * deserializeAws_ec2DescribeByoipCidrsCommand
 */
export declare const de_DescribeByoipCidrsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeByoipCidrsCommandOutput>;
/**
 * deserializeAws_ec2DescribeCapacityBlockOfferingsCommand
 */
export declare const de_DescribeCapacityBlockOfferingsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeCapacityBlockOfferingsCommandOutput>;
/**
 * deserializeAws_ec2DescribeCapacityReservationFleetsCommand
 */
export declare const de_DescribeCapacityReservationFleetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeCapacityReservationFleetsCommandOutput>;
/**
 * deserializeAws_ec2DescribeCapacityReservationsCommand
 */
export declare const de_DescribeCapacityReservationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeCapacityReservationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeCarrierGatewaysCommand
 */
export declare const de_DescribeCarrierGatewaysCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeCarrierGatewaysCommandOutput>;
/**
 * deserializeAws_ec2DescribeClassicLinkInstancesCommand
 */
export declare const de_DescribeClassicLinkInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeClassicLinkInstancesCommandOutput>;
/**
 * deserializeAws_ec2DescribeClientVpnAuthorizationRulesCommand
 */
export declare const de_DescribeClientVpnAuthorizationRulesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeClientVpnAuthorizationRulesCommandOutput>;
/**
 * deserializeAws_ec2DescribeClientVpnConnectionsCommand
 */
export declare const de_DescribeClientVpnConnectionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeClientVpnConnectionsCommandOutput>;
/**
 * deserializeAws_ec2DescribeClientVpnEndpointsCommand
 */
export declare const de_DescribeClientVpnEndpointsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeClientVpnEndpointsCommandOutput>;
/**
 * deserializeAws_ec2DescribeClientVpnRoutesCommand
 */
export declare const de_DescribeClientVpnRoutesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeClientVpnRoutesCommandOutput>;
/**
 * deserializeAws_ec2DescribeClientVpnTargetNetworksCommand
 */
export declare const de_DescribeClientVpnTargetNetworksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeClientVpnTargetNetworksCommandOutput>;
/**
 * deserializeAws_ec2DescribeCoipPoolsCommand
 */
export declare const de_DescribeCoipPoolsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeCoipPoolsCommandOutput>;
/**
 * deserializeAws_ec2DescribeConversionTasksCommand
 */
export declare const de_DescribeConversionTasksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeConversionTasksCommandOutput>;
/**
 * deserializeAws_ec2DescribeCustomerGatewaysCommand
 */
export declare const de_DescribeCustomerGatewaysCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeCustomerGatewaysCommandOutput>;
/**
 * deserializeAws_ec2DescribeDhcpOptionsCommand
 */
export declare const de_DescribeDhcpOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDhcpOptionsCommandOutput>;
/**
 * deserializeAws_ec2DescribeEgressOnlyInternetGatewaysCommand
 */
export declare const de_DescribeEgressOnlyInternetGatewaysCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeEgressOnlyInternetGatewaysCommandOutput>;
/**
 * deserializeAws_ec2DescribeElasticGpusCommand
 */
export declare const de_DescribeElasticGpusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeElasticGpusCommandOutput>;
/**
 * deserializeAws_ec2DescribeExportImageTasksCommand
 */
export declare const de_DescribeExportImageTasksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeExportImageTasksCommandOutput>;
/**
 * deserializeAws_ec2DescribeExportTasksCommand
 */
export declare const de_DescribeExportTasksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeExportTasksCommandOutput>;
/**
 * deserializeAws_ec2DescribeFastLaunchImagesCommand
 */
export declare const de_DescribeFastLaunchImagesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeFastLaunchImagesCommandOutput>;
/**
 * deserializeAws_ec2DescribeFastSnapshotRestoresCommand
 */
export declare const de_DescribeFastSnapshotRestoresCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeFastSnapshotRestoresCommandOutput>;
/**
 * deserializeAws_ec2DescribeFleetHistoryCommand
 */
export declare const de_DescribeFleetHistoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeFleetHistoryCommandOutput>;
/**
 * deserializeAws_ec2DescribeFleetInstancesCommand
 */
export declare const de_DescribeFleetInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeFleetInstancesCommandOutput>;
/**
 * deserializeAws_ec2DescribeFleetsCommand
 */
export declare const de_DescribeFleetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeFleetsCommandOutput>;
/**
 * deserializeAws_ec2DescribeFlowLogsCommand
 */
export declare const de_DescribeFlowLogsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeFlowLogsCommandOutput>;
/**
 * deserializeAws_ec2DescribeFpgaImageAttributeCommand
 */
export declare const de_DescribeFpgaImageAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeFpgaImageAttributeCommandOutput>;
/**
 * deserializeAws_ec2DescribeFpgaImagesCommand
 */
export declare const de_DescribeFpgaImagesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeFpgaImagesCommandOutput>;
/**
 * deserializeAws_ec2DescribeHostReservationOfferingsCommand
 */
export declare const de_DescribeHostReservationOfferingsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeHostReservationOfferingsCommandOutput>;
/**
 * deserializeAws_ec2DescribeHostReservationsCommand
 */
export declare const de_DescribeHostReservationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeHostReservationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeHostsCommand
 */
export declare const de_DescribeHostsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeHostsCommandOutput>;
/**
 * deserializeAws_ec2DescribeIamInstanceProfileAssociationsCommand
 */
export declare const de_DescribeIamInstanceProfileAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeIamInstanceProfileAssociationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeIdentityIdFormatCommand
 */
export declare const de_DescribeIdentityIdFormatCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeIdentityIdFormatCommandOutput>;
/**
 * deserializeAws_ec2DescribeIdFormatCommand
 */
export declare const de_DescribeIdFormatCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeIdFormatCommandOutput>;
/**
 * deserializeAws_ec2DescribeImageAttributeCommand
 */
export declare const de_DescribeImageAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeImageAttributeCommandOutput>;
/**
 * deserializeAws_ec2DescribeImagesCommand
 */
export declare const de_DescribeImagesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeImagesCommandOutput>;
/**
 * deserializeAws_ec2DescribeImportImageTasksCommand
 */
export declare const de_DescribeImportImageTasksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeImportImageTasksCommandOutput>;
/**
 * deserializeAws_ec2DescribeImportSnapshotTasksCommand
 */
export declare const de_DescribeImportSnapshotTasksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeImportSnapshotTasksCommandOutput>;
/**
 * deserializeAws_ec2DescribeInstanceAttributeCommand
 */
export declare const de_DescribeInstanceAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceAttributeCommandOutput>;
/**
 * deserializeAws_ec2DescribeInstanceConnectEndpointsCommand
 */
export declare const de_DescribeInstanceConnectEndpointsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceConnectEndpointsCommandOutput>;
/**
 * deserializeAws_ec2DescribeInstanceCreditSpecificationsCommand
 */
export declare const de_DescribeInstanceCreditSpecificationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceCreditSpecificationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeInstanceEventNotificationAttributesCommand
 */
export declare const de_DescribeInstanceEventNotificationAttributesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceEventNotificationAttributesCommandOutput>;
/**
 * deserializeAws_ec2DescribeInstanceEventWindowsCommand
 */
export declare const de_DescribeInstanceEventWindowsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceEventWindowsCommandOutput>;
/**
 * deserializeAws_ec2DescribeInstancesCommand
 */
export declare const de_DescribeInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstancesCommandOutput>;
/**
 * deserializeAws_ec2DescribeInstanceStatusCommand
 */
export declare const de_DescribeInstanceStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceStatusCommandOutput>;
/**
 * deserializeAws_ec2DescribeInstanceTopologyCommand
 */
export declare const de_DescribeInstanceTopologyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceTopologyCommandOutput>;
/**
 * deserializeAws_ec2DescribeInstanceTypeOfferingsCommand
 */
export declare const de_DescribeInstanceTypeOfferingsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceTypeOfferingsCommandOutput>;
/**
 * deserializeAws_ec2DescribeInstanceTypesCommand
 */
export declare const de_DescribeInstanceTypesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceTypesCommandOutput>;
/**
 * deserializeAws_ec2DescribeInternetGatewaysCommand
 */
export declare const de_DescribeInternetGatewaysCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInternetGatewaysCommandOutput>;
/**
 * deserializeAws_ec2DescribeIpamByoasnCommand
 */
export declare const de_DescribeIpamByoasnCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeIpamByoasnCommandOutput>;
/**
 * deserializeAws_ec2DescribeIpamPoolsCommand
 */
export declare const de_DescribeIpamPoolsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeIpamPoolsCommandOutput>;
/**
 * deserializeAws_ec2DescribeIpamResourceDiscoveriesCommand
 */
export declare const de_DescribeIpamResourceDiscoveriesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeIpamResourceDiscoveriesCommandOutput>;
/**
 * deserializeAws_ec2DescribeIpamResourceDiscoveryAssociationsCommand
 */
export declare const de_DescribeIpamResourceDiscoveryAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeIpamResourceDiscoveryAssociationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeIpamsCommand
 */
export declare const de_DescribeIpamsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeIpamsCommandOutput>;
/**
 * deserializeAws_ec2DescribeIpamScopesCommand
 */
export declare const de_DescribeIpamScopesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeIpamScopesCommandOutput>;
/**
 * deserializeAws_ec2DescribeIpv6PoolsCommand
 */
export declare const de_DescribeIpv6PoolsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeIpv6PoolsCommandOutput>;
/**
 * deserializeAws_ec2DescribeKeyPairsCommand
 */
export declare const de_DescribeKeyPairsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeKeyPairsCommandOutput>;
/**
 * deserializeAws_ec2DescribeLaunchTemplatesCommand
 */
export declare const de_DescribeLaunchTemplatesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLaunchTemplatesCommandOutput>;
/**
 * deserializeAws_ec2DescribeLaunchTemplateVersionsCommand
 */
export declare const de_DescribeLaunchTemplateVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLaunchTemplateVersionsCommandOutput>;
/**
 * deserializeAws_ec2DescribeLocalGatewayRouteTablesCommand
 */
export declare const de_DescribeLocalGatewayRouteTablesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLocalGatewayRouteTablesCommandOutput>;
/**
 * deserializeAws_ec2DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsCommand
 */
export declare const de_DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeLocalGatewayRouteTableVpcAssociationsCommand
 */
export declare const de_DescribeLocalGatewayRouteTableVpcAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLocalGatewayRouteTableVpcAssociationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeLocalGatewaysCommand
 */
export declare const de_DescribeLocalGatewaysCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLocalGatewaysCommandOutput>;
/**
 * deserializeAws_ec2DescribeLocalGatewayVirtualInterfaceGroupsCommand
 */
export declare const de_DescribeLocalGatewayVirtualInterfaceGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLocalGatewayVirtualInterfaceGroupsCommandOutput>;
/**
 * deserializeAws_ec2DescribeLocalGatewayVirtualInterfacesCommand
 */
export declare const de_DescribeLocalGatewayVirtualInterfacesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLocalGatewayVirtualInterfacesCommandOutput>;
/**
 * deserializeAws_ec2DescribeLockedSnapshotsCommand
 */
export declare const de_DescribeLockedSnapshotsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeLockedSnapshotsCommandOutput>;
/**
 * deserializeAws_ec2DescribeMacHostsCommand
 */
export declare const de_DescribeMacHostsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeMacHostsCommandOutput>;
/**
 * deserializeAws_ec2DescribeManagedPrefixListsCommand
 */
export declare const de_DescribeManagedPrefixListsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeManagedPrefixListsCommandOutput>;
/**
 * deserializeAws_ec2DescribeMovingAddressesCommand
 */
export declare const de_DescribeMovingAddressesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeMovingAddressesCommandOutput>;
/**
 * deserializeAws_ec2DescribeNatGatewaysCommand
 */
export declare const de_DescribeNatGatewaysCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeNatGatewaysCommandOutput>;
/**
 * deserializeAws_ec2DescribeNetworkAclsCommand
 */
export declare const de_DescribeNetworkAclsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeNetworkAclsCommandOutput>;
/**
 * deserializeAws_ec2DescribeNetworkInsightsAccessScopeAnalysesCommand
 */
export declare const de_DescribeNetworkInsightsAccessScopeAnalysesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeNetworkInsightsAccessScopeAnalysesCommandOutput>;
/**
 * deserializeAws_ec2DescribeNetworkInsightsAccessScopesCommand
 */
export declare const de_DescribeNetworkInsightsAccessScopesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeNetworkInsightsAccessScopesCommandOutput>;
/**
 * deserializeAws_ec2DescribeNetworkInsightsAnalysesCommand
 */
export declare const de_DescribeNetworkInsightsAnalysesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeNetworkInsightsAnalysesCommandOutput>;
/**
 * deserializeAws_ec2DescribeNetworkInsightsPathsCommand
 */
export declare const de_DescribeNetworkInsightsPathsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeNetworkInsightsPathsCommandOutput>;
/**
 * deserializeAws_ec2DescribeNetworkInterfaceAttributeCommand
 */
export declare const de_DescribeNetworkInterfaceAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeNetworkInterfaceAttributeCommandOutput>;
/**
 * deserializeAws_ec2DescribeNetworkInterfacePermissionsCommand
 */
export declare const de_DescribeNetworkInterfacePermissionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeNetworkInterfacePermissionsCommandOutput>;
/**
 * deserializeAws_ec2DescribeNetworkInterfacesCommand
 */
export declare const de_DescribeNetworkInterfacesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeNetworkInterfacesCommandOutput>;
/**
 * deserializeAws_ec2DescribePlacementGroupsCommand
 */
export declare const de_DescribePlacementGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePlacementGroupsCommandOutput>;
/**
 * deserializeAws_ec2DescribePrefixListsCommand
 */
export declare const de_DescribePrefixListsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePrefixListsCommandOutput>;
/**
 * deserializeAws_ec2DescribePrincipalIdFormatCommand
 */
export declare const de_DescribePrincipalIdFormatCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePrincipalIdFormatCommandOutput>;
/**
 * deserializeAws_ec2DescribePublicIpv4PoolsCommand
 */
export declare const de_DescribePublicIpv4PoolsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePublicIpv4PoolsCommandOutput>;
/**
 * deserializeAws_ec2DescribeRegionsCommand
 */
export declare const de_DescribeRegionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeRegionsCommandOutput>;
/**
 * deserializeAws_ec2DescribeReplaceRootVolumeTasksCommand
 */
export declare const de_DescribeReplaceRootVolumeTasksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeReplaceRootVolumeTasksCommandOutput>;
/**
 * deserializeAws_ec2DescribeReservedInstancesCommand
 */
export declare const de_DescribeReservedInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeReservedInstancesCommandOutput>;
/**
 * deserializeAws_ec2DescribeReservedInstancesListingsCommand
 */
export declare const de_DescribeReservedInstancesListingsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeReservedInstancesListingsCommandOutput>;
/**
 * deserializeAws_ec2DescribeReservedInstancesModificationsCommand
 */
export declare const de_DescribeReservedInstancesModificationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeReservedInstancesModificationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeReservedInstancesOfferingsCommand
 */
export declare const de_DescribeReservedInstancesOfferingsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeReservedInstancesOfferingsCommandOutput>;
/**
 * deserializeAws_ec2DescribeRouteTablesCommand
 */
export declare const de_DescribeRouteTablesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeRouteTablesCommandOutput>;
/**
 * deserializeAws_ec2DescribeScheduledInstanceAvailabilityCommand
 */
export declare const de_DescribeScheduledInstanceAvailabilityCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeScheduledInstanceAvailabilityCommandOutput>;
/**
 * deserializeAws_ec2DescribeScheduledInstancesCommand
 */
export declare const de_DescribeScheduledInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeScheduledInstancesCommandOutput>;
/**
 * deserializeAws_ec2DescribeSecurityGroupReferencesCommand
 */
export declare const de_DescribeSecurityGroupReferencesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSecurityGroupReferencesCommandOutput>;
/**
 * deserializeAws_ec2DescribeSecurityGroupRulesCommand
 */
export declare const de_DescribeSecurityGroupRulesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSecurityGroupRulesCommandOutput>;
/**
 * deserializeAws_ec2DescribeSecurityGroupsCommand
 */
export declare const de_DescribeSecurityGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSecurityGroupsCommandOutput>;
/**
 * deserializeAws_ec2DescribeSnapshotAttributeCommand
 */
export declare const de_DescribeSnapshotAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSnapshotAttributeCommandOutput>;
/**
 * deserializeAws_ec2DescribeSnapshotsCommand
 */
export declare const de_DescribeSnapshotsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSnapshotsCommandOutput>;
/**
 * deserializeAws_ec2DescribeSnapshotTierStatusCommand
 */
export declare const de_DescribeSnapshotTierStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSnapshotTierStatusCommandOutput>;
/**
 * deserializeAws_ec2DescribeSpotDatafeedSubscriptionCommand
 */
export declare const de_DescribeSpotDatafeedSubscriptionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSpotDatafeedSubscriptionCommandOutput>;
/**
 * deserializeAws_ec2DescribeSpotFleetInstancesCommand
 */
export declare const de_DescribeSpotFleetInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSpotFleetInstancesCommandOutput>;
/**
 * deserializeAws_ec2DescribeSpotFleetRequestHistoryCommand
 */
export declare const de_DescribeSpotFleetRequestHistoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSpotFleetRequestHistoryCommandOutput>;
/**
 * deserializeAws_ec2DescribeSpotFleetRequestsCommand
 */
export declare const de_DescribeSpotFleetRequestsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSpotFleetRequestsCommandOutput>;
/**
 * deserializeAws_ec2DescribeSpotInstanceRequestsCommand
 */
export declare const de_DescribeSpotInstanceRequestsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSpotInstanceRequestsCommandOutput>;
/**
 * deserializeAws_ec2DescribeSpotPriceHistoryCommand
 */
export declare const de_DescribeSpotPriceHistoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSpotPriceHistoryCommandOutput>;
/**
 * deserializeAws_ec2DescribeStaleSecurityGroupsCommand
 */
export declare const de_DescribeStaleSecurityGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeStaleSecurityGroupsCommandOutput>;
/**
 * deserializeAws_ec2DescribeStoreImageTasksCommand
 */
export declare const de_DescribeStoreImageTasksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeStoreImageTasksCommandOutput>;
/**
 * deserializeAws_ec2DescribeSubnetsCommand
 */
export declare const de_DescribeSubnetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeSubnetsCommandOutput>;
/**
 * deserializeAws_ec2DescribeTagsCommand
 */
export declare const de_DescribeTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTagsCommandOutput>;
/**
 * deserializeAws_ec2DescribeTrafficMirrorFiltersCommand
 */
export declare const de_DescribeTrafficMirrorFiltersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTrafficMirrorFiltersCommandOutput>;
/**
 * deserializeAws_ec2DescribeTrafficMirrorSessionsCommand
 */
export declare const de_DescribeTrafficMirrorSessionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTrafficMirrorSessionsCommandOutput>;
/**
 * deserializeAws_ec2DescribeTrafficMirrorTargetsCommand
 */
export declare const de_DescribeTrafficMirrorTargetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTrafficMirrorTargetsCommandOutput>;
/**
 * deserializeAws_ec2DescribeTransitGatewayAttachmentsCommand
 */
export declare const de_DescribeTransitGatewayAttachmentsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTransitGatewayAttachmentsCommandOutput>;
/**
 * deserializeAws_ec2DescribeTransitGatewayConnectPeersCommand
 */
export declare const de_DescribeTransitGatewayConnectPeersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTransitGatewayConnectPeersCommandOutput>;
/**
 * deserializeAws_ec2DescribeTransitGatewayConnectsCommand
 */
export declare const de_DescribeTransitGatewayConnectsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTransitGatewayConnectsCommandOutput>;
/**
 * deserializeAws_ec2DescribeTransitGatewayMulticastDomainsCommand
 */
export declare const de_DescribeTransitGatewayMulticastDomainsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTransitGatewayMulticastDomainsCommandOutput>;
/**
 * deserializeAws_ec2DescribeTransitGatewayPeeringAttachmentsCommand
 */
export declare const de_DescribeTransitGatewayPeeringAttachmentsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTransitGatewayPeeringAttachmentsCommandOutput>;
/**
 * deserializeAws_ec2DescribeTransitGatewayPolicyTablesCommand
 */
export declare const de_DescribeTransitGatewayPolicyTablesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTransitGatewayPolicyTablesCommandOutput>;
/**
 * deserializeAws_ec2DescribeTransitGatewayRouteTableAnnouncementsCommand
 */
export declare const de_DescribeTransitGatewayRouteTableAnnouncementsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTransitGatewayRouteTableAnnouncementsCommandOutput>;
/**
 * deserializeAws_ec2DescribeTransitGatewayRouteTablesCommand
 */
export declare const de_DescribeTransitGatewayRouteTablesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTransitGatewayRouteTablesCommandOutput>;
/**
 * deserializeAws_ec2DescribeTransitGatewaysCommand
 */
export declare const de_DescribeTransitGatewaysCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTransitGatewaysCommandOutput>;
/**
 * deserializeAws_ec2DescribeTransitGatewayVpcAttachmentsCommand
 */
export declare const de_DescribeTransitGatewayVpcAttachmentsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTransitGatewayVpcAttachmentsCommandOutput>;
/**
 * deserializeAws_ec2DescribeTrunkInterfaceAssociationsCommand
 */
export declare const de_DescribeTrunkInterfaceAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTrunkInterfaceAssociationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVerifiedAccessEndpointsCommand
 */
export declare const de_DescribeVerifiedAccessEndpointsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVerifiedAccessEndpointsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVerifiedAccessGroupsCommand
 */
export declare const de_DescribeVerifiedAccessGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVerifiedAccessGroupsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVerifiedAccessInstanceLoggingConfigurationsCommand
 */
export declare const de_DescribeVerifiedAccessInstanceLoggingConfigurationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVerifiedAccessInstanceLoggingConfigurationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVerifiedAccessInstancesCommand
 */
export declare const de_DescribeVerifiedAccessInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVerifiedAccessInstancesCommandOutput>;
/**
 * deserializeAws_ec2DescribeVerifiedAccessTrustProvidersCommand
 */
export declare const de_DescribeVerifiedAccessTrustProvidersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVerifiedAccessTrustProvidersCommandOutput>;
/**
 * deserializeAws_ec2DescribeVolumeAttributeCommand
 */
export declare const de_DescribeVolumeAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVolumeAttributeCommandOutput>;
/**
 * deserializeAws_ec2DescribeVolumesCommand
 */
export declare const de_DescribeVolumesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVolumesCommandOutput>;
/**
 * deserializeAws_ec2DescribeVolumesModificationsCommand
 */
export declare const de_DescribeVolumesModificationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVolumesModificationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVolumeStatusCommand
 */
export declare const de_DescribeVolumeStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVolumeStatusCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpcAttributeCommand
 */
export declare const de_DescribeVpcAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpcAttributeCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpcClassicLinkCommand
 */
export declare const de_DescribeVpcClassicLinkCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpcClassicLinkCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpcClassicLinkDnsSupportCommand
 */
export declare const de_DescribeVpcClassicLinkDnsSupportCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpcClassicLinkDnsSupportCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpcEndpointConnectionNotificationsCommand
 */
export declare const de_DescribeVpcEndpointConnectionNotificationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpcEndpointConnectionNotificationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpcEndpointConnectionsCommand
 */
export declare const de_DescribeVpcEndpointConnectionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpcEndpointConnectionsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpcEndpointsCommand
 */
export declare const de_DescribeVpcEndpointsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpcEndpointsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpcEndpointServiceConfigurationsCommand
 */
export declare const de_DescribeVpcEndpointServiceConfigurationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpcEndpointServiceConfigurationsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpcEndpointServicePermissionsCommand
 */
export declare const de_DescribeVpcEndpointServicePermissionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpcEndpointServicePermissionsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpcEndpointServicesCommand
 */
export declare const de_DescribeVpcEndpointServicesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpcEndpointServicesCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpcPeeringConnectionsCommand
 */
export declare const de_DescribeVpcPeeringConnectionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpcPeeringConnectionsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpcsCommand
 */
export declare const de_DescribeVpcsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpcsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpnConnectionsCommand
 */
export declare const de_DescribeVpnConnectionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpnConnectionsCommandOutput>;
/**
 * deserializeAws_ec2DescribeVpnGatewaysCommand
 */
export declare const de_DescribeVpnGatewaysCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpnGatewaysCommandOutput>;
/**
 * deserializeAws_ec2DetachClassicLinkVpcCommand
 */
export declare const de_DetachClassicLinkVpcCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetachClassicLinkVpcCommandOutput>;
/**
 * deserializeAws_ec2DetachInternetGatewayCommand
 */
export declare const de_DetachInternetGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetachInternetGatewayCommandOutput>;
/**
 * deserializeAws_ec2DetachNetworkInterfaceCommand
 */
export declare const de_DetachNetworkInterfaceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetachNetworkInterfaceCommandOutput>;
/**
 * deserializeAws_ec2DetachVerifiedAccessTrustProviderCommand
 */
export declare const de_DetachVerifiedAccessTrustProviderCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetachVerifiedAccessTrustProviderCommandOutput>;
/**
 * deserializeAws_ec2DetachVolumeCommand
 */
export declare const de_DetachVolumeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetachVolumeCommandOutput>;
/**
 * deserializeAws_ec2DetachVpnGatewayCommand
 */
export declare const de_DetachVpnGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetachVpnGatewayCommandOutput>;
/**
 * deserializeAws_ec2DisableAddressTransferCommand
 */
export declare const de_DisableAddressTransferCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableAddressTransferCommandOutput>;
/**
 * deserializeAws_ec2DisableAwsNetworkPerformanceMetricSubscriptionCommand
 */
export declare const de_DisableAwsNetworkPerformanceMetricSubscriptionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableAwsNetworkPerformanceMetricSubscriptionCommandOutput>;
/**
 * deserializeAws_ec2DisableEbsEncryptionByDefaultCommand
 */
export declare const de_DisableEbsEncryptionByDefaultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableEbsEncryptionByDefaultCommandOutput>;
/**
 * deserializeAws_ec2DisableFastLaunchCommand
 */
export declare const de_DisableFastLaunchCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableFastLaunchCommandOutput>;
/**
 * deserializeAws_ec2DisableFastSnapshotRestoresCommand
 */
export declare const de_DisableFastSnapshotRestoresCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableFastSnapshotRestoresCommandOutput>;
/**
 * deserializeAws_ec2DisableImageCommand
 */
export declare const de_DisableImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableImageCommandOutput>;
/**
 * deserializeAws_ec2DisableImageBlockPublicAccessCommand
 */
export declare const de_DisableImageBlockPublicAccessCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableImageBlockPublicAccessCommandOutput>;
/**
 * deserializeAws_ec2DisableImageDeprecationCommand
 */
export declare const de_DisableImageDeprecationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableImageDeprecationCommandOutput>;
/**
 * deserializeAws_ec2DisableIpamOrganizationAdminAccountCommand
 */
export declare const de_DisableIpamOrganizationAdminAccountCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableIpamOrganizationAdminAccountCommandOutput>;
/**
 * deserializeAws_ec2DisableSerialConsoleAccessCommand
 */
export declare const de_DisableSerialConsoleAccessCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableSerialConsoleAccessCommandOutput>;
/**
 * deserializeAws_ec2DisableSnapshotBlockPublicAccessCommand
 */
export declare const de_DisableSnapshotBlockPublicAccessCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableSnapshotBlockPublicAccessCommandOutput>;
/**
 * deserializeAws_ec2DisableTransitGatewayRouteTablePropagationCommand
 */
export declare const de_DisableTransitGatewayRouteTablePropagationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableTransitGatewayRouteTablePropagationCommandOutput>;
/**
 * deserializeAws_ec2DisableVgwRoutePropagationCommand
 */
export declare const de_DisableVgwRoutePropagationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableVgwRoutePropagationCommandOutput>;
/**
 * deserializeAws_ec2DisableVpcClassicLinkCommand
 */
export declare const de_DisableVpcClassicLinkCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableVpcClassicLinkCommandOutput>;
/**
 * deserializeAws_ec2DisableVpcClassicLinkDnsSupportCommand
 */
export declare const de_DisableVpcClassicLinkDnsSupportCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableVpcClassicLinkDnsSupportCommandOutput>;
/**
 * deserializeAws_ec2DisassociateAddressCommand
 */
export declare const de_DisassociateAddressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateAddressCommandOutput>;
/**
 * deserializeAws_ec2DisassociateClientVpnTargetNetworkCommand
 */
export declare const de_DisassociateClientVpnTargetNetworkCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateClientVpnTargetNetworkCommandOutput>;
/**
 * deserializeAws_ec2DisassociateEnclaveCertificateIamRoleCommand
 */
export declare const de_DisassociateEnclaveCertificateIamRoleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateEnclaveCertificateIamRoleCommandOutput>;
/**
 * deserializeAws_ec2DisassociateIamInstanceProfileCommand
 */
export declare const de_DisassociateIamInstanceProfileCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateIamInstanceProfileCommandOutput>;
/**
 * deserializeAws_ec2DisassociateInstanceEventWindowCommand
 */
export declare const de_DisassociateInstanceEventWindowCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateInstanceEventWindowCommandOutput>;
/**
 * deserializeAws_ec2DisassociateIpamByoasnCommand
 */
export declare const de_DisassociateIpamByoasnCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateIpamByoasnCommandOutput>;
/**
 * deserializeAws_ec2DisassociateIpamResourceDiscoveryCommand
 */
export declare const de_DisassociateIpamResourceDiscoveryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateIpamResourceDiscoveryCommandOutput>;
/**
 * deserializeAws_ec2DisassociateNatGatewayAddressCommand
 */
export declare const de_DisassociateNatGatewayAddressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateNatGatewayAddressCommandOutput>;
/**
 * deserializeAws_ec2DisassociateRouteTableCommand
 */
export declare const de_DisassociateRouteTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateRouteTableCommandOutput>;
/**
 * deserializeAws_ec2DisassociateSubnetCidrBlockCommand
 */
export declare const de_DisassociateSubnetCidrBlockCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateSubnetCidrBlockCommandOutput>;
/**
 * deserializeAws_ec2DisassociateTransitGatewayMulticastDomainCommand
 */
export declare const de_DisassociateTransitGatewayMulticastDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateTransitGatewayMulticastDomainCommandOutput>;
/**
 * deserializeAws_ec2DisassociateTransitGatewayPolicyTableCommand
 */
export declare const de_DisassociateTransitGatewayPolicyTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateTransitGatewayPolicyTableCommandOutput>;
/**
 * deserializeAws_ec2DisassociateTransitGatewayRouteTableCommand
 */
export declare const de_DisassociateTransitGatewayRouteTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateTransitGatewayRouteTableCommandOutput>;
/**
 * deserializeAws_ec2DisassociateTrunkInterfaceCommand
 */
export declare const de_DisassociateTrunkInterfaceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateTrunkInterfaceCommandOutput>;
/**
 * deserializeAws_ec2DisassociateVpcCidrBlockCommand
 */
export declare const de_DisassociateVpcCidrBlockCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateVpcCidrBlockCommandOutput>;
/**
 * deserializeAws_ec2EnableAddressTransferCommand
 */
export declare const de_EnableAddressTransferCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableAddressTransferCommandOutput>;
/**
 * deserializeAws_ec2EnableAwsNetworkPerformanceMetricSubscriptionCommand
 */
export declare const de_EnableAwsNetworkPerformanceMetricSubscriptionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableAwsNetworkPerformanceMetricSubscriptionCommandOutput>;
/**
 * deserializeAws_ec2EnableEbsEncryptionByDefaultCommand
 */
export declare const de_EnableEbsEncryptionByDefaultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableEbsEncryptionByDefaultCommandOutput>;
/**
 * deserializeAws_ec2EnableFastLaunchCommand
 */
export declare const de_EnableFastLaunchCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableFastLaunchCommandOutput>;
/**
 * deserializeAws_ec2EnableFastSnapshotRestoresCommand
 */
export declare const de_EnableFastSnapshotRestoresCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableFastSnapshotRestoresCommandOutput>;
/**
 * deserializeAws_ec2EnableImageCommand
 */
export declare const de_EnableImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableImageCommandOutput>;
/**
 * deserializeAws_ec2EnableImageBlockPublicAccessCommand
 */
export declare const de_EnableImageBlockPublicAccessCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableImageBlockPublicAccessCommandOutput>;
/**
 * deserializeAws_ec2EnableImageDeprecationCommand
 */
export declare const de_EnableImageDeprecationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableImageDeprecationCommandOutput>;
/**
 * deserializeAws_ec2EnableIpamOrganizationAdminAccountCommand
 */
export declare const de_EnableIpamOrganizationAdminAccountCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableIpamOrganizationAdminAccountCommandOutput>;
/**
 * deserializeAws_ec2EnableReachabilityAnalyzerOrganizationSharingCommand
 */
export declare const de_EnableReachabilityAnalyzerOrganizationSharingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableReachabilityAnalyzerOrganizationSharingCommandOutput>;
/**
 * deserializeAws_ec2EnableSerialConsoleAccessCommand
 */
export declare const de_EnableSerialConsoleAccessCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableSerialConsoleAccessCommandOutput>;
/**
 * deserializeAws_ec2EnableSnapshotBlockPublicAccessCommand
 */
export declare const de_EnableSnapshotBlockPublicAccessCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableSnapshotBlockPublicAccessCommandOutput>;
/**
 * deserializeAws_ec2EnableTransitGatewayRouteTablePropagationCommand
 */
export declare const de_EnableTransitGatewayRouteTablePropagationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableTransitGatewayRouteTablePropagationCommandOutput>;
/**
 * deserializeAws_ec2EnableVgwRoutePropagationCommand
 */
export declare const de_EnableVgwRoutePropagationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableVgwRoutePropagationCommandOutput>;
/**
 * deserializeAws_ec2EnableVolumeIOCommand
 */
export declare const de_EnableVolumeIOCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableVolumeIOCommandOutput>;
/**
 * deserializeAws_ec2EnableVpcClassicLinkCommand
 */
export declare const de_EnableVpcClassicLinkCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableVpcClassicLinkCommandOutput>;
/**
 * deserializeAws_ec2EnableVpcClassicLinkDnsSupportCommand
 */
export declare const de_EnableVpcClassicLinkDnsSupportCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableVpcClassicLinkDnsSupportCommandOutput>;
/**
 * deserializeAws_ec2ExportClientVpnClientCertificateRevocationListCommand
 */
export declare const de_ExportClientVpnClientCertificateRevocationListCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ExportClientVpnClientCertificateRevocationListCommandOutput>;
/**
 * deserializeAws_ec2ExportClientVpnClientConfigurationCommand
 */
export declare const de_ExportClientVpnClientConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ExportClientVpnClientConfigurationCommandOutput>;
/**
 * deserializeAws_ec2ExportImageCommand
 */
export declare const de_ExportImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ExportImageCommandOutput>;
/**
 * deserializeAws_ec2ExportTransitGatewayRoutesCommand
 */
export declare const de_ExportTransitGatewayRoutesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ExportTransitGatewayRoutesCommandOutput>;
/**
 * deserializeAws_ec2GetAssociatedEnclaveCertificateIamRolesCommand
 */
export declare const de_GetAssociatedEnclaveCertificateIamRolesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetAssociatedEnclaveCertificateIamRolesCommandOutput>;
/**
 * deserializeAws_ec2GetAssociatedIpv6PoolCidrsCommand
 */
export declare const de_GetAssociatedIpv6PoolCidrsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetAssociatedIpv6PoolCidrsCommandOutput>;
/**
 * deserializeAws_ec2GetAwsNetworkPerformanceDataCommand
 */
export declare const de_GetAwsNetworkPerformanceDataCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetAwsNetworkPerformanceDataCommandOutput>;
/**
 * deserializeAws_ec2GetCapacityReservationUsageCommand
 */
export declare const de_GetCapacityReservationUsageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCapacityReservationUsageCommandOutput>;
/**
 * deserializeAws_ec2GetCoipPoolUsageCommand
 */
export declare const de_GetCoipPoolUsageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCoipPoolUsageCommandOutput>;
/**
 * deserializeAws_ec2GetConsoleOutputCommand
 */
export declare const de_GetConsoleOutputCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetConsoleOutputCommandOutput>;
/**
 * deserializeAws_ec2GetConsoleScreenshotCommand
 */
export declare const de_GetConsoleScreenshotCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetConsoleScreenshotCommandOutput>;
/**
 * deserializeAws_ec2GetDefaultCreditSpecificationCommand
 */
export declare const de_GetDefaultCreditSpecificationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDefaultCreditSpecificationCommandOutput>;
/**
 * deserializeAws_ec2GetEbsDefaultKmsKeyIdCommand
 */
export declare const de_GetEbsDefaultKmsKeyIdCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetEbsDefaultKmsKeyIdCommandOutput>;
/**
 * deserializeAws_ec2GetEbsEncryptionByDefaultCommand
 */
export declare const de_GetEbsEncryptionByDefaultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetEbsEncryptionByDefaultCommandOutput>;
/**
 * deserializeAws_ec2GetFlowLogsIntegrationTemplateCommand
 */
export declare const de_GetFlowLogsIntegrationTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetFlowLogsIntegrationTemplateCommandOutput>;
/**
 * deserializeAws_ec2GetGroupsForCapacityReservationCommand
 */
export declare const de_GetGroupsForCapacityReservationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetGroupsForCapacityReservationCommandOutput>;
/**
 * deserializeAws_ec2GetHostReservationPurchasePreviewCommand
 */
export declare const de_GetHostReservationPurchasePreviewCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetHostReservationPurchasePreviewCommandOutput>;
/**
 * deserializeAws_ec2GetImageBlockPublicAccessStateCommand
 */
export declare const de_GetImageBlockPublicAccessStateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetImageBlockPublicAccessStateCommandOutput>;
/**
 * deserializeAws_ec2GetInstanceMetadataDefaultsCommand
 */
export declare const de_GetInstanceMetadataDefaultsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetInstanceMetadataDefaultsCommandOutput>;
/**
 * deserializeAws_ec2GetInstanceTypesFromInstanceRequirementsCommand
 */
export declare const de_GetInstanceTypesFromInstanceRequirementsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetInstanceTypesFromInstanceRequirementsCommandOutput>;
/**
 * deserializeAws_ec2GetInstanceUefiDataCommand
 */
export declare const de_GetInstanceUefiDataCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetInstanceUefiDataCommandOutput>;
/**
 * deserializeAws_ec2GetIpamAddressHistoryCommand
 */
export declare const de_GetIpamAddressHistoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetIpamAddressHistoryCommandOutput>;
/**
 * deserializeAws_ec2GetIpamDiscoveredAccountsCommand
 */
export declare const de_GetIpamDiscoveredAccountsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetIpamDiscoveredAccountsCommandOutput>;
/**
 * deserializeAws_ec2GetIpamDiscoveredPublicAddressesCommand
 */
export declare const de_GetIpamDiscoveredPublicAddressesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetIpamDiscoveredPublicAddressesCommandOutput>;
/**
 * deserializeAws_ec2GetIpamDiscoveredResourceCidrsCommand
 */
export declare const de_GetIpamDiscoveredResourceCidrsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetIpamDiscoveredResourceCidrsCommandOutput>;
/**
 * deserializeAws_ec2GetIpamPoolAllocationsCommand
 */
export declare const de_GetIpamPoolAllocationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetIpamPoolAllocationsCommandOutput>;
/**
 * deserializeAws_ec2GetIpamPoolCidrsCommand
 */
export declare const de_GetIpamPoolCidrsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetIpamPoolCidrsCommandOutput>;
/**
 * deserializeAws_ec2GetIpamResourceCidrsCommand
 */
export declare const de_GetIpamResourceCidrsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetIpamResourceCidrsCommandOutput>;
/**
 * deserializeAws_ec2GetLaunchTemplateDataCommand
 */
export declare const de_GetLaunchTemplateDataCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetLaunchTemplateDataCommandOutput>;
/**
 * deserializeAws_ec2GetManagedPrefixListAssociationsCommand
 */
export declare const de_GetManagedPrefixListAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetManagedPrefixListAssociationsCommandOutput>;
/**
 * deserializeAws_ec2GetManagedPrefixListEntriesCommand
 */
export declare const de_GetManagedPrefixListEntriesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetManagedPrefixListEntriesCommandOutput>;
/**
 * deserializeAws_ec2GetNetworkInsightsAccessScopeAnalysisFindingsCommand
 */
export declare const de_GetNetworkInsightsAccessScopeAnalysisFindingsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetNetworkInsightsAccessScopeAnalysisFindingsCommandOutput>;
/**
 * deserializeAws_ec2GetNetworkInsightsAccessScopeContentCommand
 */
export declare const de_GetNetworkInsightsAccessScopeContentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetNetworkInsightsAccessScopeContentCommandOutput>;
/**
 * deserializeAws_ec2GetPasswordDataCommand
 */
export declare const de_GetPasswordDataCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPasswordDataCommandOutput>;
/**
 * deserializeAws_ec2GetReservedInstancesExchangeQuoteCommand
 */
export declare const de_GetReservedInstancesExchangeQuoteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetReservedInstancesExchangeQuoteCommandOutput>;
/**
 * deserializeAws_ec2GetSecurityGroupsForVpcCommand
 */
export declare const de_GetSecurityGroupsForVpcCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetSecurityGroupsForVpcCommandOutput>;
/**
 * deserializeAws_ec2GetSerialConsoleAccessStatusCommand
 */
export declare const de_GetSerialConsoleAccessStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetSerialConsoleAccessStatusCommandOutput>;
/**
 * deserializeAws_ec2GetSnapshotBlockPublicAccessStateCommand
 */
export declare const de_GetSnapshotBlockPublicAccessStateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetSnapshotBlockPublicAccessStateCommandOutput>;
/**
 * deserializeAws_ec2GetSpotPlacementScoresCommand
 */
export declare const de_GetSpotPlacementScoresCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetSpotPlacementScoresCommandOutput>;
/**
 * deserializeAws_ec2GetSubnetCidrReservationsCommand
 */
export declare const de_GetSubnetCidrReservationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetSubnetCidrReservationsCommandOutput>;
/**
 * deserializeAws_ec2GetTransitGatewayAttachmentPropagationsCommand
 */
export declare const de_GetTransitGatewayAttachmentPropagationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetTransitGatewayAttachmentPropagationsCommandOutput>;
/**
 * deserializeAws_ec2GetTransitGatewayMulticastDomainAssociationsCommand
 */
export declare const de_GetTransitGatewayMulticastDomainAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetTransitGatewayMulticastDomainAssociationsCommandOutput>;
/**
 * deserializeAws_ec2GetTransitGatewayPolicyTableAssociationsCommand
 */
export declare const de_GetTransitGatewayPolicyTableAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetTransitGatewayPolicyTableAssociationsCommandOutput>;
/**
 * deserializeAws_ec2GetTransitGatewayPolicyTableEntriesCommand
 */
export declare const de_GetTransitGatewayPolicyTableEntriesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetTransitGatewayPolicyTableEntriesCommandOutput>;
/**
 * deserializeAws_ec2GetTransitGatewayPrefixListReferencesCommand
 */
export declare const de_GetTransitGatewayPrefixListReferencesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetTransitGatewayPrefixListReferencesCommandOutput>;
/**
 * deserializeAws_ec2GetTransitGatewayRouteTableAssociationsCommand
 */
export declare const de_GetTransitGatewayRouteTableAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetTransitGatewayRouteTableAssociationsCommandOutput>;
/**
 * deserializeAws_ec2GetTransitGatewayRouteTablePropagationsCommand
 */
export declare const de_GetTransitGatewayRouteTablePropagationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetTransitGatewayRouteTablePropagationsCommandOutput>;
/**
 * deserializeAws_ec2GetVerifiedAccessEndpointPolicyCommand
 */
export declare const de_GetVerifiedAccessEndpointPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetVerifiedAccessEndpointPolicyCommandOutput>;
/**
 * deserializeAws_ec2GetVerifiedAccessGroupPolicyCommand
 */
export declare const de_GetVerifiedAccessGroupPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetVerifiedAccessGroupPolicyCommandOutput>;
/**
 * deserializeAws_ec2GetVpnConnectionDeviceSampleConfigurationCommand
 */
export declare const de_GetVpnConnectionDeviceSampleConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetVpnConnectionDeviceSampleConfigurationCommandOutput>;
/**
 * deserializeAws_ec2GetVpnConnectionDeviceTypesCommand
 */
export declare const de_GetVpnConnectionDeviceTypesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetVpnConnectionDeviceTypesCommandOutput>;
/**
 * deserializeAws_ec2GetVpnTunnelReplacementStatusCommand
 */
export declare const de_GetVpnTunnelReplacementStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetVpnTunnelReplacementStatusCommandOutput>;
/**
 * deserializeAws_ec2ImportClientVpnClientCertificateRevocationListCommand
 */
export declare const de_ImportClientVpnClientCertificateRevocationListCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ImportClientVpnClientCertificateRevocationListCommandOutput>;
/**
 * deserializeAws_ec2ImportImageCommand
 */
export declare const de_ImportImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ImportImageCommandOutput>;
/**
 * deserializeAws_ec2ImportInstanceCommand
 */
export declare const de_ImportInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ImportInstanceCommandOutput>;
/**
 * deserializeAws_ec2ImportKeyPairCommand
 */
export declare const de_ImportKeyPairCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ImportKeyPairCommandOutput>;
/**
 * deserializeAws_ec2ImportSnapshotCommand
 */
export declare const de_ImportSnapshotCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ImportSnapshotCommandOutput>;
/**
 * deserializeAws_ec2ImportVolumeCommand
 */
export declare const de_ImportVolumeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ImportVolumeCommandOutput>;
/**
 * deserializeAws_ec2ListImagesInRecycleBinCommand
 */
export declare const de_ListImagesInRecycleBinCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListImagesInRecycleBinCommandOutput>;
/**
 * deserializeAws_ec2ListSnapshotsInRecycleBinCommand
 */
export declare const de_ListSnapshotsInRecycleBinCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListSnapshotsInRecycleBinCommandOutput>;
/**
 * deserializeAws_ec2LockSnapshotCommand
 */
export declare const de_LockSnapshotCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<LockSnapshotCommandOutput>;
/**
 * deserializeAws_ec2ModifyAddressAttributeCommand
 */
export declare const de_ModifyAddressAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyAddressAttributeCommandOutput>;
/**
 * deserializeAws_ec2ModifyAvailabilityZoneGroupCommand
 */
export declare const de_ModifyAvailabilityZoneGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyAvailabilityZoneGroupCommandOutput>;
/**
 * deserializeAws_ec2ModifyCapacityReservationCommand
 */
export declare const de_ModifyCapacityReservationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyCapacityReservationCommandOutput>;
/**
 * deserializeAws_ec2ModifyCapacityReservationFleetCommand
 */
export declare const de_ModifyCapacityReservationFleetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyCapacityReservationFleetCommandOutput>;
/**
 * deserializeAws_ec2ModifyClientVpnEndpointCommand
 */
export declare const de_ModifyClientVpnEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyClientVpnEndpointCommandOutput>;
/**
 * deserializeAws_ec2ModifyDefaultCreditSpecificationCommand
 */
export declare const de_ModifyDefaultCreditSpecificationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyDefaultCreditSpecificationCommandOutput>;
/**
 * deserializeAws_ec2ModifyEbsDefaultKmsKeyIdCommand
 */
export declare const de_ModifyEbsDefaultKmsKeyIdCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyEbsDefaultKmsKeyIdCommandOutput>;
/**
 * deserializeAws_ec2ModifyFleetCommand
 */
export declare const de_ModifyFleetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyFleetCommandOutput>;
/**
 * deserializeAws_ec2ModifyFpgaImageAttributeCommand
 */
export declare const de_ModifyFpgaImageAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyFpgaImageAttributeCommandOutput>;
/**
 * deserializeAws_ec2ModifyHostsCommand
 */
export declare const de_ModifyHostsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyHostsCommandOutput>;
/**
 * deserializeAws_ec2ModifyIdentityIdFormatCommand
 */
export declare const de_ModifyIdentityIdFormatCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyIdentityIdFormatCommandOutput>;
/**
 * deserializeAws_ec2ModifyIdFormatCommand
 */
export declare const de_ModifyIdFormatCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyIdFormatCommandOutput>;
/**
 * deserializeAws_ec2ModifyImageAttributeCommand
 */
export declare const de_ModifyImageAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyImageAttributeCommandOutput>;
/**
 * deserializeAws_ec2ModifyInstanceAttributeCommand
 */
export declare const de_ModifyInstanceAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyInstanceAttributeCommandOutput>;
/**
 * deserializeAws_ec2ModifyInstanceCapacityReservationAttributesCommand
 */
export declare const de_ModifyInstanceCapacityReservationAttributesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyInstanceCapacityReservationAttributesCommandOutput>;
/**
 * deserializeAws_ec2ModifyInstanceCreditSpecificationCommand
 */
export declare const de_ModifyInstanceCreditSpecificationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyInstanceCreditSpecificationCommandOutput>;
/**
 * deserializeAws_ec2ModifyInstanceEventStartTimeCommand
 */
export declare const de_ModifyInstanceEventStartTimeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyInstanceEventStartTimeCommandOutput>;
/**
 * deserializeAws_ec2ModifyInstanceEventWindowCommand
 */
export declare const de_ModifyInstanceEventWindowCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyInstanceEventWindowCommandOutput>;
/**
 * deserializeAws_ec2ModifyInstanceMaintenanceOptionsCommand
 */
export declare const de_ModifyInstanceMaintenanceOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyInstanceMaintenanceOptionsCommandOutput>;
/**
 * deserializeAws_ec2ModifyInstanceMetadataDefaultsCommand
 */
export declare const de_ModifyInstanceMetadataDefaultsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyInstanceMetadataDefaultsCommandOutput>;
/**
 * deserializeAws_ec2ModifyInstanceMetadataOptionsCommand
 */
export declare const de_ModifyInstanceMetadataOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyInstanceMetadataOptionsCommandOutput>;
/**
 * deserializeAws_ec2ModifyInstancePlacementCommand
 */
export declare const de_ModifyInstancePlacementCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyInstancePlacementCommandOutput>;
/**
 * deserializeAws_ec2ModifyIpamCommand
 */
export declare const de_ModifyIpamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyIpamCommandOutput>;
/**
 * deserializeAws_ec2ModifyIpamPoolCommand
 */
export declare const de_ModifyIpamPoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyIpamPoolCommandOutput>;
/**
 * deserializeAws_ec2ModifyIpamResourceCidrCommand
 */
export declare const de_ModifyIpamResourceCidrCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyIpamResourceCidrCommandOutput>;
/**
 * deserializeAws_ec2ModifyIpamResourceDiscoveryCommand
 */
export declare const de_ModifyIpamResourceDiscoveryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyIpamResourceDiscoveryCommandOutput>;
/**
 * deserializeAws_ec2ModifyIpamScopeCommand
 */
export declare const de_ModifyIpamScopeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyIpamScopeCommandOutput>;
/**
 * deserializeAws_ec2ModifyLaunchTemplateCommand
 */
export declare const de_ModifyLaunchTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyLaunchTemplateCommandOutput>;
/**
 * deserializeAws_ec2ModifyLocalGatewayRouteCommand
 */
export declare const de_ModifyLocalGatewayRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyLocalGatewayRouteCommandOutput>;
/**
 * deserializeAws_ec2ModifyManagedPrefixListCommand
 */
export declare const de_ModifyManagedPrefixListCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyManagedPrefixListCommandOutput>;
/**
 * deserializeAws_ec2ModifyNetworkInterfaceAttributeCommand
 */
export declare const de_ModifyNetworkInterfaceAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyNetworkInterfaceAttributeCommandOutput>;
/**
 * deserializeAws_ec2ModifyPrivateDnsNameOptionsCommand
 */
export declare const de_ModifyPrivateDnsNameOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyPrivateDnsNameOptionsCommandOutput>;
/**
 * deserializeAws_ec2ModifyReservedInstancesCommand
 */
export declare const de_ModifyReservedInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyReservedInstancesCommandOutput>;
/**
 * deserializeAws_ec2ModifySecurityGroupRulesCommand
 */
export declare const de_ModifySecurityGroupRulesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifySecurityGroupRulesCommandOutput>;
/**
 * deserializeAws_ec2ModifySnapshotAttributeCommand
 */
export declare const de_ModifySnapshotAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifySnapshotAttributeCommandOutput>;
/**
 * deserializeAws_ec2ModifySnapshotTierCommand
 */
export declare const de_ModifySnapshotTierCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifySnapshotTierCommandOutput>;
/**
 * deserializeAws_ec2ModifySpotFleetRequestCommand
 */
export declare const de_ModifySpotFleetRequestCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifySpotFleetRequestCommandOutput>;
/**
 * deserializeAws_ec2ModifySubnetAttributeCommand
 */
export declare const de_ModifySubnetAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifySubnetAttributeCommandOutput>;
/**
 * deserializeAws_ec2ModifyTrafficMirrorFilterNetworkServicesCommand
 */
export declare const de_ModifyTrafficMirrorFilterNetworkServicesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyTrafficMirrorFilterNetworkServicesCommandOutput>;
/**
 * deserializeAws_ec2ModifyTrafficMirrorFilterRuleCommand
 */
export declare const de_ModifyTrafficMirrorFilterRuleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyTrafficMirrorFilterRuleCommandOutput>;
/**
 * deserializeAws_ec2ModifyTrafficMirrorSessionCommand
 */
export declare const de_ModifyTrafficMirrorSessionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyTrafficMirrorSessionCommandOutput>;
/**
 * deserializeAws_ec2ModifyTransitGatewayCommand
 */
export declare const de_ModifyTransitGatewayCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyTransitGatewayCommandOutput>;
/**
 * deserializeAws_ec2ModifyTransitGatewayPrefixListReferenceCommand
 */
export declare const de_ModifyTransitGatewayPrefixListReferenceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyTransitGatewayPrefixListReferenceCommandOutput>;
/**
 * deserializeAws_ec2ModifyTransitGatewayVpcAttachmentCommand
 */
export declare const de_ModifyTransitGatewayVpcAttachmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyTransitGatewayVpcAttachmentCommandOutput>;
/**
 * deserializeAws_ec2ModifyVerifiedAccessEndpointCommand
 */
export declare const de_ModifyVerifiedAccessEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVerifiedAccessEndpointCommandOutput>;
/**
 * deserializeAws_ec2ModifyVerifiedAccessEndpointPolicyCommand
 */
export declare const de_ModifyVerifiedAccessEndpointPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVerifiedAccessEndpointPolicyCommandOutput>;
/**
 * deserializeAws_ec2ModifyVerifiedAccessGroupCommand
 */
export declare const de_ModifyVerifiedAccessGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVerifiedAccessGroupCommandOutput>;
/**
 * deserializeAws_ec2ModifyVerifiedAccessGroupPolicyCommand
 */
export declare const de_ModifyVerifiedAccessGroupPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVerifiedAccessGroupPolicyCommandOutput>;
/**
 * deserializeAws_ec2ModifyVerifiedAccessInstanceCommand
 */
export declare const de_ModifyVerifiedAccessInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVerifiedAccessInstanceCommandOutput>;
/**
 * deserializeAws_ec2ModifyVerifiedAccessInstanceLoggingConfigurationCommand
 */
export declare const de_ModifyVerifiedAccessInstanceLoggingConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVerifiedAccessInstanceLoggingConfigurationCommandOutput>;
/**
 * deserializeAws_ec2ModifyVerifiedAccessTrustProviderCommand
 */
export declare const de_ModifyVerifiedAccessTrustProviderCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVerifiedAccessTrustProviderCommandOutput>;
/**
 * deserializeAws_ec2ModifyVolumeCommand
 */
export declare const de_ModifyVolumeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVolumeCommandOutput>;
/**
 * deserializeAws_ec2ModifyVolumeAttributeCommand
 */
export declare const de_ModifyVolumeAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVolumeAttributeCommandOutput>;
/**
 * deserializeAws_ec2ModifyVpcAttributeCommand
 */
export declare const de_ModifyVpcAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVpcAttributeCommandOutput>;
/**
 * deserializeAws_ec2ModifyVpcEndpointCommand
 */
export declare const de_ModifyVpcEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVpcEndpointCommandOutput>;
/**
 * deserializeAws_ec2ModifyVpcEndpointConnectionNotificationCommand
 */
export declare const de_ModifyVpcEndpointConnectionNotificationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVpcEndpointConnectionNotificationCommandOutput>;
/**
 * deserializeAws_ec2ModifyVpcEndpointServiceConfigurationCommand
 */
export declare const de_ModifyVpcEndpointServiceConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVpcEndpointServiceConfigurationCommandOutput>;
/**
 * deserializeAws_ec2ModifyVpcEndpointServicePayerResponsibilityCommand
 */
export declare const de_ModifyVpcEndpointServicePayerResponsibilityCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVpcEndpointServicePayerResponsibilityCommandOutput>;
/**
 * deserializeAws_ec2ModifyVpcEndpointServicePermissionsCommand
 */
export declare const de_ModifyVpcEndpointServicePermissionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVpcEndpointServicePermissionsCommandOutput>;
/**
 * deserializeAws_ec2ModifyVpcPeeringConnectionOptionsCommand
 */
export declare const de_ModifyVpcPeeringConnectionOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVpcPeeringConnectionOptionsCommandOutput>;
/**
 * deserializeAws_ec2ModifyVpcTenancyCommand
 */
export declare const de_ModifyVpcTenancyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVpcTenancyCommandOutput>;
/**
 * deserializeAws_ec2ModifyVpnConnectionCommand
 */
export declare const de_ModifyVpnConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVpnConnectionCommandOutput>;
/**
 * deserializeAws_ec2ModifyVpnConnectionOptionsCommand
 */
export declare const de_ModifyVpnConnectionOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVpnConnectionOptionsCommandOutput>;
/**
 * deserializeAws_ec2ModifyVpnTunnelCertificateCommand
 */
export declare const de_ModifyVpnTunnelCertificateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVpnTunnelCertificateCommandOutput>;
/**
 * deserializeAws_ec2ModifyVpnTunnelOptionsCommand
 */
export declare const de_ModifyVpnTunnelOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ModifyVpnTunnelOptionsCommandOutput>;
/**
 * deserializeAws_ec2MonitorInstancesCommand
 */
export declare const de_MonitorInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<MonitorInstancesCommandOutput>;
/**
 * deserializeAws_ec2MoveAddressToVpcCommand
 */
export declare const de_MoveAddressToVpcCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<MoveAddressToVpcCommandOutput>;
/**
 * deserializeAws_ec2MoveByoipCidrToIpamCommand
 */
export declare const de_MoveByoipCidrToIpamCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<MoveByoipCidrToIpamCommandOutput>;
/**
 * deserializeAws_ec2ProvisionByoipCidrCommand
 */
export declare const de_ProvisionByoipCidrCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ProvisionByoipCidrCommandOutput>;
/**
 * deserializeAws_ec2ProvisionIpamByoasnCommand
 */
export declare const de_ProvisionIpamByoasnCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ProvisionIpamByoasnCommandOutput>;
/**
 * deserializeAws_ec2ProvisionIpamPoolCidrCommand
 */
export declare const de_ProvisionIpamPoolCidrCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ProvisionIpamPoolCidrCommandOutput>;
/**
 * deserializeAws_ec2ProvisionPublicIpv4PoolCidrCommand
 */
export declare const de_ProvisionPublicIpv4PoolCidrCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ProvisionPublicIpv4PoolCidrCommandOutput>;
/**
 * deserializeAws_ec2PurchaseCapacityBlockCommand
 */
export declare const de_PurchaseCapacityBlockCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PurchaseCapacityBlockCommandOutput>;
/**
 * deserializeAws_ec2PurchaseHostReservationCommand
 */
export declare const de_PurchaseHostReservationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PurchaseHostReservationCommandOutput>;
/**
 * deserializeAws_ec2PurchaseReservedInstancesOfferingCommand
 */
export declare const de_PurchaseReservedInstancesOfferingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PurchaseReservedInstancesOfferingCommandOutput>;
/**
 * deserializeAws_ec2PurchaseScheduledInstancesCommand
 */
export declare const de_PurchaseScheduledInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PurchaseScheduledInstancesCommandOutput>;
/**
 * deserializeAws_ec2RebootInstancesCommand
 */
export declare const de_RebootInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RebootInstancesCommandOutput>;
/**
 * deserializeAws_ec2RegisterImageCommand
 */
export declare const de_RegisterImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RegisterImageCommandOutput>;
/**
 * deserializeAws_ec2RegisterInstanceEventNotificationAttributesCommand
 */
export declare const de_RegisterInstanceEventNotificationAttributesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RegisterInstanceEventNotificationAttributesCommandOutput>;
/**
 * deserializeAws_ec2RegisterTransitGatewayMulticastGroupMembersCommand
 */
export declare const de_RegisterTransitGatewayMulticastGroupMembersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RegisterTransitGatewayMulticastGroupMembersCommandOutput>;
/**
 * deserializeAws_ec2RegisterTransitGatewayMulticastGroupSourcesCommand
 */
export declare const de_RegisterTransitGatewayMulticastGroupSourcesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RegisterTransitGatewayMulticastGroupSourcesCommandOutput>;
/**
 * deserializeAws_ec2RejectTransitGatewayMulticastDomainAssociationsCommand
 */
export declare const de_RejectTransitGatewayMulticastDomainAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RejectTransitGatewayMulticastDomainAssociationsCommandOutput>;
/**
 * deserializeAws_ec2RejectTransitGatewayPeeringAttachmentCommand
 */
export declare const de_RejectTransitGatewayPeeringAttachmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RejectTransitGatewayPeeringAttachmentCommandOutput>;
/**
 * deserializeAws_ec2RejectTransitGatewayVpcAttachmentCommand
 */
export declare const de_RejectTransitGatewayVpcAttachmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RejectTransitGatewayVpcAttachmentCommandOutput>;
/**
 * deserializeAws_ec2RejectVpcEndpointConnectionsCommand
 */
export declare const de_RejectVpcEndpointConnectionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RejectVpcEndpointConnectionsCommandOutput>;
/**
 * deserializeAws_ec2RejectVpcPeeringConnectionCommand
 */
export declare const de_RejectVpcPeeringConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RejectVpcPeeringConnectionCommandOutput>;
/**
 * deserializeAws_ec2ReleaseAddressCommand
 */
export declare const de_ReleaseAddressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ReleaseAddressCommandOutput>;
/**
 * deserializeAws_ec2ReleaseHostsCommand
 */
export declare const de_ReleaseHostsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ReleaseHostsCommandOutput>;
/**
 * deserializeAws_ec2ReleaseIpamPoolAllocationCommand
 */
export declare const de_ReleaseIpamPoolAllocationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ReleaseIpamPoolAllocationCommandOutput>;
/**
 * deserializeAws_ec2ReplaceIamInstanceProfileAssociationCommand
 */
export declare const de_ReplaceIamInstanceProfileAssociationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ReplaceIamInstanceProfileAssociationCommandOutput>;
/**
 * deserializeAws_ec2ReplaceNetworkAclAssociationCommand
 */
export declare const de_ReplaceNetworkAclAssociationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ReplaceNetworkAclAssociationCommandOutput>;
/**
 * deserializeAws_ec2ReplaceNetworkAclEntryCommand
 */
export declare const de_ReplaceNetworkAclEntryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ReplaceNetworkAclEntryCommandOutput>;
/**
 * deserializeAws_ec2ReplaceRouteCommand
 */
export declare const de_ReplaceRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ReplaceRouteCommandOutput>;
/**
 * deserializeAws_ec2ReplaceRouteTableAssociationCommand
 */
export declare const de_ReplaceRouteTableAssociationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ReplaceRouteTableAssociationCommandOutput>;
/**
 * deserializeAws_ec2ReplaceTransitGatewayRouteCommand
 */
export declare const de_ReplaceTransitGatewayRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ReplaceTransitGatewayRouteCommandOutput>;
/**
 * deserializeAws_ec2ReplaceVpnTunnelCommand
 */
export declare const de_ReplaceVpnTunnelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ReplaceVpnTunnelCommandOutput>;
/**
 * deserializeAws_ec2ReportInstanceStatusCommand
 */
export declare const de_ReportInstanceStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ReportInstanceStatusCommandOutput>;
/**
 * deserializeAws_ec2RequestSpotFleetCommand
 */
export declare const de_RequestSpotFleetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RequestSpotFleetCommandOutput>;
/**
 * deserializeAws_ec2RequestSpotInstancesCommand
 */
export declare const de_RequestSpotInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RequestSpotInstancesCommandOutput>;
/**
 * deserializeAws_ec2ResetAddressAttributeCommand
 */
export declare const de_ResetAddressAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ResetAddressAttributeCommandOutput>;
/**
 * deserializeAws_ec2ResetEbsDefaultKmsKeyIdCommand
 */
export declare const de_ResetEbsDefaultKmsKeyIdCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ResetEbsDefaultKmsKeyIdCommandOutput>;
/**
 * deserializeAws_ec2ResetFpgaImageAttributeCommand
 */
export declare const de_ResetFpgaImageAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ResetFpgaImageAttributeCommandOutput>;
/**
 * deserializeAws_ec2ResetImageAttributeCommand
 */
export declare const de_ResetImageAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ResetImageAttributeCommandOutput>;
/**
 * deserializeAws_ec2ResetInstanceAttributeCommand
 */
export declare const de_ResetInstanceAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ResetInstanceAttributeCommandOutput>;
/**
 * deserializeAws_ec2ResetNetworkInterfaceAttributeCommand
 */
export declare const de_ResetNetworkInterfaceAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ResetNetworkInterfaceAttributeCommandOutput>;
/**
 * deserializeAws_ec2ResetSnapshotAttributeCommand
 */
export declare const de_ResetSnapshotAttributeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ResetSnapshotAttributeCommandOutput>;
/**
 * deserializeAws_ec2RestoreAddressToClassicCommand
 */
export declare const de_RestoreAddressToClassicCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RestoreAddressToClassicCommandOutput>;
/**
 * deserializeAws_ec2RestoreImageFromRecycleBinCommand
 */
export declare const de_RestoreImageFromRecycleBinCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RestoreImageFromRecycleBinCommandOutput>;
/**
 * deserializeAws_ec2RestoreManagedPrefixListVersionCommand
 */
export declare const de_RestoreManagedPrefixListVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RestoreManagedPrefixListVersionCommandOutput>;
/**
 * deserializeAws_ec2RestoreSnapshotFromRecycleBinCommand
 */
export declare const de_RestoreSnapshotFromRecycleBinCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RestoreSnapshotFromRecycleBinCommandOutput>;
/**
 * deserializeAws_ec2RestoreSnapshotTierCommand
 */
export declare const de_RestoreSnapshotTierCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RestoreSnapshotTierCommandOutput>;
/**
 * deserializeAws_ec2RevokeClientVpnIngressCommand
 */
export declare const de_RevokeClientVpnIngressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RevokeClientVpnIngressCommandOutput>;
/**
 * deserializeAws_ec2RevokeSecurityGroupEgressCommand
 */
export declare const de_RevokeSecurityGroupEgressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RevokeSecurityGroupEgressCommandOutput>;
/**
 * deserializeAws_ec2RevokeSecurityGroupIngressCommand
 */
export declare const de_RevokeSecurityGroupIngressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RevokeSecurityGroupIngressCommandOutput>;
/**
 * deserializeAws_ec2RunInstancesCommand
 */
export declare const de_RunInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RunInstancesCommandOutput>;
/**
 * deserializeAws_ec2RunScheduledInstancesCommand
 */
export declare const de_RunScheduledInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RunScheduledInstancesCommandOutput>;
/**
 * deserializeAws_ec2SearchLocalGatewayRoutesCommand
 */
export declare const de_SearchLocalGatewayRoutesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SearchLocalGatewayRoutesCommandOutput>;
/**
 * deserializeAws_ec2SearchTransitGatewayMulticastGroupsCommand
 */
export declare const de_SearchTransitGatewayMulticastGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SearchTransitGatewayMulticastGroupsCommandOutput>;
/**
 * deserializeAws_ec2SearchTransitGatewayRoutesCommand
 */
export declare const de_SearchTransitGatewayRoutesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SearchTransitGatewayRoutesCommandOutput>;
/**
 * deserializeAws_ec2SendDiagnosticInterruptCommand
 */
export declare const de_SendDiagnosticInterruptCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SendDiagnosticInterruptCommandOutput>;
/**
 * deserializeAws_ec2StartInstancesCommand
 */
export declare const de_StartInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartInstancesCommandOutput>;
/**
 * deserializeAws_ec2StartNetworkInsightsAccessScopeAnalysisCommand
 */
export declare const de_StartNetworkInsightsAccessScopeAnalysisCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartNetworkInsightsAccessScopeAnalysisCommandOutput>;
/**
 * deserializeAws_ec2StartNetworkInsightsAnalysisCommand
 */
export declare const de_StartNetworkInsightsAnalysisCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartNetworkInsightsAnalysisCommandOutput>;
/**
 * deserializeAws_ec2StartVpcEndpointServicePrivateDnsVerificationCommand
 */
export declare const de_StartVpcEndpointServicePrivateDnsVerificationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartVpcEndpointServicePrivateDnsVerificationCommandOutput>;
/**
 * deserializeAws_ec2StopInstancesCommand
 */
export declare const de_StopInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopInstancesCommandOutput>;
/**
 * deserializeAws_ec2TerminateClientVpnConnectionsCommand
 */
export declare const de_TerminateClientVpnConnectionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TerminateClientVpnConnectionsCommandOutput>;
/**
 * deserializeAws_ec2TerminateInstancesCommand
 */
export declare const de_TerminateInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TerminateInstancesCommandOutput>;
/**
 * deserializeAws_ec2UnassignIpv6AddressesCommand
 */
export declare const de_UnassignIpv6AddressesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UnassignIpv6AddressesCommandOutput>;
/**
 * deserializeAws_ec2UnassignPrivateIpAddressesCommand
 */
export declare const de_UnassignPrivateIpAddressesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UnassignPrivateIpAddressesCommandOutput>;
/**
 * deserializeAws_ec2UnassignPrivateNatGatewayAddressCommand
 */
export declare const de_UnassignPrivateNatGatewayAddressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UnassignPrivateNatGatewayAddressCommandOutput>;
/**
 * deserializeAws_ec2UnlockSnapshotCommand
 */
export declare const de_UnlockSnapshotCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UnlockSnapshotCommandOutput>;
/**
 * deserializeAws_ec2UnmonitorInstancesCommand
 */
export declare const de_UnmonitorInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UnmonitorInstancesCommandOutput>;
/**
 * deserializeAws_ec2UpdateSecurityGroupRuleDescriptionsEgressCommand
 */
export declare const de_UpdateSecurityGroupRuleDescriptionsEgressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateSecurityGroupRuleDescriptionsEgressCommandOutput>;
/**
 * deserializeAws_ec2UpdateSecurityGroupRuleDescriptionsIngressCommand
 */
export declare const de_UpdateSecurityGroupRuleDescriptionsIngressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateSecurityGroupRuleDescriptionsIngressCommandOutput>;
/**
 * deserializeAws_ec2WithdrawByoipCidrCommand
 */
export declare const de_WithdrawByoipCidrCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<WithdrawByoipCidrCommandOutput>;
